/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc/config/loongarch/loongarch.md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "emit-rtl.h"
#include "tm-constrs.h"
#include "target.h"


struct target_constraints default_target_constraints;
#if SWITCHABLE_TARGET
struct target_constraints *this_target_constraints = &default_target_constraints;
#endif
static inline bool
aligned_register_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 25 "../../gcc/common.md"
{
  /* Require the offset in a non-paradoxical subreg to be naturally aligned.
     For example, if we have a subreg of something that is double the size of
     this operand, the offset must select the first or second half of it.  */
  if (SUBREG_P (op)
      && multiple_p (SUBREG_BYTE (op), GET_MODE_SIZE (GET_MODE (op))))
    op = SUBREG_REG (op);
  if (!REG_P (op))
    return false;

  if (HARD_REGISTER_P (op))
    {
      if (!in_hard_reg_set_p (operand_reg_set, GET_MODE (op), REGNO (op)))
	return false;

      /* Reject hard registers that would need reloading, so that the reload
	 is visible to IRA and to pre-RA optimizers.  */
      if (REGNO (op) % REG_NREGS (op) != 0)
	return false;
    }
  return true;
}

bool
aligned_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case REG:
    case SUBREG:
      break;
    default:
      return false;
    }
  return (
(aligned_register_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
const_uns_arith_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 24 "../../gcc/config/loongarch/predicates.md"
(IMM12_OPERAND_UNSIGNED (INTVAL (op))));
}

bool
uns_arith_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (const_uns_arith_operand (op, mode)) || (register_operand (op, mode));
}

bool
const_lu32i_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 32 "../../gcc/config/loongarch/predicates.md"
(LU32I_OPERAND (INTVAL (op))));
}

bool
const_lu52i_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 36 "../../gcc/config/loongarch/predicates.md"
(LU52I_OPERAND (INTVAL (op))));
}

bool
const_arith_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 40 "../../gcc/config/loongarch/predicates.md"
(IMM12_OPERAND (INTVAL (op))));
}

bool
const_dual_imm12_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 44 "../../gcc/config/loongarch/predicates.md"
(DUAL_IMM12_OPERAND (INTVAL (op))));
}

bool
const_imm16_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 48 "../../gcc/config/loongarch/predicates.md"
(IMM16_OPERAND (INTVAL (op))));
}

bool
const_addu16i_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 52 "../../gcc/config/loongarch/predicates.md"
(ADDU16I_OPERAND (INTVAL (op))));
}

bool
const_addu16i_imm12_di_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 56 "../../gcc/config/loongarch/predicates.md"
(loongarch_addu16i_imm12_operand_p (INTVAL (op), DImode)));
}

bool
const_addu16i_imm12_si_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 60 "../../gcc/config/loongarch/predicates.md"
(loongarch_addu16i_imm12_operand_p (INTVAL (op), SImode)));
}

bool
const_dual_addu16i_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 64 "../../gcc/config/loongarch/predicates.md"
(DUAL_ADDU16I_OPERAND (INTVAL (op))));
}

bool
arith_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (const_arith_operand (op, mode)) || (register_operand (op, mode));
}

bool
plus_di_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (arith_operand (op, mode)) || ((const_dual_imm12_operand (op, mode)) || ((const_addu16i_operand (op, mode)) || ((const_addu16i_imm12_di_operand (op, mode)) || (const_dual_addu16i_operand (op, mode)))));
}

bool
plus_si_extend_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (arith_operand (op, mode)) || ((const_dual_imm12_operand (op, mode)) || (const_addu16i_imm12_si_operand (op, mode)));
}

bool
plus_si_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (plus_si_extend_operand (op, mode)) || (const_addu16i_operand (op, mode));
}

bool
const_immalsl_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 88 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 1, 4)));
}

bool
const_lsx_branch_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 92 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), -1024, 1023)));
}

bool
const_uimm3_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 96 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 0, 7)));
}

bool
const_8_to_11_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 100 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 8, 11)));
}

bool
const_12_to_15_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 104 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 12, 15)));
}

bool
const_uimm4_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 108 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 0, 15)));
}

bool
const_uimm5_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 112 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 0, 31)));
}

bool
const_uimm6_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 116 "../../gcc/config/loongarch/predicates.md"
(UIMM6_OPERAND (INTVAL (op))));
}

bool
const_uimm7_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 120 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 0, 127)));
}

bool
const_uimm8_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 124 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 0, 255)));
}

bool
const_uimm14_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 128 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 0, 16383)));
}

bool
const_uimm15_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 132 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 0, 32767)));
}

bool
const_imm5_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 136 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), -16, 15)));
}

bool
const_imm10_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 140 "../../gcc/config/loongarch/predicates.md"
(IMM10_OPERAND (INTVAL (op))));
}

bool
const_imm12_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 144 "../../gcc/config/loongarch/predicates.md"
(IMM12_OPERAND (INTVAL (op))));
}

bool
const_imm13_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 148 "../../gcc/config/loongarch/predicates.md"
(IMM13_OPERAND (INTVAL (op))));
}

bool
reg_imm10_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (const_imm10_operand (op, mode)) || (register_operand (op, mode));
}

bool
aq8b_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 156 "../../gcc/config/loongarch/predicates.md"
(loongarch_signed_immediate_p (INTVAL (op), 8, 0)));
}

bool
aq8h_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 160 "../../gcc/config/loongarch/predicates.md"
(loongarch_signed_immediate_p (INTVAL (op), 8, 1)));
}

bool
aq8w_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 164 "../../gcc/config/loongarch/predicates.md"
(loongarch_signed_immediate_p (INTVAL (op), 8, 2)));
}

bool
aq8d_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 168 "../../gcc/config/loongarch/predicates.md"
(loongarch_signed_immediate_p (INTVAL (op), 8, 3)));
}

bool
aq12b_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 172 "../../gcc/config/loongarch/predicates.md"
(loongarch_signed_immediate_p (INTVAL (op), 12, 0)));
}

bool
aq12h_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 176 "../../gcc/config/loongarch/predicates.md"
(loongarch_signed_immediate_p (INTVAL (op), 11, 1)));
}

bool
aq12w_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 180 "../../gcc/config/loongarch/predicates.md"
(loongarch_signed_immediate_p (INTVAL (op), 10, 2)));
}

bool
aq12d_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 184 "../../gcc/config/loongarch/predicates.md"
(loongarch_signed_immediate_p (INTVAL (op), 9, 3)));
}

bool
sle_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 188 "../../gcc/config/loongarch/predicates.md"
(IMM12_OPERAND (INTVAL (op) + 1)));
}

bool
sleu_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (sle_operand (op, mode)) && (
#line 192 "../../gcc/config/loongarch/predicates.md"
(INTVAL (op) + 1 != 0));
}

bool
const_0_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      break;
    default:
      return false;
    }
  return (
#line 196 "../../gcc/config/loongarch/predicates.md"
(op == CONST0_RTX (GET_MODE (op)))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

bool
const_m1_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      break;
    default:
      return false;
    }
  return (
#line 200 "../../gcc/config/loongarch/predicates.md"
(op == CONSTM1_RTX (GET_MODE (op)))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

bool
reg_or_m1_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (const_m1_operand (op, mode)) || (register_operand (op, mode));
}

bool
reg_or_0_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (const_0_operand (op, mode)) || (register_operand (op, mode));
}

bool
const_1_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      break;
    default:
      return false;
    }
  return (
#line 212 "../../gcc/config/loongarch/predicates.md"
(op == CONST1_RTX (GET_MODE (op)))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

bool
const_vector_1_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == CONST_VECTOR) && (
#line 216 "../../gcc/config/loongarch/predicates.md"
(op == CONST1_RTX (GET_MODE (op))))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
reg_or_1_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (const_1_operand (op, mode)) || (register_operand (op, mode));
}

bool
reg_or_vecotr_1_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (const_vector_1_operand (op, mode)) || (register_operand (op, mode));
}

bool
const_exp_2_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 229 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (exact_log2 (INTVAL (op)), 0, 1)));
}

bool
const_exp_4_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 233 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (exact_log2 (INTVAL (op)), 0, 3)));
}

bool
const_exp_8_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 237 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (exact_log2 (INTVAL (op)), 0, 7)));
}

bool
const_exp_16_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 241 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (exact_log2 (INTVAL (op)), 0, 15)));
}

bool
const_exp_32_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 245 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (exact_log2 (INTVAL (op)), 0, 31)));
}

bool
const_0_or_1_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 250 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 0, 1)));
}

bool
const_0_to_3_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 254 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 0, 3)));
}

bool
const_0_to_7_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 258 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 0, 7)));
}

bool
const_2_or_3_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 262 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 2, 3)));
}

bool
const_4_to_7_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 266 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 4, 7)));
}

bool
const_8_to_15_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 270 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 8, 15)));
}

bool
const_16_to_31_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 274 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 16, 31)));
}

bool
qi_mask_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 278 "../../gcc/config/loongarch/predicates.md"
(UINTVAL (op) == 0xff));
}

bool
hi_mask_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 282 "../../gcc/config/loongarch/predicates.md"
(UINTVAL (op) == 0xffff));
}

bool
lu52i_mask_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 286 "../../gcc/config/loongarch/predicates.md"
(UINTVAL (op) == 0xfffffffffffff));
}

bool
si_mask_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 290 "../../gcc/config/loongarch/predicates.md"
(UINTVAL (op) == 0xffffffff));
}

bool
low_bitmask_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 294 "../../gcc/config/loongarch/predicates.md"
(low_bitmask_len (mode, INTVAL (op)) > 12));
}

bool
d_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 298 "../../gcc/config/loongarch/predicates.md"
(GP_REG_P (REGNO (op))))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
db4_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 302 "../../gcc/config/loongarch/predicates.md"
(loongarch_unsigned_immediate_p (INTVAL (op) + 1, 4, 0)));
}

bool
db7_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 306 "../../gcc/config/loongarch/predicates.md"
(loongarch_unsigned_immediate_p (INTVAL (op) + 1, 7, 0)));
}

bool
db8_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 310 "../../gcc/config/loongarch/predicates.md"
(loongarch_unsigned_immediate_p (INTVAL (op) + 1, 8, 0)));
}

bool
ib3_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 314 "../../gcc/config/loongarch/predicates.md"
(loongarch_unsigned_immediate_p (INTVAL (op) - 1, 3, 0)));
}

bool
sb4_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 318 "../../gcc/config/loongarch/predicates.md"
(loongarch_signed_immediate_p (INTVAL (op), 4, 0)));
}

bool
sb5_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 322 "../../gcc/config/loongarch/predicates.md"
(loongarch_signed_immediate_p (INTVAL (op), 5, 0)));
}

bool
sb8_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 326 "../../gcc/config/loongarch/predicates.md"
(loongarch_signed_immediate_p (INTVAL (op), 8, 0)));
}

bool
sd8_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 330 "../../gcc/config/loongarch/predicates.md"
(loongarch_signed_immediate_p (INTVAL (op), 8, 3)));
}

bool
ub4_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 334 "../../gcc/config/loongarch/predicates.md"
(loongarch_unsigned_immediate_p (INTVAL (op), 4, 0)));
}

bool
ub8_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 338 "../../gcc/config/loongarch/predicates.md"
(loongarch_unsigned_immediate_p (INTVAL (op), 8, 0)));
}

bool
uh4_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 342 "../../gcc/config/loongarch/predicates.md"
(loongarch_unsigned_immediate_p (INTVAL (op), 4, 1)));
}

bool
uw4_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 346 "../../gcc/config/loongarch/predicates.md"
(loongarch_unsigned_immediate_p (INTVAL (op), 4, 2)));
}

bool
uw5_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 350 "../../gcc/config/loongarch/predicates.md"
(loongarch_unsigned_immediate_p (INTVAL (op), 5, 2)));
}

bool
uw6_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 354 "../../gcc/config/loongarch/predicates.md"
(loongarch_unsigned_immediate_p (INTVAL (op), 6, 2)));
}

bool
uw8_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 358 "../../gcc/config/loongarch/predicates.md"
(loongarch_unsigned_immediate_p (INTVAL (op), 8, 2)));
}

bool
addiur2_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && ((
#line 362 "../../gcc/config/loongarch/predicates.md"
(INTVAL (op) == -1)) || ((
#line 363 "../../gcc/config/loongarch/predicates.md"
(INTVAL (op) == 1)) || ((
#line 364 "../../gcc/config/loongarch/predicates.md"
(INTVAL (op) == 4)) || ((
#line 365 "../../gcc/config/loongarch/predicates.md"
(INTVAL (op) == 8)) || ((
#line 366 "../../gcc/config/loongarch/predicates.md"
(INTVAL (op) == 12)) || ((
#line 367 "../../gcc/config/loongarch/predicates.md"
(INTVAL (op) == 16)) || ((
#line 368 "../../gcc/config/loongarch/predicates.md"
(INTVAL (op) == 20)) || (
#line 369 "../../gcc/config/loongarch/predicates.md"
(INTVAL (op) == 24)))))))));
}

bool
addiusp_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && ((
#line 373 "../../gcc/config/loongarch/predicates.md"
((IN_RANGE (INTVAL (op), 2, 257)))) || (
#line 374 "../../gcc/config/loongarch/predicates.md"
((IN_RANGE (INTVAL (op), -258, -3)))));
}

bool
andi16_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && ((
#line 378 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 1, 4))) || ((
#line 379 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 7, 8))) || ((
#line 380 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 15, 16))) || ((
#line 381 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 31, 32))) || ((
#line 382 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (INTVAL (op), 63, 64))) || ((
#line 383 "../../gcc/config/loongarch/predicates.md"
(INTVAL (op) == 255)) || ((
#line 384 "../../gcc/config/loongarch/predicates.md"
(INTVAL (op) == 32768)) || (
#line 385 "../../gcc/config/loongarch/predicates.md"
(INTVAL (op) == 65535)))))))));
}

bool
movep_src_register (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && ((
#line 389 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (REGNO (op), 2, 3))) || (
#line 390 "../../gcc/config/loongarch/predicates.md"
(IN_RANGE (REGNO (op), 16, 20))))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
movep_src_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (const_0_operand (op, mode)) || (movep_src_register (op, mode));
}

bool
fcc_reload_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case REG:
    case SUBREG:
      break;
    default:
      return false;
    }
  return (
#line 398 "../../gcc/config/loongarch/predicates.md"
(FCC_REG_P (true_regnum (op)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
muldiv_target_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return register_operand (op, mode);
}

bool
ins_zero_bitmask_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && ((
#line 405 "../../gcc/config/loongarch/predicates.md"
(low_bitmask_len (mode, 				     ~UINTVAL (op) | (~UINTVAL(op) - 1)) 		    > 0)) && ((!(const_uns_arith_operand (op, mode))) && (!(low_bitmask_operand (op, mode)))));
}

bool
and_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (uns_arith_operand (op, mode)) || ((low_bitmask_operand (op, mode)) || (ins_zero_bitmask_operand (op, mode)));
}

static inline bool
const_call_insn_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 418 "../../gcc/config/loongarch/predicates.md"
{
  /* Split symbol to high and low if return false.
     If defined TARGET_CMODEL_EXTREME, all symbol would be splited,
     else if offset is not zero, the symbol would be splited.  */

  enum loongarch_symbol_type symbol_type;
  loongarch_symbolic_constant_p (op, &symbol_type);

  rtx offset, x = op;
  split_const (x, &x, &offset);

  if (offset != const0_rtx)
    return false;

  /* When compiling with '-mcmodel=medium -mexplicit-relocs'
     symbols are splited in loongarch_legitimize_call_address.

     When compiling with '-mcmodel=medium -mno-explicit-relocs',
     first obtain the symbolic address or the address of the
     plt entry, and then perform an indirect jump, so return false.  */

  switch (symbol_type)
    {
    case SYMBOL_PCREL:
      if (TARGET_CMODEL_EXTREME
	  || (TARGET_CMODEL_MEDIUM
	      && (la_opt_explicit_relocs == EXPLICIT_RELOCS_NONE)))
	return false;
      else
	return true;

    case SYMBOL_GOT_DISP:
      if (TARGET_CMODEL_EXTREME
	  || !flag_plt
	  || (flag_plt && TARGET_CMODEL_MEDIUM
	      && (la_opt_explicit_relocs == EXPLICIT_RELOCS_NONE)))
	return false;
      else
	return true;

    default:
      return false;
    }
}

bool
const_call_insn_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case CONST:
    case SYMBOL_REF:
    case LABEL_REF:
      break;
    default:
      return false;
    }
  return (
(const_call_insn_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

bool
call_insn_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (const_call_insn_operand (op, mode)) || (register_operand (op, mode));
}

bool
is_const_call_local_symbol (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (const_call_insn_operand (op, mode)) && (((
#line 469 "../../gcc/config/loongarch/predicates.md"
(loongarch_global_symbol_p (op) == 0)) || (
#line 470 "../../gcc/config/loongarch/predicates.md"
(loongarch_symbol_binds_local_p (op) != 0))) && (
#line 471 "../../gcc/config/loongarch/predicates.md"
(CONSTANT_P (op))));
}

bool
is_const_call_no_local_symbol (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (const_call_insn_operand (op, mode)) && (((
#line 475 "../../gcc/config/loongarch/predicates.md"
(loongarch_global_symbol_p (op) != 0)) || ((
#line 476 "../../gcc/config/loongarch/predicates.md"
(loongarch_symbol_binds_local_p (op) == 0)) || (
#line 477 "../../gcc/config/loongarch/predicates.md"
(loongarch_weak_symbol_p (op) != 0)))) && (
#line 478 "../../gcc/config/loongarch/predicates.md"
(CONSTANT_P (op))));
}

static inline bool
splittable_const_int_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 484 "../../gcc/config/loongarch/predicates.md"
{
  /* Don't handle multi-word moves this way; we don't want to introduce
     the individual word-mode moves until after reload.  */
  if (GET_MODE_SIZE (mode) > UNITS_PER_WORD)
    return false;

  /* Otherwise check whether the constant can be loaded in a single
     instruction.  */
  return !LU12I_INT (op) && !IMM12_INT (op) && !IMM12_INT_UNSIGNED (op)
	 && !LU52I_INT (op);
}

bool
splittable_const_int_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
(splittable_const_int_operand_1 (op, mode)));
}

static inline bool
move_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 498 "../../gcc/config/loongarch/predicates.md"
{
  enum loongarch_symbol_type symbol_type;

  /* The thinking here is as follows:

     (1) The move expanders should split complex load sequences into
	 individual instructions.  Those individual instructions can
	 then be optimized by all rtl passes.

     (2) The target of pre-reload load sequences should not be used
	 to store temporary results.  If the target register is only
	 assigned one value, reload can rematerialize that value
	 on demand, rather than spill it to the stack.

     (3) If we allowed pre-reload passes like combine and cse to recreate
	 complex load sequences, we would want to be able to split the
	 sequences before reload as well, so that the pre-reload scheduler
	 can see the individual instructions.  This falls foul of (2);
	 the splitter would be forced to reuse the target register for
	 intermediate results.

     (4) We want to define complex load splitters for combine.  These
	 splitters can request a temporary scratch register, which avoids
	 the problem in (2).  They allow things like:

	      (set (reg T1) (high SYM))
	      (set (reg T2) (low (reg T1) SYM))
	      (set (reg X) (plus (reg T2) (const_int OFFSET)))

	 to be combined into:

	      (set (reg T3) (high SYM+OFFSET))
	      (set (reg X) (lo_sum (reg T3) SYM+OFFSET))

	 if T2 is only used this once.  */
  switch (GET_CODE (op))
    {
    case CONST_INT:
      return true;

    case CONST:
    case SYMBOL_REF:
    case LABEL_REF:
      return (loongarch_symbolic_constant_p (op, &symbol_type)
	      && (!loongarch_explicit_relocs_p (symbol_type)
		  || !loongarch_split_symbol_type (symbol_type)));

    case HIGH:
      op = XEXP (op, 0);

      return (loongarch_symbolic_constant_p (op, &symbol_type)
	      && loongarch_explicit_relocs_p (symbol_type)
	      && loongarch_split_symbol_type (symbol_type));

    default:
      return true;
    }
}

bool
move_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (general_operand (op, mode)) && (
(move_operand_1 (op, mode)));
}

static inline bool
symbolic_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 559 "../../gcc/config/loongarch/predicates.md"
{
  enum loongarch_symbol_type type;
  return loongarch_symbolic_constant_p (op, &type);
}

bool
symbolic_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case CONST:
    case SYMBOL_REF:
    case LABEL_REF:
      break;
    default:
      return false;
    }
  return (
(symbolic_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

static inline bool
symbolic_pcrel_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 566 "../../gcc/config/loongarch/predicates.md"
{
  enum loongarch_symbol_type type;
  return loongarch_symbolic_constant_p (op, &type) && type == SYMBOL_PCREL;
}

bool
symbolic_pcrel_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case CONST:
    case SYMBOL_REF:
    case LABEL_REF:
      break;
    default:
      return false;
    }
  return (
(symbolic_pcrel_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

bool
symbolic_pcrel_offset_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == PLUS) && ((symbolic_pcrel_operand (op, mode)) && (const_int_operand (op, mode)));
}

static inline bool
mem_simple_ldst_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 578 "../../gcc/config/loongarch/predicates.md"
{
  op = XEXP (op, 0);
  return (symbolic_pcrel_operand (op, Pmode)
	  || symbolic_pcrel_offset_operand (op, Pmode));
}

bool
mem_simple_ldst_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MEM) && (
(mem_simple_ldst_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
symbolic_off64_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 586 "../../gcc/config/loongarch/predicates.md"
{
  enum loongarch_symbol_type type;
  return loongarch_symbolic_constant_p (op, &type)
	 && loongarch_symbol_extreme_p (type);
}

bool
symbolic_off64_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case CONST:
    case SYMBOL_REF:
    case LABEL_REF:
      break;
    default:
      return false;
    }
  return (
(symbolic_off64_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

bool
symbolic_off64_or_reg_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || (symbolic_off64_operand (op, mode));
}

bool
equality_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

bool
order_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case LT:
    case LTU:
    case LE:
    case LEU:
    case GE:
    case GEU:
    case GT:
    case GTU:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

bool
loongarch_cstore_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case NE:
    case EQ:
    case GT:
    case GTU:
    case GE:
    case GEU:
    case LT:
    case LTU:
    case LE:
    case LEU:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

bool
loongarch_fcmp_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case UNORDERED:
    case UNEQ:
    case UNLT:
    case UNLE:
    case EQ:
    case LT:
    case LE:
    case ORDERED:
    case LTGT:
    case NE:
    case GE:
    case GT:
    case UNGE:
    case UNGT:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

bool
small_data_pattern (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case SET:
    case PARALLEL:
    case UNSPEC:
    case UNSPEC_VOLATILE:
    case PREFETCH:
      break;
    default:
      return false;
    }
  return (
#line 613 "../../gcc/config/loongarch/predicates.md"
(loongarch_small_data_pattern_p (op))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
non_volatile_mem_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (memory_operand (op, mode)) && (!(
#line 618 "../../gcc/config/loongarch/predicates.md"
(MEM_VOLATILE_P (op))));
}

static inline bool
const_vector_same_val_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 622 "../../gcc/config/loongarch/predicates.md"
{
  return loongarch_const_vector_same_val_p (op, mode);
}

bool
const_vector_same_val_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == CONST_VECTOR) && (
(const_vector_same_val_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
const_vector_same_simm5_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 628 "../../gcc/config/loongarch/predicates.md"
{
  return loongarch_const_vector_same_int_p (op, mode, -16, 15);
}

bool
const_vector_same_simm5_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == CONST_VECTOR) && (
(const_vector_same_simm5_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
const_vector_same_uimm5_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 634 "../../gcc/config/loongarch/predicates.md"
{
  return loongarch_const_vector_same_int_p (op, mode, 0, 31);
}

bool
const_vector_same_uimm5_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == CONST_VECTOR) && (
(const_vector_same_uimm5_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
const_vector_same_ximm5_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 640 "../../gcc/config/loongarch/predicates.md"
{
  return loongarch_const_vector_same_int_p (op, mode, -31, 31);
}

bool
const_vector_same_ximm5_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == CONST_VECTOR) && (
(const_vector_same_ximm5_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
const_vector_same_uimm_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 646 "../../gcc/config/loongarch/predicates.md"
{
  return loongarch_const_vector_same_int_p (op, mode);
}

bool
const_vector_same_uimm_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == CONST_VECTOR) && (
(const_vector_same_uimm_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
par_const_vector_shf_set_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 652 "../../gcc/config/loongarch/predicates.md"
{
  return loongarch_const_vector_shuffle_set_p (op, mode);
}

bool
par_const_vector_shf_set_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == PARALLEL) && (
(par_const_vector_shf_set_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
reg_or_vector_same_val_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || (const_vector_same_val_operand (op, mode));
}

bool
reg_or_vector_same_simm5_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || (const_vector_same_simm5_operand (op, mode));
}

bool
reg_or_vector_same_uimm5_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || (const_vector_same_uimm5_operand (op, mode));
}

bool
reg_or_vector_same_ximm5_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || (const_vector_same_ximm5_operand (op, mode));
}

bool
reg_or_vector_same_uimm_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || (const_vector_same_uimm_operand (op, mode));
}

static inline bool
vect_par_cnst_even_or_odd_half_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 680 "../../gcc/config/loongarch/predicates.md"
{
  int nunits = XVECLEN (op, 0);

  if (!known_eq (GET_MODE_NUNITS (mode), nunits * 2))
    return false;

  rtx first = XVECEXP (op, 0, 0);
  if (!CONST_INT_P (first))
    return false;

  if (INTVAL (first) != 0 && INTVAL (first) != 1)
    return false;

  for (int i = 1; i < nunits; i++)
    {
      rtx elem = XVECEXP (op, 0, i);
      if (!CONST_INT_P (elem) || INTVAL (elem) != INTVAL (first) + i * 2)
	return false;
    }

  return true;
}

bool
vect_par_cnst_even_or_odd_half (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == PARALLEL) && (
(vect_par_cnst_even_or_odd_half_1 (op, mode)));
}

enum constraint_num
lookup_constraint_1 (const char *str)
{
  switch (str[0])
    {
    case ':':
      return CONSTRAINT__c;
    case '<':
      return CONSTRAINT__l;
    case '>':
      return CONSTRAINT__g;
    case 'E':
      return CONSTRAINT_E;
    case 'F':
      return CONSTRAINT_F;
    case 'G':
      return CONSTRAINT_G;
    case 'I':
      return CONSTRAINT_I;
    case 'J':
      return CONSTRAINT_J;
    case 'K':
      return CONSTRAINT_K;
    case 'L':
      if (str[1] == 'b')
        return CONSTRAINT_Lb;
      if (str[1] == 'c')
        return CONSTRAINT_Lc;
      if (str[1] == 'd')
        return CONSTRAINT_Ld;
      if (str[1] == 'e')
        return CONSTRAINT_Le;
      if (str[1] == 'a')
        return CONSTRAINT_La;
      break;
    case 'M':
      return CONSTRAINT_M;
    case 'N':
      return CONSTRAINT_N;
    case 'O':
      return CONSTRAINT_O;
    case 'P':
      return CONSTRAINT_P;
    case 'R':
      return CONSTRAINT_R;
    case 'S':
      return CONSTRAINT_S;
    case 'U':
      if (!strncmp (str + 1, "uv5", 3))
        return CONSTRAINT_Uuv5;
      if (!strncmp (str + 1, "sv5", 3))
        return CONSTRAINT_Usv5;
      if (!strncmp (str + 1, "rv8", 3))
        return CONSTRAINT_Urv8;
      if (!strncmp (str + 1, "uvx", 3))
        return CONSTRAINT_Uuvx;
      if (!strncmp (str + 1, "nv5", 3))
        return CONSTRAINT_Unv5;
      break;
    case 'V':
      return CONSTRAINT_V;
    case 'X':
      return CONSTRAINT_X;
    case 'Y':
      if (str[1] == 'A')
        return CONSTRAINT_YA;
      if (str[1] == 'B')
        return CONSTRAINT_YB;
      if (str[1] == 'b')
        return CONSTRAINT_Yb;
      if (str[1] == 'd')
        return CONSTRAINT_Yd;
      if (str[1] == 'h')
        return CONSTRAINT_Yh;
      if (str[1] == 'w')
        return CONSTRAINT_Yw;
      if (str[1] == 'x')
        return CONSTRAINT_Yx;
      if (str[1] == 'y')
        return CONSTRAINT_Yy;
      if (str[1] == 'I')
        return CONSTRAINT_YI;
      if (str[1] == 'C')
        return CONSTRAINT_YC;
      if (str[1] == 'Z')
        return CONSTRAINT_YZ;
      if (str[1] == 'G')
        return CONSTRAINT_YG;
      break;
    case 'Z':
      if (str[1] == 'B')
        return CONSTRAINT_ZB;
      if (str[1] == 'D')
        return CONSTRAINT_ZD;
      if (str[1] == 'C')
        return CONSTRAINT_ZC;
      break;
    case 'b':
      return CONSTRAINT_b;
    case 'c':
      return CONSTRAINT_c;
    case 'e':
      return CONSTRAINT_e;
    case 'f':
      return CONSTRAINT_f;
    case 'i':
      return CONSTRAINT_i;
    case 'j':
      return CONSTRAINT_j;
    case 'k':
      return CONSTRAINT_k;
    case 'l':
      return CONSTRAINT_l;
    case 'm':
      return CONSTRAINT_m;
    case 'n':
      return CONSTRAINT_n;
    case 'o':
      return CONSTRAINT_o;
    case 'p':
      return CONSTRAINT_p;
    case 'q':
      return CONSTRAINT_q;
    case 'r':
      return CONSTRAINT_r;
    case 's':
      return CONSTRAINT_s;
    case 'u':
      return CONSTRAINT_u;
    case 'v':
      return CONSTRAINT_v;
    case 'w':
      return CONSTRAINT_w;
    case 'z':
      return CONSTRAINT_z;
    default: break;
    }
  return CONSTRAINT__UNKNOWN;
}

const unsigned char lookup_constraint_array[] = {
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT__c, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT__l, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT__g, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_E, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_F, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_G, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_I, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_J, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_K, (int) UCHAR_MAX),
  UCHAR_MAX,
  MIN ((int) CONSTRAINT_M, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_N, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_O, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_P, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_R, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_S, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  UCHAR_MAX,
  MIN ((int) CONSTRAINT_V, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_X, (int) UCHAR_MAX),
  UCHAR_MAX,
  UCHAR_MAX,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_b, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_c, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_e, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_f, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_i, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_j, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_k, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_l, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_m, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_n, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_o, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_p, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_q, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_r, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_s, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_u, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_v, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_w, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_z, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN
};

enum reg_class
reg_class_for_constraint_1 (enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_r: return GENERAL_REGS;
    case CONSTRAINT_e: return JIRL_REGS;
    case CONSTRAINT_f: return TARGET_HARD_FLOAT ? FP_REGS : NO_REGS;
    case CONSTRAINT_j: return SIBCALL_REGS;
    case CONSTRAINT_q: return CSR_REGS;
    case CONSTRAINT_z: return FCC_REGS;
    default: break;
    }
  return NO_REGS;
}

bool (*constraint_satisfied_p_array[]) (rtx) = {
  satisfies_constraint_I,
  satisfies_constraint_J,
  satisfies_constraint_K,
  satisfies_constraint_La,
  satisfies_constraint_Lb,
  satisfies_constraint_Lc,
  satisfies_constraint_Ld,
  satisfies_constraint_Le,
  satisfies_constraint_M,
  satisfies_constraint_N,
  satisfies_constraint_O,
  satisfies_constraint_P,
  satisfies_constraint_w,
  satisfies_constraint_o,
  satisfies_constraint_k,
  satisfies_constraint_m,
  satisfies_constraint_R,
  satisfies_constraint_ZC,
  satisfies_constraint_ZB,
  satisfies_constraint_p,
  satisfies_constraint_ZD,
  satisfies_constraint_b,
  satisfies_constraint_c,
  satisfies_constraint_l,
  satisfies_constraint_u,
  satisfies_constraint_v,
  satisfies_constraint_G,
  satisfies_constraint_YG,
  satisfies_constraint_YA,
  satisfies_constraint_YB,
  satisfies_constraint_Yb,
  satisfies_constraint_Yh,
  satisfies_constraint_Yw,
  satisfies_constraint_Yx,
  satisfies_constraint_Yy,
  satisfies_constraint_YI,
  satisfies_constraint_YC,
  satisfies_constraint_YZ,
  satisfies_constraint_Unv5,
  satisfies_constraint_Uuv5,
  satisfies_constraint_Usv5,
  satisfies_constraint_Urv8,
  satisfies_constraint_Uuvx,
  satisfies_constraint_S,
  satisfies_constraint_V,
  satisfies_constraint__l,
  satisfies_constraint__g,
  satisfies_constraint_i,
  satisfies_constraint_s,
  satisfies_constraint__c,
  satisfies_constraint_n,
  satisfies_constraint_E,
  satisfies_constraint_F,
  satisfies_constraint_X,
  satisfies_constraint_Yd
};

bool
insn_const_int_ok_for_constraint (HOST_WIDE_INT ival, enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_I:
      return 
#line 178 "../../gcc/config/loongarch/constraints.md"
(IMM12_OPERAND (ival));

    case CONSTRAINT_J:
      return 
#line 183 "../../gcc/config/loongarch/constraints.md"
(ival == 0);

    case CONSTRAINT_K:
      return 
#line 188 "../../gcc/config/loongarch/constraints.md"
(IMM12_OPERAND_UNSIGNED (ival));

    case CONSTRAINT_La:
      return 
#line 193 "../../gcc/config/loongarch/constraints.md"
(DUAL_IMM12_OPERAND (ival));

    case CONSTRAINT_Lb:
      return 
#line 199 "../../gcc/config/loongarch/constraints.md"
(ADDU16I_OPERAND (ival));

    case CONSTRAINT_Lc:
      return 
#line 205 "../../gcc/config/loongarch/constraints.md"
(loongarch_addu16i_imm12_operand_p (ival, DImode));

    case CONSTRAINT_Ld:
      return 
#line 211 "../../gcc/config/loongarch/constraints.md"
(DUAL_ADDU16I_OPERAND (ival));

    case CONSTRAINT_Le:
      return 
#line 217 "../../gcc/config/loongarch/constraints.md"
(loongarch_addu16i_imm12_operand_p (ival, SImode));

    case CONSTRAINT_M:
      return (!(
#line 223 "../../gcc/config/loongarch/constraints.md"
(IMM12_OPERAND (ival)))) && ((!(
#line 224 "../../gcc/config/loongarch/constraints.md"
(IMM12_OPERAND_UNSIGNED (ival)))) && (!(
#line 225 "../../gcc/config/loongarch/constraints.md"
(LU12I_OPERAND (ival)))));

    case CONSTRAINT_N:
      return 
#line 230 "../../gcc/config/loongarch/constraints.md"
(ival >= -0xffff && ival < 0);

    case CONSTRAINT_O:
      return 
#line 235 "../../gcc/config/loongarch/constraints.md"
(ival >= -0x4000 && ival < 0x4000);

    case CONSTRAINT_P:
      return 
#line 240 "../../gcc/config/loongarch/constraints.md"
(ival > 0 && ival < 0x10000);

    default: break;
    }
  return false;
}


void
init_reg_class_start_regs ()
{
}
