/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_FCCmode)
      || GET_MODE (x1) != E_FCCmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode)
          || !register_operand (operands[2], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode)
          || !register_operand (operands[2], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode)
      || !register_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern39 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 2);
  if (XWINT (x4, 0) != 6L)
    return -1;
  x5 = XVECEXP (x3, 0, 3);
  if (XWINT (x5, 0) != 7L
      || pattern37 (x1, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern43 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LO_SUM)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern46 (x2, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern46 (x2, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern57 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern60 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!symbolic_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern69 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !const_uimm4_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern74 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern82 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V4DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4DImode))
    return -1;
  return 0;
}

int
pattern89 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern88 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern88 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern94 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SFmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != VEC_CONCAT
      || GET_MODE (x3) != E_V2SFmode
      || !register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SFmode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SFmode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SFmode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[4] = x7;
  if (!register_operand (operands[4], E_SFmode))
    return -1;
  return 0;
}

int
pattern103 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern110 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern125 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_ximm5_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[1], E_V2DFmode))
            return -1;
          return 0;

        case E_V4DFmode:
          if (!register_operand (operands[1], E_V4DFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode))
            return -1;
          return 2;

        case E_V8SFmode:
          if (!register_operand (operands[1], E_V8SFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern152 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern151 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern151 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern160 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern166 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern172 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern180 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !const_0_or_1_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[4]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern187 (x1, 
E_V1TImode, 
E_V2DImode, 
E_V1DImode, 
E_V2TImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern187 (x1, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern187 (x1, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode, 
E_V8SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern187 (x1, 
E_V8HImode, 
E_V16QImode, 
E_V8QImode, 
E_V16HImode) != 0)
        return -1;
      return 3;

    case E_V2TImode:
      if (pattern187 (x1, 
E_V2TImode, 
E_V4DImode, 
E_V2DImode, 
E_V4TImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern187 (x1, 
E_V4DImode, 
E_V8SImode, 
E_V4SImode, 
E_V8DImode) != 0)
        return -1;
      return 5;

    case E_V8SImode:
      if (pattern187 (x1, 
E_V8SImode, 
E_V16HImode, 
E_V8HImode, 
E_V16SImode) != 0)
        return -1;
      return 6;

    case E_V16HImode:
      if (pattern187 (x1, 
E_V16HImode, 
E_V32QImode, 
E_V16QImode, 
E_V32HImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ASHIFT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_immalsl_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 4191 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 376; /* fclass_s */

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode)
          || !(
#line 4191 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
        return -1;
      return 377; /* fclass_d */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern50 (x1))
    {
    case 0:
      if (!(
#line 2724 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (10 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && 
#line 409 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
        return -1;
      return 199; /* lfloorsfsi2 */

    case 1:
      if (!(
#line 2724 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (10 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && (
#line 409 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))))
        return -1;
      return 205; /* lfloordfsi2 */

    case 2:
      if (!(
#line 2724 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (10 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && (
#line 410 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))))
        return -1;
      return 202; /* lfloorsfdi2 */

    case 3:
      if (!(
#line 2724 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (10 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && 
#line 410 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
        return -1;
      return 208; /* lfloordfdi2 */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  switch (pattern141 (x3))
    {
    case 0:
      if (!
#line 3137 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2061; /* lasx_xvreplve_d */

    case 1:
      if (!
#line 3137 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2062; /* lasx_xvreplve_w */

    case 2:
      if (!
#line 3137 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2063; /* lasx_xvreplve_h */

    case 3:
      if (!
#line 3137 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2064; /* lasx_xvreplve_b */

    case 4:
      if (!
#line 3137 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2065; /* lasx_xvreplve_d_f */

    case 5:
      if (!
#line 3137 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2066; /* lasx_xvreplve_w_f */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 2040 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1853; /* lasx_xvsrlr_d */

    case 1:
      if (!
#line 2040 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1854; /* lasx_xvsrlr_w */

    case 2:
      if (!
#line 2040 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1855; /* lasx_xvsrlr_h */

    case 3:
      if (!
#line 2040 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1856; /* lasx_xvsrlr_b */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern77 (x1))
    {
    case 0:
      if (!
#line 1126 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1694; /* lasx_xvbitclri_d */

    case 1:
      if (!
#line 1126 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1695; /* lasx_xvbitclri_w */

    case 2:
      if (!
#line 1126 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1696; /* lasx_xvbitclri_h */

    case 3:
      if (!
#line 1126 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1697; /* lasx_xvbitclri_b */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 1705 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1241; /* lsx_vsrar_d */

    case 1:
      if (!
#line 1705 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1242; /* lsx_vsrar_w */

    case 2:
      if (!
#line 1705 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1243; /* lsx_vsrar_h */

    case 3:
      if (!
#line 1705 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1244; /* lsx_vsrar_b */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 966 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1084; /* lsx_vavgr_u_du */

    case 1:
      if (!
#line 966 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1085; /* lsx_vavgr_u_wu */

    case 2:
      if (!
#line 966 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1086; /* lsx_vavgr_u_hu */

    case 3:
      if (!
#line 966 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1087; /* lsx_vavgr_u_bu */

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern160 (x2, 
E_V2DFmode) != 0
          || !
#line 544 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 963; /* lsx_vshuf_d_f */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern160 (x2, 
E_V4SFmode) != 0
          || !
#line 544 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 964; /* lsx_vshuf_w_f */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern160 (x2, 
E_V2DImode) != 0
          || !
#line 544 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 965; /* lsx_vshuf_d */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern160 (x2, 
E_V4SImode) != 0
          || !
#line 544 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 966; /* lsx_vshuf_w */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern160 (x2, 
E_V8HImode) != 0
          || !
#line 544 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 967; /* lsx_vshuf_h */

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  if (XWINT (x4, 0) == 0L)
    {
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern133 (x2))
        {
        case 0:
          if (
#line 375 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 938; /* lsx_vec_extract_d_f */
          break;

        case 1:
          if (
#line 626 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LSX))
            return 1568; /* vec_extractv4df_0 */
          break;

        case 2:
          if (
#line 375 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 939; /* lsx_vec_extract_w_f */
          break;

        case 3:
          if (
#line 626 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LSX))
            return 1569; /* vec_extractv8sf_0 */
          break;

        default:
          break;
        }
    }
  x5 = XEXP (x1, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[0] = x5;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_V2DImode)
              || !const_0_or_1_operand (operands[2], E_VOIDmode)
              || !
#line 489 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 960; /* lsx_vpickve2gr_du */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode))
            return -1;
          switch (pattern196 (x2, 
E_VOIDmode))
            {
            case 0:
              if (!
#line 499 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 962; /* lsx_vpickve2gr_d_f */

            case 1:
              if (!
#line 3524 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2152; /* lasx_xvpickve_d_f_scalar */

            default:
              return -1;
            }

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !register_operand (operands[1], E_V8SFmode)
              || !const_0_to_7_operand (operands[2], E_VOIDmode)
              || !
#line 3524 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2153; /* lasx_xvpickve_w_f_scalar */

        default:
          return -1;
        }

    case MEM:
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case PLUS:
          if (GET_MODE (x7) != E_DImode)
            return -1;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x9 = XEXP (x7, 1);
          operands[1] = x9;
          x6 = XEXP (x2, 0);
          operands[2] = x6;
          operands[3] = x4;
          switch (GET_MODE (x5))
            {
            case E_DImode:
              if (!aq8d_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x2) != E_DImode)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V2DImode:
                  if (!register_operand (operands[2], E_V2DImode)
                      || !const_0_or_1_operand (operands[3], E_VOIDmode)
                      || !
#line 2639 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1442; /* lsx_vstelm_d_insn */

                case E_V4DImode:
                  if (!register_operand (operands[2], E_V4DImode)
                      || !const_0_to_3_operand (operands[3], E_VOIDmode)
                      || !
#line 3464 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2132; /* lasx_xvstelm_d_insn */

                default:
                  return -1;
                }

            case E_SImode:
              if (!aq8w_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x2) != E_SImode)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V4SImode:
                  if (!register_operand (operands[2], E_V4SImode)
                      || !const_0_to_3_operand (operands[3], E_VOIDmode)
                      || !
#line 2639 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1443; /* lsx_vstelm_w_insn */

                case E_V8SImode:
                  if (!register_operand (operands[2], E_V8SImode)
                      || !const_0_to_7_operand (operands[3], E_VOIDmode)
                      || !
#line 3464 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2133; /* lasx_xvstelm_w_insn */

                default:
                  return -1;
                }

            case E_HImode:
              if (!aq8h_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x2) != E_HImode)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V8HImode:
                  if (!register_operand (operands[2], E_V8HImode)
                      || !const_uimm3_operand (operands[3], E_VOIDmode)
                      || !
#line 2639 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1444; /* lsx_vstelm_h_insn */

                case E_V16HImode:
                  if (!register_operand (operands[2], E_V16HImode)
                      || !const_uimm4_operand (operands[3], E_VOIDmode)
                      || !
#line 3464 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2134; /* lasx_xvstelm_h_insn */

                default:
                  return -1;
                }

            case E_QImode:
              if (!aq8b_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x2) != E_QImode)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V16QImode:
                  if (!register_operand (operands[2], E_V16QImode)
                      || !const_uimm4_operand (operands[3], E_VOIDmode)
                      || !
#line 2639 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1445; /* lsx_vstelm_b_insn */

                case E_V32QImode:
                  if (!register_operand (operands[2], E_V32QImode)
                      || !const_uimm5_operand (operands[3], E_VOIDmode)
                      || !
#line 3464 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2135; /* lasx_xvstelm_b_insn */

                default:
                  return -1;
                }

            case E_DFmode:
              if (!aq8d_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x2) != E_DFmode)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V2DFmode:
                  if (!register_operand (operands[2], E_V2DFmode)
                      || !const_0_or_1_operand (operands[3], E_VOIDmode)
                      || !
#line 2639 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1446; /* lsx_vstelm_d_f_insn */

                case E_V4DFmode:
                  if (!register_operand (operands[2], E_V4DFmode)
                      || !const_0_to_3_operand (operands[3], E_VOIDmode)
                      || !
#line 3464 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2136; /* lasx_xvstelm_d_f_insn */

                default:
                  return -1;
                }

            case E_SFmode:
              if (!aq8w_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x2) != E_SFmode)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V4SFmode:
                  if (!register_operand (operands[2], E_V4SFmode)
                      || !const_0_to_3_operand (operands[3], E_VOIDmode)
                      || !
#line 2639 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1447; /* lsx_vstelm_w_f_insn */

                case E_V8SFmode:
                  if (!register_operand (operands[2], E_V8SFmode)
                      || !const_0_to_7_operand (operands[3], E_VOIDmode)
                      || !
#line 3464 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2137; /* lasx_xvstelm_w_f_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[0] = x7;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x6 = XEXP (x2, 0);
          operands[1] = x6;
          operands[2] = x4;
          switch (GET_MODE (x5))
            {
            case E_DImode:
              if (GET_MODE (x2) != E_DImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2DImode:
                  if (!register_operand (operands[1], E_V2DImode)
                      || !const_0_or_1_operand (operands[2], E_SImode)
                      || !
#line 2653 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1448; /* lsx_vstelm_d_insn_0 */

                case E_V4DImode:
                  if (!register_operand (operands[1], E_V4DImode)
                      || !const_0_to_3_operand (operands[2], E_SImode)
                      || !
#line 3478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2138; /* lasx_xvstelm_d_insn_0 */

                default:
                  return -1;
                }

            case E_SImode:
              if (GET_MODE (x2) != E_SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !const_0_to_3_operand (operands[2], E_SImode)
                      || !
#line 2653 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1449; /* lsx_vstelm_w_insn_0 */

                case E_V8SImode:
                  if (!register_operand (operands[1], E_V8SImode)
                      || !const_0_to_7_operand (operands[2], E_SImode)
                      || !
#line 3478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2140; /* lasx_xvstelm_w_insn_0 */

                default:
                  return -1;
                }

            case E_HImode:
              if (GET_MODE (x2) != E_HImode
                  || !register_operand (operands[1], E_V8HImode)
                  || !const_uimm3_operand (operands[2], E_SImode)
                  || !
#line 2653 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1450; /* lsx_vstelm_h_insn_0 */

            case E_QImode:
              if (GET_MODE (x2) != E_QImode
                  || !register_operand (operands[1], E_V16QImode)
                  || !const_uimm4_operand (operands[2], E_SImode)
                  || !
#line 2653 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1451; /* lsx_vstelm_b_insn_0 */

            case E_DFmode:
              switch (pattern196 (x2, 
E_SImode))
                {
                case 0:
                  if (!
#line 2653 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1452; /* lsx_vstelm_d_f_insn_0 */

                case 1:
                  if (!
#line 3478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2139; /* lasx_xvstelm_d_f_insn_0 */

                default:
                  return -1;
                }

            case E_SFmode:
              if (GET_MODE (x2) != E_SFmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !const_0_to_3_operand (operands[2], E_SImode)
                      || !
#line 2653 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1453; /* lsx_vstelm_w_f_insn_0 */

                case E_V8SFmode:
                  if (!register_operand (operands[1], E_V8SFmode)
                      || !const_0_to_7_operand (operands[2], E_SImode)
                      || !
#line 3478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2141; /* lasx_xvstelm_w_f_insn_0 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (register_operand (operands[1], E_SImode))
            {
              x6 = XEXP (x4, 1);
              operands[2] = x6;
              if (plus_si_extend_operand (operands[2], E_SImode)
                  && 
#line 795 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return 6; /* addsi3_extended */
            }
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_SImode)
            return -1;
          x7 = XEXP (x5, 0);
          if (GET_MODE (x7) != E_DImode)
            return -1;
          switch (GET_CODE (x7))
            {
            case ASHIFT:
              if (pattern195 (x4) != 0
                  || !
#line 3119 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 258; /* *alslsi3_extend_subreg */

            case AND:
              if (pattern204 (x4) != 0
                  || !
#line 3175 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && loongarch_reassoc_shift_bitwise (true, operands[2], operands[3],
				       SImode)))
                return -1;
              return 266; /* and_alsl_reversesi_extended */

            case IOR:
              if (pattern204 (x4) != 0
                  || !
#line 3175 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       SImode)))
                return -1;
              return 267; /* ior_alsl_reversesi_extended */

            case XOR:
              if (pattern204 (x4) != 0
                  || !
#line 3175 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       SImode)))
                return -1;
              return 268; /* xor_alsl_reversesi_extended */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          if (!const_immalsl_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_SImode)
              || !
#line 3105 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 256; /* *alslsi3_extend */

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 846 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 11; /* subsi3_extend */

    case MULT:
      if (pattern32 (x3) != 0
          || !
#line 882 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 16; /* mulsi3_extend */

    case DIV:
      if (pattern32 (x3) != 0
          || !
#line 1102 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && ISA_HAS_DIV32))
        return -1;
      return 37; /* divsi3_extended */

    case UDIV:
      if (pattern32 (x3) != 0
          || !
#line 1102 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && ISA_HAS_DIV32))
        return -1;
      return 38; /* udivsi3_extended */

    case MOD:
      if (pattern32 (x3) != 0
          || !
#line 1102 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && ISA_HAS_DIV32))
        return -1;
      return 39; /* modsi3_extended */

    case UMOD:
      if (pattern32 (x3) != 0
          || !
#line 1102 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && ISA_HAS_DIV32))
        return -1;
      return 40; /* umodsi3_extended */

    case UNSPEC:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 1:
          if (XINT (x4, 1) != 35)
            return -1;
          x9 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x9) != SUBREG
              || maybe_ne (SUBREG_BYTE (x9), 0)
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_DImode)
            return -1;
          switch (GET_CODE (x10))
            {
            case DIV:
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x12 = XEXP (x10, 1);
              operands[2] = x12;
              if (!register_operand (operands[2], E_DImode)
                  || !
#line 1122 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && !ISA_HAS_DIV32))
                return -1;
              return 41; /* divdi3_fake */

            case UDIV:
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x12 = XEXP (x10, 1);
              operands[2] = x12;
              if (!register_operand (operands[2], E_DImode)
                  || !
#line 1122 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && !ISA_HAS_DIV32))
                return -1;
              return 42; /* udivdi3_fake */

            case MOD:
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x12 = XEXP (x10, 1);
              operands[2] = x12;
              if (!register_operand (operands[2], E_DImode)
                  || !
#line 1122 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && !ISA_HAS_DIV32))
                return -1;
              return 43; /* moddi3_fake */

            case UMOD:
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x12 = XEXP (x10, 1);
              operands[2] = x12;
              if (!register_operand (operands[2], E_DImode)
                  || !
#line 1122 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && !ISA_HAS_DIV32))
                return -1;
              return 44; /* umoddi3_fake */

            default:
              return -1;
            }

        case 2:
          x9 = XVECEXP (x4, 0, 0);
          operands[1] = x9;
          x13 = XVECEXP (x4, 0, 1);
          operands[2] = x13;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          switch (XINT (x4, 1))
            {
            case 24:
              switch (pattern191 ())
                {
                case 0:
                  if (!
#line 4494 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 454; /* loongarch_crc_w_b_w_extended */

                case 1:
                  if (!
#line 4494 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 456; /* loongarch_crc_w_h_w_extended */

                case 2:
                  if (!
#line 4494 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 458; /* loongarch_crc_w_w_w_extended */

                case 3:
                  if (!
#line 4494 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 460; /* loongarch_crc_w_d_w_extended */

                default:
                  return -1;
                }

            case 25:
              switch (pattern191 ())
                {
                case 0:
                  if (!
#line 4494 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 455; /* loongarch_crcc_w_b_w_extended */

                case 1:
                  if (!
#line 4494 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 457; /* loongarch_crcc_w_h_w_extended */

                case 2:
                  if (!
#line 4494 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 459; /* loongarch_crcc_w_w_w_extended */

                case 3:
                  if (!
#line 4494 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 461; /* loongarch_crcc_w_d_w_extended */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      if (pattern33 (x3) != 0
          || !
#line 1523 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 93; /* *negsi2_extended */

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern34 (x3))
        {
        case 0:
          if (nonimmediate_operand (operands[1], E_SImode)
              && 
#line 1844 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return 133; /* extendsidi2 */
          if (!mem_simple_ldst_operand (operands[1], E_SImode)
              || !(
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 482; /* simple_load_sextsidi */

        case 1:
          if (nonimmediate_operand (operands[1], E_QImode)
              && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return 135; /* extendqidi2 */
          if (!mem_simple_ldst_operand (operands[1], E_QImode)
              || !(
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 478; /* simple_load_sextqidi */

        case 2:
          if (nonimmediate_operand (operands[1], E_HImode)
              && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return 137; /* extendhidi2 */
          if (!mem_simple_ldst_operand (operands[1], E_HImode)
              || !(
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 480; /* simple_load_sexthidi */

        case 3:
          if (nonimmediate_operand (operands[1], E_QImode))
            return 134; /* extendqisi2 */
          if (!mem_simple_ldst_operand (operands[1], E_QImode)
              || !
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)))
            return -1;
          return 472; /* simple_load_sextqisi */

        case 4:
          if (nonimmediate_operand (operands[1], E_HImode))
            return 136; /* extendhisi2 */
          if (!mem_simple_ldst_operand (operands[1], E_HImode)
              || !
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)))
            return -1;
          return 474; /* simple_load_sexthisi */

        case 5:
          if (!
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)))
            return -1;
          return 476; /* simple_load_sextsisi */

        case 6:
          return 138; /* extendqihi2 */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern35 (x3) != 0
          || !
#line 3034 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 248; /* ashlsi3_extend */

    case ASHIFTRT:
      if (pattern35 (x3) != 0
          || !
#line 3034 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 249; /* ashrsi3_extend */

    case LSHIFTRT:
      if (pattern35 (x3) != 0
          || !
#line 3034 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 250; /* lshrsi3_extend */

    case ROTATERT:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!arith_operand (operands[2], E_SImode)
              || !
#line 3058 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 253; /* rotrsi3_extend */

        case BSWAP:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 3228 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 270; /* revb_2h_extend */

        default:
          return -1;
        }

    case BITREVERSE:
      if (pattern33 (x3) != 0
          || !
#line 4330 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 436; /* rbitsi_extended */

    case VEC_SELECT:
      switch (pattern42 (x3))
        {
        case 0:
          if (!
#line 468 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 952; /* lsx_vpickve2gr_h */

        case 1:
          if (!
#line 468 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 954; /* lsx_vpickve2gr_b */

        case 2:
          if (!
#line 479 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 956; /* lsx_vpickve2gr_w */

        case 3:
          if (!
#line 3148 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2067; /* lasx_xvpickve2gr_w */

        case 4:
          if (!
#line 479 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 958; /* lsx_vpickve2gr_w_f */

        case 5:
          if (!
#line 554 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1564; /* lasx_xvpickve2gr_d */

        case 6:
          if (!
#line 3009 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1473; /* vec_unpacks_hi_v16qi */

        case 7:
          if (!
#line 2381 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1925; /* vec_unpacks_lo_v16qi_internal */

        case 8:
          if (!
#line 2395 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1927; /* vec_unpacks_lo_v16hi */

        case 9:
          if (!
#line 2444 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1935; /* lasx_vext2xv_w_b */

        case 10:
          if (!
#line 3199 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2073; /* lasx_xvexth_w_h */

        case 11:
          if (!
#line 3021 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1475; /* vec_unpacks_hi_v8hi */

        case 12:
          if (!
#line 2407 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1929; /* vec_unpacks_lo_v8hi_internal */

        case 13:
          if (!
#line 2419 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1931; /* vec_unpacks_lo_v8si */

        case 14:
          if (!
#line 2456 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1937; /* lasx_vext2xv_d_h */

        case 15:
          if (!
#line 2468 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1939; /* lasx_vext2xv_d_b */

        case 16:
          if (!
#line 3211 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2075; /* lasx_xvexth_d_w */

        case 17:
          if (!
#line 3032 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1477; /* vec_unpacks_hi_v4si */

        case 18:
          if (!
#line 2430 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1933; /* vec_unpacks_lo_v4si_internal */

        case 19:
          if (!
#line 2367 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1923; /* vec_unpacks_lo_v32qi */

        case 20:
          if (!
#line 3185 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2071; /* lasx_xvexth_h_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_DUPLICATE)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  operands[3] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern169 (x2, 
E_DImode, 
E_V2DImode) != 0
              || !register_operand (operands[2], E_V2DImode)
              || !const_exp_2_operand (operands[3], E_VOIDmode)
              || !
#line 428 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 940; /* lsx_vinsgr2vr_d */

        case E_V4SImode:
          if (pattern170 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 428 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 941; /* lsx_vinsgr2vr_w */

        case E_V8HImode:
          if (pattern171 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 428 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 942; /* lsx_vinsgr2vr_h */

        case E_V16QImode:
          if (pattern169 (x2, 
E_QImode, 
E_V16QImode) != 0
              || !register_operand (operands[2], E_V16QImode)
              || !const_exp_16_operand (operands[3], E_VOIDmode)
              || !
#line 428 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 943; /* lsx_vinsgr2vr_b */

        case E_V2DFmode:
          if (pattern172 (x2, 
E_DFmode, 
E_V2DFmode) != 0
              || !register_operand (operands[2], E_V2DFmode)
              || !const_exp_2_operand (operands[3], E_VOIDmode)
              || !
#line 457 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 950; /* lsx_vextrins_d_f_scalar */

        case E_V4SFmode:
          if (pattern173 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 457 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 951; /* lsx_vextrins_w_f_scalar */

        case E_V4DImode:
          if (pattern170 (x2, 
E_V4DImode, 
E_DImode) != 0
              || !
#line 455 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1534; /* lasx_xvinsgr2vr_d */

        case E_V8SImode:
          if (pattern171 (x2, 
E_V8SImode, 
E_SImode) != 0
              || !
#line 455 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1535; /* lasx_xvinsgr2vr_w */

        case E_V4DFmode:
          if (pattern173 (x2, 
E_V4DFmode, 
E_DFmode) != 0
              || !
#line 3504 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2146; /* lasx_xvinsve0_d_f_scalar */

        case E_V8SFmode:
          if (pattern172 (x2, 
E_SFmode, 
E_V8SFmode) != 0
              || !register_operand (operands[2], E_V8SFmode)
              || !const_exp_8_operand (operands[3], E_VOIDmode)
              || !
#line 3504 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2147; /* lasx_xvinsve0_w_f_scalar */

        default:
          return -1;
        }

    case VEC_SELECT:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XVECEXP (x8, 0, 0);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern197 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 444 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 944; /* lsx_vextrins_d_internal */

        case E_V4SImode:
          if (pattern198 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 444 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 945; /* lsx_vextrins_w_internal */

        case E_V8HImode:
          if (pattern199 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !register_operand (operands[2], E_V8HImode)
              || !const_exp_8_operand (operands[3], E_VOIDmode)
              || !
#line 444 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 946; /* lsx_vextrins_h_internal */

        case E_V16QImode:
          if (pattern199 (x2, 
E_V16QImode, 
E_QImode) != 0
              || !register_operand (operands[2], E_V16QImode)
              || !const_exp_16_operand (operands[3], E_VOIDmode)
              || !
#line 444 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 947; /* lsx_vextrins_b_internal */

        case E_V2DFmode:
          if (pattern197 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 444 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 948; /* lsx_vextrins_d_f_internal */

        case E_V4SFmode:
          if (pattern198 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 444 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 949; /* lsx_vextrins_w_f_internal */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          switch (pattern105 (x3))
            {
            case 0:
              if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 285; /* *seq_zero_sisi */

            case 1:
              if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 286; /* *seq_zero_disi */

            case 2:
              if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 287; /* *seq_zero_didi */

            default:
              return -1;
            }

        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_FCCmode:
              switch (pattern11 (x3))
                {
                case 0:
                  if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 313; /* seq_sf_using_FCCmode */

                case 1:
                  if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                    return -1;
                  return 327; /* seq_df_using_FCCmode */

                default:
                  return -1;
                }

            case E_V2DImode:
              switch (pattern117 (x3))
                {
                case 0:
                  if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 663; /* lsx_vfcmp_ceq_d */

                case 1:
                  if (!
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1117; /* lsx_vseq_d */

                default:
                  return -1;
                }

            case E_V4SImode:
              switch (pattern118 (x3))
                {
                case 0:
                  if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 673; /* lsx_vfcmp_ceq_s */

                case 1:
                  if (!
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1122; /* lsx_vseq_w */

                default:
                  return -1;
                }

            case E_V4DImode:
              switch (pattern119 (x3))
                {
                case 0:
                  if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 683; /* lasx_xvfcmp_ceq_d */

                case 1:
                  if (!
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1721; /* lasx_xvseq_d */

                default:
                  return -1;
                }

            case E_V8SImode:
              switch (pattern120 (x3))
                {
                case 0:
                  if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 693; /* lasx_xvfcmp_ceq_s */

                case 1:
                  if (!
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1726; /* lasx_xvseq_w */

                default:
                  return -1;
                }

            case E_V8HImode:
              if (pattern2 (x3, 
E_V8HImode) != 0
                  || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1127; /* lsx_vseq_h */

            case E_V16QImode:
              if (pattern2 (x3, 
E_V16QImode) != 0
                  || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1132; /* lsx_vseq_b */

            case E_V16HImode:
              if (pattern2 (x3, 
E_V16HImode) != 0
                  || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1731; /* lasx_xvseq_h */

            case E_V32QImode:
              if (pattern2 (x3, 
E_V32QImode) != 0
                  || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1736; /* lasx_xvseq_b */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 135
          || GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_FCCmode)
          || GET_MODE (x3) != E_FCCmode)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!const_0_operand (operands[2], E_SImode)
          || !
#line 2776 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1468; /* lsx_vseteqz_v */

    default:
      return -1;
    }
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x5;
      if (!call_insn_operand (operands[1], E_VOIDmode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (
#line 3867 "../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn)))
        return 357; /* sibcall_value_internal */
      if (pnum_clobbers == NULL)
        return -1;
      *pnum_clobbers = 1;
      return 366; /* call_value_internal */

    case LO_SUM:
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !symbolic_operand (operands[2], E_SImode))
            return -1;
          if ((
#line 3894 "../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
            return 358; /* sibcall_value_internal_1si */
          if (pnum_clobbers == NULL
              || !(
#line 4068 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
            return -1;
          *pnum_clobbers = 1;
          return 367; /* call_value_internal_1si */

        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !symbolic_operand (operands[2], E_DImode))
            return -1;
          if ((
#line 3894 "../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
            return 359; /* sibcall_value_internal_1di */
          if (pnum_clobbers == NULL
              || !(
#line 4068 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
            return -1;
          *pnum_clobbers = 1;
          return 368; /* call_value_internal_1di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (XVECLEN (x3, 0))
        {
        case 2:
          if (XINT (x3, 1) != 39
              || GET_MODE (x3) != E_DImode)
            return -1;
          x5 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x5) != PC)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != UNSPEC
              || XVECLEN (x7, 0) != 2
              || XINT (x7, 1) != 40
              || GET_MODE (x7) != E_DImode)
            return -1;
          x8 = XVECEXP (x7, 0, 1);
          if (GET_CODE (x8) != PC
              || !register_operand (operands[0], E_DImode))
            return -1;
          x9 = XVECEXP (x3, 0, 0);
          operands[2] = x9;
          x10 = XEXP (x6, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x11 = XVECEXP (x7, 0, 0);
          if (!rtx_equal_p (x11, operands[2])
              || !
#line 2278 "../../gcc/config/loongarch/loongarch.md"
(TARGET_ABI_LP64 && la_opt_explicit_relocs != EXPLICIT_RELOCS_NONE))
            return -1;
          return 155; /* la_pcrel64_two_parts */

        case 1:
          if (XINT (x3, 1) != 52
              || GET_MODE (x3) != E_BLKmode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          operands[1] = x6;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x9 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x9, operands[0]))
            return -1;
          return 490; /* mem_thread_fence_1 */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (XVECLEN (x3, 0))
        {
        case 1:
          if (pattern122 (x1) != 0)
            return -1;
          switch (XINT (x3, 1))
            {
            case 3:
              if (!const_uimm14_operand (operands[1], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode)
                    return -1;
                  return 222; /* loongarch_csrrd_w */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 223; /* loongarch_csrrd_d */

                default:
                  return -1;
                }

            case 6:
              if (!register_operand (operands[1], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (!register_operand (operands[0], E_QImode)
                      || GET_MODE (x3) != E_QImode)
                    return -1;
                  return 228; /* loongarch_iocsrrd_b */

                case E_HImode:
                  if (!register_operand (operands[0], E_HImode)
                      || GET_MODE (x3) != E_HImode)
                    return -1;
                  return 229; /* loongarch_iocsrrd_h */

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode)
                    return -1;
                  return 230; /* loongarch_iocsrrd_w */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !
#line 401 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 231; /* loongarch_iocsrrd_d */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x9 = XVECEXP (x3, 0, 0);
          operands[1] = x9;
          switch (XINT (x3, 1))
            {
            case 4:
              x6 = XVECEXP (x1, 0, 1);
              if (pattern19 (x6) != 0)
                return -1;
              x5 = XVECEXP (x3, 0, 1);
              operands[2] = x5;
              if (!const_uimm14_operand (operands[2], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode
                      || !register_operand (operands[1], E_SImode))
                    return -1;
                  return 224; /* loongarch_csrwr_w */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !register_operand (operands[1], E_DImode)
                      || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 225; /* loongarch_csrwr_d */

                default:
                  return -1;
                }

            case 49:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              x5 = XVECEXP (x3, 0, 1);
              operands[3] = x5;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              x7 = XEXP (x6, 1);
              operands[2] = x7;
              x10 = XEXP (x6, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern209 (x3, 
E_SImode) != 0)
                    return -1;
                  return 517; /* atomic_exchangesi */

                case E_DImode:
                  if (pattern209 (x3, 
E_DImode) != 0
                      || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 518; /* atomic_exchangedi */

                case E_QImode:
                  if (pattern209 (x3, 
E_QImode) != 0
                      || !
#line 233 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAM_BH))
                    return -1;
                  return 519; /* atomic_exchangeqi_short */

                case E_HImode:
                  if (pattern209 (x3, 
E_HImode) != 0
                      || !
#line 233 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAM_BH))
                    return -1;
                  return 520; /* atomic_exchangehi_short */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          if (XINT (x3, 1) != 5
              || pattern122 (x1) != 0)
            return -1;
          x5 = XVECEXP (x3, 0, 1);
          operands[2] = x5;
          x12 = XVECEXP (x3, 0, 2);
          operands[3] = x12;
          if (!const_uimm14_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern213 (x3, 
E_SImode) != 0)
                return -1;
              return 226; /* loongarch_csrxchg_w */

            case E_DImode:
              if (pattern213 (x3, 
E_DImode) != 0
                  || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 227; /* loongarch_csrxchg_d */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      return recog_132 (x1, insn, pnum_clobbers);

    case CALL:
      x13 = XEXP (x3, 0);
      if (GET_CODE (x13) != MEM)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x14 = XEXP (x13, 0);
      switch (GET_CODE (x14))
        {
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x14;
          if (!call_insn_operand (operands[1], E_VOIDmode)
              || GET_MODE (x13) != E_SImode)
            return -1;
          x15 = XEXP (x3, 1);
          operands[2] = x15;
          x6 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x6))
            {
            case SET:
              x7 = XEXP (x6, 1);
              if (GET_CODE (x7) != CALL)
                return -1;
              x16 = XEXP (x7, 0);
              if (GET_CODE (x16) != MEM
                  || GET_MODE (x16) != E_SImode)
                return -1;
              x10 = XEXP (x6, 0);
              operands[3] = x10;
              if (!register_operand (operands[3], E_VOIDmode))
                return -1;
              x17 = XEXP (x16, 0);
              if (!rtx_equal_p (x17, operands[1]))
                return -1;
              x18 = XEXP (x7, 1);
              if (!rtx_equal_p (x18, operands[2]))
                return -1;
              if (
#line 3905 "../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn)))
                return 360; /* sibcall_value_multiple_internal */
              if (pnum_clobbers == NULL)
                return -1;
              *pnum_clobbers = 1;
              return 369; /* call_value_multiple_internal */

            case CLOBBER:
              x10 = XEXP (x6, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 1
                  || GET_MODE (x10) != E_SImode)
                return -1;
              return 366; /* call_value_internal */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x14, 0) != 2)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != CALL)
            return -1;
          x16 = XEXP (x7, 0);
          if (GET_CODE (x16) != MEM)
            return -1;
          x17 = XEXP (x16, 0);
          if (GET_CODE (x17) != UNSPEC
              || XVECLEN (x17, 0) != 2)
            return -1;
          x19 = XVECEXP (x14, 0, 0);
          operands[1] = x19;
          x20 = XVECEXP (x14, 0, 1);
          operands[2] = x20;
          x15 = XEXP (x3, 1);
          operands[3] = x15;
          x10 = XEXP (x6, 0);
          operands[4] = x10;
          if (!register_operand (operands[4], E_VOIDmode))
            return -1;
          x21 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x21, operands[1]))
            return -1;
          x22 = XVECEXP (x17, 0, 1);
          if (!rtx_equal_p (x22, operands[2]))
            return -1;
          x18 = XEXP (x7, 1);
          if (!rtx_equal_p (x18, operands[3]))
            return -1;
          switch (XINT (x14, 1))
            {
            case 36:
              if (XINT (x17, 1) != 36)
                return -1;
              switch (GET_MODE (x13))
                {
                case E_SImode:
                  if (pattern220 (x1, 
E_SImode) != 0
                      || !(
#line 3938 "../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                    return -1;
                  return 361; /* sibcall_value_multiple_internal_1si */

                case E_DImode:
                  if (pattern220 (x1, 
E_DImode) != 0
                      || !(
#line 3938 "../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                    return -1;
                  return 362; /* sibcall_value_multiple_internal_1di */

                default:
                  return -1;
                }

            case 37:
              if (pnum_clobbers == NULL
                  || XINT (x17, 1) != 37)
                return -1;
              switch (GET_MODE (x13))
                {
                case E_SImode:
                  if (pattern220 (x1, 
E_SImode) != 0
                      || !(
#line 4114 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 370; /* call_value_multiple_internal_1si */

                case E_DImode:
                  if (pattern220 (x1, 
E_DImode) != 0
                      || !(
#line 4114 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 371; /* call_value_multiple_internal_1di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case LO_SUM:
          x6 = XVECEXP (x1, 0, 1);
          if (pattern99 (x6) != 0)
            return -1;
          x23 = XEXP (x14, 0);
          operands[1] = x23;
          x24 = XEXP (x14, 1);
          operands[2] = x24;
          x15 = XEXP (x3, 1);
          operands[3] = x15;
          switch (GET_MODE (x13))
            {
            case E_SImode:
              if (GET_MODE (x14) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !symbolic_operand (operands[2], E_SImode)
                  || !(
#line 4068 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                return -1;
              return 367; /* call_value_internal_1si */

            case E_DImode:
              if (GET_MODE (x14) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !symbolic_operand (operands[2], E_DImode)
                  || !(
#line 4068 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                return -1;
              return 368; /* call_value_internal_1di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern96 (x1, 
SIGN_EXTEND) != 0
          || !
#line 4447 "../../gcc/config/loongarch/loongarch.md"
(reload_completed))
        return -1;
      return 444; /* *join2_loadhi */

    case ZERO_EXTEND:
      if (pattern96 (x1, 
ZERO_EXTEND) != 0
          || !
#line 4447 "../../gcc/config/loongarch/loongarch.md"
(reload_completed))
        return -1;
      return 445; /* *join2_loadhi */

    case SMUL_HIGHPART:
      switch (pattern98 (x1, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 603; /* smulv2di3_highpart */

        case 1:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 605; /* smulv4si3_highpart */

        case 2:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 607; /* smulv8hi3_highpart */

        case 3:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 609; /* smulv16qi3_highpart */

        case 4:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 611; /* smulv4di3_highpart */

        case 5:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 613; /* smulv8si3_highpart */

        case 6:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 615; /* smulv16hi3_highpart */

        case 7:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 617; /* smulv32qi3_highpart */

        default:
          return -1;
        }

    case UMUL_HIGHPART:
      switch (pattern98 (x1, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 604; /* umulv2di3_highpart */

        case 1:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 606; /* umulv4si3_highpart */

        case 2:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 608; /* umulv8hi3_highpart */

        case 3:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 610; /* umulv16qi3_highpart */

        case 4:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 612; /* umulv4di3_highpart */

        case 5:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 614; /* umulv8si3_highpart */

        case 6:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 616; /* umulv16hi3_highpart */

        case 7:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 618; /* umulv32qi3_highpart */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x15 = XEXP (x3, 1);
      if (GET_CODE (x15) != LABEL_REF)
        return -1;
      x25 = XEXP (x3, 2);
      if (GET_CODE (x25) != PC)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x26 = XEXP (x15, 0);
      operands[0] = x26;
      x10 = XEXP (x6, 0);
      operands[3] = x10;
      if (!scratch_operand (operands[3], E_FCCmode))
        return -1;
      x13 = XEXP (x3, 0);
      switch (GET_CODE (x13))
        {
        case EQ:
          switch (pattern203 (x13))
            {
            case 0:
              if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1288; /* lsx_bz_d */

            case 1:
              if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1290; /* lsx_bz_w */

            case 2:
              if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1292; /* lsx_bz_h */

            case 3:
              if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1294; /* lsx_bz_b */

            case 4:
              if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1296; /* lsx_bz_d_f */

            case 5:
              if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1298; /* lsx_bz_w_f */

            case 6:
              if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1300; /* lsx_bz_v_d */

            case 7:
              if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1302; /* lsx_bz_v_w */

            case 8:
              if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1304; /* lsx_bz_v_h */

            case 9:
              if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1306; /* lsx_bz_v_b */

            case 10:
              if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1308; /* lsx_bz_v_d_f */

            case 11:
              if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1310; /* lsx_bz_v_w_f */

            case 12:
              if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1899; /* lasx_xbz_d */

            case 13:
              if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1901; /* lasx_xbz_w */

            case 14:
              if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1903; /* lasx_xbz_h */

            case 15:
              if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1905; /* lasx_xbz_b */

            case 16:
              if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1907; /* lasx_xbz_d_f */

            case 17:
              if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1909; /* lasx_xbz_w_f */

            case 18:
              if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1911; /* lasx_xbz_v_d */

            case 19:
              if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1913; /* lasx_xbz_v_w */

            case 20:
              if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1915; /* lasx_xbz_v_h */

            case 21:
              if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1917; /* lasx_xbz_v_b */

            case 22:
              if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1919; /* lasx_xbz_v_d_f */

            case 23:
              if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1921; /* lasx_xbz_v_w_f */

            default:
              return -1;
            }

        case NE:
          switch (pattern203 (x13))
            {
            case 0:
              if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1289; /* lsx_bnz_d */

            case 1:
              if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1291; /* lsx_bnz_w */

            case 2:
              if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1293; /* lsx_bnz_h */

            case 3:
              if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1295; /* lsx_bnz_b */

            case 4:
              if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1297; /* lsx_bnz_d_f */

            case 5:
              if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1299; /* lsx_bnz_w_f */

            case 6:
              if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1301; /* lsx_bnz_v_d */

            case 7:
              if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1303; /* lsx_bnz_v_w */

            case 8:
              if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1305; /* lsx_bnz_v_h */

            case 9:
              if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1307; /* lsx_bnz_v_b */

            case 10:
              if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1309; /* lsx_bnz_v_d_f */

            case 11:
              if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1311; /* lsx_bnz_v_w_f */

            case 12:
              if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1900; /* lasx_xbnz_d */

            case 13:
              if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1902; /* lasx_xbnz_w */

            case 14:
              if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1904; /* lasx_xbnz_h */

            case 15:
              if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1906; /* lasx_xbnz_b */

            case 16:
              if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1908; /* lasx_xbnz_d_f */

            case 17:
              if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1910; /* lasx_xbnz_w_f */

            case 18:
              if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1912; /* lasx_xbnz_v_d */

            case 19:
              if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1914; /* lasx_xbnz_v_w */

            case 20:
              if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1916; /* lasx_xbnz_v_h */

            case 21:
              if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1918; /* lasx_xbnz_v_b */

            case 22:
              if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1920; /* lasx_xbnz_v_d_f */

            case 23:
              if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1922; /* lasx_xbnz_v_w_f */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
