/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_vector_same_val_operand (operands[2], i1)
      || !const_uimm3_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern16 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_uimm5_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH)
    return -1;
  return 0;
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern20 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern20 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || pattern26 (x1, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          return 0;

        case E_QImode:
          return 1;

        case E_HImode:
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          return 3;

        case E_HImode:
          return 4;

        case E_SImode:
          if (!mem_simple_ldst_operand (operands[1], E_SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !symbolic_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !symbolic_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !const_uimm5_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V2DImode)
          || !const_uimm6_operand (operands[2], E_VOIDmode))
        return -1;
      return 0;

    case E_V8HImode:
      if (pattern68 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern69 (x3, 
E_V16QImode, 
E_V8HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern98 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern97 (x6, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern97 (x6, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern97 (x6, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern97 (x6, 
E_V16QImode) != 0)
        return -1;
      return 3;

    case E_V4DImode:
      if (pattern97 (x6, 
E_V4DImode) != 0)
        return -1;
      return 4;

    case E_V8SImode:
      if (pattern97 (x6, 
E_V8SImode) != 0)
        return -1;
      return 5;

    case E_V16HImode:
      if (pattern97 (x6, 
E_V16HImode) != 0)
        return -1;
      return 6;

    case E_V32QImode:
      if (pattern97 (x6, 
E_V32QImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode)
      || !reg_or_0_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8SImode)
      || GET_MODE (x1) != E_V8SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SFmode)
          || !register_operand (operands[2], E_V8SFmode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode)
          || !reg_or_vector_same_simm5_operand (operands[2], E_V8SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern129 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_vector_1_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern135 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern143 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_uimm8_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern148 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      x3 = XEXP (x1, 2);
      if (GET_CODE (x3) != PC)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      return pattern147 (); /* [-1, 1] */

    case PC:
      x3 = XEXP (x1, 2);
      if (GET_CODE (x3) != LABEL_REF)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      res = pattern147 ();
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern159 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !symbolic_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern165 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern171 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !const_exp_8_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern179 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern187 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_even_or_odd_half (operands[4], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i4)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i3
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern202 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 2;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode))
        return -1;
      return 3;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 4;

    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern215 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (pattern80 (x3))
    {
    case 0:
      if (!
#line 2687 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2008; /* lasx_xvmskltz_d */

    case 1:
      if (!
#line 2687 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2009; /* lasx_xvmskltz_w */

    case 2:
      if (!
#line 2687 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2010; /* lasx_xvmskltz_h */

    case 3:
      if (!
#line 2687 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2011; /* lasx_xvmskltz_b */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern50 (x1))
    {
    case 0:
      if (!(
#line 2724 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (11 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && 
#line 409 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
        return -1;
      return 200; /* lceilsfsi2 */

    case 1:
      if (!(
#line 2724 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (11 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && (
#line 409 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))))
        return -1;
      return 206; /* lceildfsi2 */

    case 2:
      if (!(
#line 2724 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (11 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && (
#line 410 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))))
        return -1;
      return 203; /* lceilsfdi2 */

    case 3:
      if (!(
#line 2724 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (11 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && 
#line 410 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
        return -1;
      return 209; /* lceildfdi2 */

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  switch (pattern136 (x5))
    {
    case 0:
      return 446; /* loongarch_crc_w_b_w */

    case 1:
      return 448; /* loongarch_crc_w_h_w */

    case 2:
      return 450; /* loongarch_crc_w_w_w */

    case 3:
      if (
#line 401 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return 452; /* loongarch_crc_w_d_w */
      break;

    default:
      break;
    }
  if (GET_CODE (x4) != REG)
    return -1;
  switch (pattern138 (x2))
    {
    case 0:
      if (!
#line 4571 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()))
        return -1;
      return 462; /* *crc_combine */

    case 1:
      if (!
#line 4571 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()))
        return -1;
      return 464; /* *crc_combine */

    case 2:
      if (!
#line 4571 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()))
        return -1;
      return 466; /* *crc_combine */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern77 (x1))
    {
    case 0:
      if (!
#line 1980 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1839; /* lasx_xvsat_u_du */

    case 1:
      if (!
#line 1980 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1840; /* lasx_xvsat_u_wu */

    case 2:
      if (!
#line 1980 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1841; /* lasx_xvsat_u_hu */

    case 3:
      if (!
#line 1980 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1842; /* lasx_xvsat_u_bu */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 1106 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1686; /* lasx_xvavgr_u_du */

    case 1:
      if (!
#line 1106 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1687; /* lasx_xvavgr_u_wu */

    case 2:
      if (!
#line 1106 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1688; /* lasx_xvavgr_u_hu */

    case 3:
      if (!
#line 1106 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1689; /* lasx_xvavgr_u_bu */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern67 (x1))
    {
    case 0:
      if (!
#line 1665 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1229; /* lsx_vsat_s_d */

    case 1:
      if (!
#line 1665 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1230; /* lsx_vsat_s_w */

    case 2:
      if (!
#line 1665 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1231; /* lsx_vsat_s_h */

    case 3:
      if (!
#line 1665 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1232; /* lsx_vsat_s_b */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 946 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1076; /* lsx_vavg_u_du */

    case 1:
      if (!
#line 946 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1077; /* lsx_vavg_u_wu */

    case 2:
      if (!
#line 946 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1078; /* lsx_vavg_u_hu */

    case 3:
      if (!
#line 946 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1079; /* lsx_vavg_u_bu */

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 12:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern134 (x2, 
E_SImode, 
E_SFmode) != 0
              || !
#line 1370 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 71; /* ldexpsf3 */

        case E_DFmode:
          if (pattern134 (x2, 
E_DImode, 
E_DFmode) != 0
              || !(
#line 1370 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 72; /* ldexpdf3 */

        default:
          return -1;
        }

    case 7:
      return recog_26 (x1, insn, pnum_clobbers);

    case 8:
      return recog_25 (x1, insn, pnum_clobbers);

    case 30:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern135 (x2, 
E_SImode) != 0
              || !
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return -1;
          return 192; /* ori_l_lo12si */

        case E_DImode:
          if (pattern135 (x2, 
E_DImode) != 0
              || !
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return -1;
          return 193; /* ori_l_lo12di */

        default:
          return -1;
        }

    case 32:
      if (pattern60 (x1) != 0
          || !
#line 2694 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 194; /* lui_h_lo20 */

    case 33:
      if (pattern60 (x1) != 0
          || !
#line 2704 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 195; /* lui_h_hi12 */

    case 20:
      return recog_18 (x1, insn, pnum_clobbers);

    case 24:
      return recog_21 (x1, insn, pnum_clobbers);

    case 25:
      return recog_22 (x1, insn, pnum_clobbers);

    case 58:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 747; /* lsx_vfcmp_caf_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 755; /* lsx_vfcmp_caf_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 763; /* lasx_xvfcmp_caf_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 771; /* lasx_xvfcmp_caf_s */

        default:
          return -1;
        }

    case 59:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 748; /* lsx_vfcmp_saf_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 756; /* lsx_vfcmp_saf_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 764; /* lasx_xvfcmp_saf_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 772; /* lasx_xvfcmp_saf_s */

        default:
          return -1;
        }

    case 60:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 749; /* lsx_vfcmp_seq_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 757; /* lsx_vfcmp_seq_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 765; /* lasx_xvfcmp_seq_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 773; /* lasx_xvfcmp_seq_s */

        default:
          return -1;
        }

    case 61:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 750; /* lsx_vfcmp_sun_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 758; /* lsx_vfcmp_sun_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 766; /* lasx_xvfcmp_sun_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 774; /* lasx_xvfcmp_sun_s */

        default:
          return -1;
        }

    case 62:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 751; /* lsx_vfcmp_sueq_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 759; /* lsx_vfcmp_sueq_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 767; /* lasx_xvfcmp_sueq_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 775; /* lasx_xvfcmp_sueq_s */

        default:
          return -1;
        }

    case 63:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 752; /* lsx_vfcmp_cne_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 760; /* lsx_vfcmp_cne_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 768; /* lasx_xvfcmp_cne_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 776; /* lasx_xvfcmp_cne_s */

        default:
          return -1;
        }

    case 64:
      return recog_65 (x1, insn, pnum_clobbers);

    case 65:
      return recog_64 (x1, insn, pnum_clobbers);

    case 66:
      return recog_63 (x1, insn, pnum_clobbers);

    case 67:
      return recog_62 (x1, insn, pnum_clobbers);

    case 68:
      return recog_61 (x1, insn, pnum_clobbers);

    case 69:
      return recog_60 (x1, insn, pnum_clobbers);

    case 70:
      return recog_59 (x1, insn, pnum_clobbers);

    case 71:
      return recog_58 (x1, insn, pnum_clobbers);

    case 72:
      return recog_57 (x1, insn, pnum_clobbers);

    case 73:
      return recog_28 (x1, insn, pnum_clobbers);

    case 74:
      return recog_56 (x1, insn, pnum_clobbers);

    case 75:
      return recog_54 (x1, insn, pnum_clobbers);

    case 156:
      return recog_55 (x1, insn, pnum_clobbers);

    case 87:
      return recog_53 (x1, insn, pnum_clobbers);

    case 88:
      return recog_52 (x1, insn, pnum_clobbers);

    case 89:
      return recog_51 (x1, insn, pnum_clobbers);

    case 90:
      return recog_50 (x1, insn, pnum_clobbers);

    case 157:
      return recog_17 (x1, insn, pnum_clobbers);

    case 79:
      return recog_49 (x1, insn, pnum_clobbers);

    case 94:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 2062 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1330; /* lsx_vsllwil_s_d_w */

        case 1:
          if (!
#line 2062 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1331; /* lsx_vsllwil_s_w_h */

        case 2:
          if (!
#line 2062 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1332; /* lsx_vsllwil_s_h_b */

        default:
          return -1;
        }

    case 95:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 2072 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1333; /* lsx_vsllwil_u_du_wu */

        case 1:
          if (!
#line 2072 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1334; /* lsx_vsllwil_u_wu_hu */

        case 2:
          if (!
#line 2072 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1335; /* lsx_vsllwil_u_hu_bu */

        default:
          return -1;
        }

    case 96:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2082 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1336; /* lsx_vsran_w_d */

        case 1:
          if (!
#line 2082 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1337; /* lsx_vsran_h_w */

        case 2:
          if (!
#line 2082 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1338; /* lsx_vsran_b_h */

        default:
          return -1;
        }

    case 97:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2092 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1339; /* lsx_vssran_s_w_d */

        case 1:
          if (!
#line 2092 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1340; /* lsx_vssran_s_h_w */

        case 2:
          if (!
#line 2092 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1341; /* lsx_vssran_s_b_h */

        default:
          return -1;
        }

    case 98:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2102 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1342; /* lsx_vssran_u_wu_d */

        case 1:
          if (!
#line 2102 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1343; /* lsx_vssran_u_hu_w */

        case 2:
          if (!
#line 2102 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1344; /* lsx_vssran_u_bu_h */

        default:
          return -1;
        }

    case 99:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1345; /* lsx_vsrain_w */

        case 1:
          if (!
#line 2112 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1346; /* lsx_vsrain_h */

        case 2:
          if (!
#line 2112 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1347; /* lsx_vsrain_b */

        default:
          return -1;
        }

    case 100:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 2123 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1348; /* lsx_vsrains_s_w */

        case 1:
          if (!
#line 2123 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1349; /* lsx_vsrains_s_h */

        case 2:
          if (!
#line 2123 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1350; /* lsx_vsrains_s_b */

        default:
          return -1;
        }

    case 101:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 2134 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1351; /* lsx_vsrains_u_w */

        case 1:
          if (!
#line 2134 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1352; /* lsx_vsrains_u_h */

        case 2:
          if (!
#line 2134 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1353; /* lsx_vsrains_u_b */

        default:
          return -1;
        }

    case 102:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2144 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1354; /* lsx_vsrarn_w_d */

        case 1:
          if (!
#line 2144 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1355; /* lsx_vsrarn_h_w */

        case 2:
          if (!
#line 2144 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1356; /* lsx_vsrarn_b_h */

        default:
          return -1;
        }

    case 126:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2154 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1357; /* lsx_vssrarn_s_w_d */

        case 1:
          if (!
#line 2154 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1358; /* lsx_vssrarn_s_h_w */

        case 2:
          if (!
#line 2154 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1359; /* lsx_vssrarn_s_b_h */

        default:
          return -1;
        }

    case 127:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2164 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1360; /* lsx_vssrarn_u_wu_d */

        case 1:
          if (!
#line 2164 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1361; /* lsx_vssrarn_u_hu_w */

        case 2:
          if (!
#line 2164 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1362; /* lsx_vssrarn_u_bu_h */

        default:
          return -1;
        }

    case 103:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2174 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1363; /* lsx_vsrln_w_d */

        case 1:
          if (!
#line 2174 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1364; /* lsx_vsrln_h_w */

        case 2:
          if (!
#line 2174 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1365; /* lsx_vsrln_b_h */

        default:
          return -1;
        }

    case 128:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2184 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1366; /* lsx_vssrln_u_wu_d */

        case 1:
          if (!
#line 2184 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1367; /* lsx_vssrln_u_hu_w */

        case 2:
          if (!
#line 2184 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1368; /* lsx_vssrln_u_bu_h */

        default:
          return -1;
        }

    case 104:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2194 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1369; /* lsx_vsrlrn_w_d */

        case 1:
          if (!
#line 2194 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1370; /* lsx_vsrlrn_h_w */

        case 2:
          if (!
#line 2194 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1371; /* lsx_vsrlrn_b_h */

        default:
          return -1;
        }

    case 105:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2204 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1372; /* lsx_vssrlrn_u_wu_d */

        case 1:
          if (!
#line 2204 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1373; /* lsx_vssrlrn_u_hu_w */

        case 2:
          if (!
#line 2204 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1374; /* lsx_vssrlrn_u_bu_h */

        default:
          return -1;
        }

    case 109:
      return recog_14 (x1, insn, pnum_clobbers);

    case 110:
      return recog_27 (x1, insn, pnum_clobbers);

    case 113:
      return recog_48 (x1, insn, pnum_clobbers);

    case 114:
      if (pattern74 (x1, 
E_V2DFmode, 
E_V4SImode) != 0
          || !
#line 2411 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1412; /* lsx_vftint_w_d */

    case 115:
      if (pattern74 (x1, 
E_V2DFmode, 
E_V4SImode) != 0
          || !
#line 2441 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1415; /* lsx_vftintrp_w_d */

    case 116:
      if (pattern74 (x1, 
E_V2DFmode, 
E_V4SImode) != 0
          || !
#line 2451 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1416; /* lsx_vftintrm_w_d */

    case 117:
      if (pattern74 (x1, 
E_V2DFmode, 
E_V4SImode) != 0
          || !
#line 2461 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1417; /* lsx_vftintrne_w_d */

    case 129:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2690 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1454; /* lsx_vssrln_w_d */

        case 1:
          if (!
#line 2690 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1455; /* lsx_vssrln_h_w */

        case 2:
          if (!
#line 2690 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1456; /* lsx_vssrln_b_h */

        default:
          return -1;
        }

    case 130:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2701 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1457; /* lsx_vssrlrn_w_d */

        case 1:
          if (!
#line 2701 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1458; /* lsx_vssrlrn_h_w */

        case 2:
          if (!
#line 2701 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1459; /* lsx_vssrlrn_b_h */

        default:
          return -1;
        }

    case 136:
      if (pattern75 (x1) != 0
          || !
#line 2967 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1469; /* lsx_vadd_q */

    case 137:
      if (pattern75 (x1) != 0
          || !
#line 2977 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1470; /* lsx_vsub_q */

    case 225:
      return recog_19 (x1, insn, pnum_clobbers);

    case 227:
      return recog_24 (x1, insn, pnum_clobbers);

    case 158:
      return recog_47 (x1, insn, pnum_clobbers);

    case 159:
      return recog_46 (x1, insn, pnum_clobbers);

    case 160:
      return recog_45 (x1, insn, pnum_clobbers);

    case 161:
      return recog_44 (x1, insn, pnum_clobbers);

    case 162:
      return recog_43 (x1, insn, pnum_clobbers);

    case 163:
      return recog_42 (x1, insn, pnum_clobbers);

    case 164:
      return recog_41 (x1, insn, pnum_clobbers);

    case 165:
      return recog_40 (x1, insn, pnum_clobbers);

    case 166:
      return recog_39 (x1, insn, pnum_clobbers);

    case 167:
      return recog_38 (x1, insn, pnum_clobbers);

    case 258:
      return recog_37 (x1, insn, pnum_clobbers);

    case 177:
      return recog_36 (x1, insn, pnum_clobbers);

    case 178:
      return recog_35 (x1, insn, pnum_clobbers);

    case 200:
      return recog_15 (x1, insn, pnum_clobbers);

    case 180:
      return recog_34 (x1, insn, pnum_clobbers);

    case 181:
      return recog_33 (x1, insn, pnum_clobbers);

    case 179:
      return recog_16 (x1, insn, pnum_clobbers);

    case 169:
      return recog_31 (x1, insn, pnum_clobbers);

    case 186:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2504 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1955; /* lasx_xvsllwil_s_d_w */

        case 1:
          if (!
#line 2504 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1956; /* lasx_xvsllwil_s_w_h */

        case 2:
          if (!
#line 2504 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1957; /* lasx_xvsllwil_s_h_b */

        default:
          return -1;
        }

    case 187:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2514 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1958; /* lasx_xvsllwil_u_du_wu */

        case 1:
          if (!
#line 2514 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1959; /* lasx_xvsllwil_u_wu_hu */

        case 2:
          if (!
#line 2514 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1960; /* lasx_xvsllwil_u_hu_bu */

        default:
          return -1;
        }

    case 188:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2524 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1961; /* lasx_xvsran_w_d */

        case 1:
          if (!
#line 2524 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1962; /* lasx_xvsran_h_w */

        case 2:
          if (!
#line 2524 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1963; /* lasx_xvsran_b_h */

        default:
          return -1;
        }

    case 189:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2534 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1964; /* lasx_xvssran_s_w_d */

        case 1:
          if (!
#line 2534 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1965; /* lasx_xvssran_s_h_w */

        case 2:
          if (!
#line 2534 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1966; /* lasx_xvssran_s_b_h */

        default:
          return -1;
        }

    case 190:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2544 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1967; /* lasx_xvssran_u_wu_d */

        case 1:
          if (!
#line 2544 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1968; /* lasx_xvssran_u_hu_w */

        case 2:
          if (!
#line 2544 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1969; /* lasx_xvssran_u_bu_h */

        default:
          return -1;
        }

    case 191:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2554 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1970; /* lasx_xvsrarn_w_d */

        case 1:
          if (!
#line 2554 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1971; /* lasx_xvsrarn_h_w */

        case 2:
          if (!
#line 2554 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1972; /* lasx_xvsrarn_b_h */

        default:
          return -1;
        }

    case 192:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2564 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1973; /* lasx_xvssrarn_s_w_d */

        case 1:
          if (!
#line 2564 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1974; /* lasx_xvssrarn_s_h_w */

        case 2:
          if (!
#line 2564 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1975; /* lasx_xvssrarn_s_b_h */

        default:
          return -1;
        }

    case 193:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2574 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1976; /* lasx_xvssrarn_u_wu_d */

        case 1:
          if (!
#line 2574 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1977; /* lasx_xvssrarn_u_hu_w */

        case 2:
          if (!
#line 2574 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1978; /* lasx_xvssrarn_u_bu_h */

        default:
          return -1;
        }

    case 194:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2584 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1979; /* lasx_xvsrln_w_d */

        case 1:
          if (!
#line 2584 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1980; /* lasx_xvsrln_h_w */

        case 2:
          if (!
#line 2584 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1981; /* lasx_xvsrln_b_h */

        default:
          return -1;
        }

    case 195:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2594 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1982; /* lasx_xvssrln_u_wu_d */

        case 1:
          if (!
#line 2594 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1983; /* lasx_xvssrln_u_hu_w */

        case 2:
          if (!
#line 2594 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1984; /* lasx_xvssrln_u_bu_h */

        default:
          return -1;
        }

    case 196:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2604 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1985; /* lasx_xvsrlrn_w_d */

        case 1:
          if (!
#line 2604 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1986; /* lasx_xvsrlrn_h_w */

        case 2:
          if (!
#line 2604 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1987; /* lasx_xvsrlrn_b_h */

        default:
          return -1;
        }

    case 197:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2614 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1988; /* lasx_xvssrlrn_u_wu_d */

        case 1:
          if (!
#line 2614 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1989; /* lasx_xvssrlrn_u_hu_w */

        case 2:
          if (!
#line 2614 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1990; /* lasx_xvssrlrn_u_bu_h */

        default:
          return -1;
        }

    case 201:
      return recog_32 (x1, insn, pnum_clobbers);

    case 202:
      return recog_30 (x1, insn, pnum_clobbers);

    case 205:
      return recog_29 (x1, insn, pnum_clobbers);

    case 206:
      if (pattern74 (x1, 
E_V4DFmode, 
E_V8SImode) != 0
          || !
#line 2821 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2026; /* lasx_xvftint_w_d */

    case 207:
      if (pattern82 (x1, 
E_V8SFmode) != 0
          || !
#line 2844 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2027; /* lasx_xvffint_s_l */

    case 208:
      if (pattern74 (x1, 
E_V4DFmode, 
E_V8SImode) != 0
          || !
#line 2867 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2028; /* lasx_xvftintrz_w_d */

    case 209:
      if (pattern74 (x1, 
E_V4DFmode, 
E_V8SImode) != 0
          || !
#line 2877 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2029; /* lasx_xvftintrp_w_d */

    case 210:
      if (pattern74 (x1, 
E_V4DFmode, 
E_V8SImode) != 0
          || !
#line 2887 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2030; /* lasx_xvftintrm_w_d */

    case 211:
      if (pattern74 (x1, 
E_V4DFmode, 
E_V8SImode) != 0
          || !
#line 2897 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2031; /* lasx_xvftintrne_w_d */

    case 228:
      if (pattern82 (x1, 
E_V4DImode) != 0
          || !
#line 3103 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2056; /* lasx_xvadd_q */

    case 229:
      if (pattern82 (x1, 
E_V4DImode) != 0
          || !
#line 3115 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2057; /* lasx_xvsub_q */

    case 251:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 3126 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2058; /* lasx_xvssrln_w_d */

        case 1:
          if (!
#line 3126 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2059; /* lasx_xvssrln_h_w */

        case 2:
          if (!
#line 3126 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2060; /* lasx_xvssrln_b_h */

        default:
          return -1;
        }

    case 230:
      return recog_23 (x1, insn, pnum_clobbers);

    case 250:
      return recog_20 (x1, insn, pnum_clobbers);

    case 252:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 3534 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2154; /* lasx_xvssrlrn_w_d */

        case 1:
          if (!
#line 3534 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2155; /* lasx_xvssrlrn_h_w */

        case 2:
          if (!
#line 3534 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2156; /* lasx_xvssrlrn_b_h */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 67; /* abssf2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 68; /* absdf2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2026 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1320; /* absv2di2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 2026 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1321; /* absv4si2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 2026 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1322; /* absv8hi2 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 2026 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1323; /* absv16qi2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 2348 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1402; /* absv2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2356 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1403; /* absv4sf2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !
#line 2486 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1947; /* absv4di2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !
#line 2486 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1948; /* absv8si2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !
#line 2486 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1949; /* absv16hi2 */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x3) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !
#line 2486 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1950; /* absv32qi2 */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !
#line 2758 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2016; /* absv4df2 */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !
#line 2766 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2017; /* absv8sf2 */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x3, 
E_SFmode) != 0
              || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 23; /* *divsf3 */

        case E_DFmode:
          if (pattern0 (x3, 
E_DFmode) != 0
              || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 24; /* *divdf3 */

        case E_DImode:
          if (pattern0 (x3, 
E_DImode) != 0
              || !
#line 421 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 29; /* *divdi3 */

        case E_SImode:
          if (pattern0 (x3, 
E_SImode) != 0
              || !
#line 422 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT || ISA_HAS_DIV32))
            return -1;
          return 33; /* *divsi3 */

        case E_V2DImode:
          if (pattern0 (x3, 
E_V2DImode) != 0
              || !
#line 625 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 988; /* divv2di3 */

        case E_V4SImode:
          if (pattern0 (x3, 
E_V4SImode) != 0
              || !
#line 625 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 989; /* divv4si3 */

        case E_V8HImode:
          if (pattern0 (x3, 
E_V8HImode) != 0
              || !
#line 625 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 990; /* divv8hi3 */

        case E_V16QImode:
          if (pattern0 (x3, 
E_V16QImode) != 0
              || !
#line 625 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 991; /* divv16qi3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 840 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1044; /* *divv2df3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !
#line 840 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1045; /* *divv4sf3 */

        case E_V4DImode:
          if (pattern0 (x3, 
E_V4DImode) != 0
              || !
#line 751 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1590; /* divv4di3 */

        case E_V8SImode:
          if (pattern0 (x3, 
E_V8SImode) != 0
              || !
#line 751 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1591; /* divv8si3 */

        case E_V16HImode:
          if (pattern0 (x3, 
E_V16HImode) != 0
              || !
#line 751 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1592; /* divv16hi3 */

        case E_V32QImode:
          if (pattern0 (x3, 
E_V32QImode) != 0
              || !
#line 751 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1593; /* divv32qi3 */

        case E_V4DFmode:
          if (pattern0 (x3, 
E_V4DFmode) != 0
              || !
#line 981 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1646; /* *divv4df3 */

        case E_V8SFmode:
          if (pattern0 (x3, 
E_V8SFmode) != 0
              || !
#line 981 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1647; /* *divv8sf3 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern128 (x3, 
E_SFmode) != 0
              || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 25; /* *recipsf3 */

        case E_DFmode:
          if (pattern128 (x3, 
E_DFmode) != 0
              || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 26; /* *recipdf3 */

        case E_V2DFmode:
          if (pattern129 (x3, 
E_V2DFmode) != 0
              || !
#line 1218 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1159; /* recipv2df3 */

        case E_V4SFmode:
          if (pattern129 (x3, 
E_V4SFmode) != 0
              || !
#line 1218 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1160; /* recipv4sf3 */

        case E_V4DFmode:
          if (pattern129 (x3, 
E_V4DFmode) != 0
              || !
#line 1329 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1763; /* recipv4df3 */

        case E_V8SFmode:
          if (pattern129 (x3, 
E_V8SFmode) != 0
              || !
#line 1329 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1764; /* recipv8sf3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1655 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1225; /* popcountv2di2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 1655 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1226; /* popcountv4si2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 1655 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1227; /* popcountv8hi2 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 1655 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1228; /* popcountv16qi2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !
#line 1959 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1831; /* popcountv4di2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !
#line 1959 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1832; /* popcountv8si2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !
#line 1959 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1833; /* popcountv16hi2 */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x3) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !
#line 1959 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1834; /* popcountv32qi2 */

    default:
      return -1;
    }
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          switch (pattern104 (x3, 
E_DFmode))
            {
            case 0:
              if (!
#line 1909 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 144; /* floatsidf2 */

            case 1:
              if (!
#line 1918 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 145; /* floatdidf2 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern104 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 1927 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 146; /* floatsisf2 */

            case 1:
              if (!
#line 1936 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 147; /* floatdisf2 */

            default:
              return -1;
            }

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1121 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1139; /* floatv2div2df2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1121 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1140; /* floatv4siv4sf2 */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode
              || !register_operand (operands[1], E_V4DImode)
              || !
#line 1231 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1743; /* floatv4div4df2 */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || !register_operand (operands[1], E_V8SImode)
              || !
#line 1231 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1744; /* floatv8siv8sf2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern93 (x3, 
E_V4SImode, 
E_V2DFmode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2490 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1420; /* vec_unpacks_float_hi_v4si */

        case 1:
          if (!
#line 2501 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1421; /* vec_unpacks_float_lo_v4si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      switch (pattern105 (x3))
        {
        case 0:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 288; /* *sne_zero_sisi */

        case 1:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 289; /* *sne_zero_disi */

        case 2:
          if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 290; /* *sne_zero_didi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern13 (x3))
        {
        case 0:
          if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 318; /* sne_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 332; /* sne_df_using_FCCmode */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 668; /* lsx_vfcmp_cune_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 678; /* lsx_vfcmp_cune_s */

        case 4:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 688; /* lasx_xvfcmp_cune_d */

        case 5:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 698; /* lasx_xvfcmp_cune_s */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
