/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern0 (x3, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern0 (x3, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 3;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 4;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 5;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 6;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 7;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 8;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern29 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i4)
      || GET_MODE (x1) != i4)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i4
      || pattern26 (x1, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern36 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern40 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (XWINT (x2, 0))
    {
    case 2L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 3L)
        return -1;
      return 0;

    case 0L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 1L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_uimm3_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern61 (x3, 
E_V2DImode, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern61 (x3, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern61 (x3, 
E_V8HImode, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 2;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i4
      || GET_MODE (x3) != i3
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern100 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!mem_simple_ldst_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!mem_simple_ldst_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!mem_simple_ldst_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  return pattern108 (x1); /* [-1, 6] */
}

int
pattern117 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !register_operand (operands[2], E_V2DFmode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode)
          || !reg_or_vector_same_simm5_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern145 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern150 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 64
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 65
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 66
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 67
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 68
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 69
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 70
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 71
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 1
      || GET_MODE (x19) != E_SImode)
    return -1;
  return 0;
}

int
pattern190 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_FCCmode
      || !register_operand (operands[1], E_FCCmode)
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern197 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_exp_2_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[3] = x2;
  if (!const_0_to_3_operand (operands[3], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  operands[4] = x3;
  if (!const_0_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  operands[5] = x4;
  if (!const_0_to_3_operand (operands[5], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 4);
  operands[6] = x5;
  x6 = XVECEXP (x1, 0, 5);
  operands[7] = x6;
  if (!const_4_to_7_operand (operands[7], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x1, 0, 6);
  operands[8] = x7;
  if (!const_4_to_7_operand (operands[8], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 7);
  operands[9] = x8;
  if (!const_4_to_7_operand (operands[9], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern221 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 8);
  if (XWINT (x3, 0) != 12L)
    return -1;
  x4 = XVECEXP (x2, 0, 9);
  if (XWINT (x4, 0) != 28L)
    return -1;
  x5 = XVECEXP (x2, 0, 10);
  if (XWINT (x5, 0) != 13L)
    return -1;
  x6 = XVECEXP (x2, 0, 11);
  if (XWINT (x6, 0) != 29L)
    return -1;
  x7 = XVECEXP (x2, 0, 12);
  if (XWINT (x7, 0) != 14L)
    return -1;
  x8 = XVECEXP (x2, 0, 13);
  if (XWINT (x8, 0) != 30L)
    return -1;
  x9 = XVECEXP (x2, 0, 14);
  if (XWINT (x9, 0) != 15L)
    return -1;
  x10 = XVECEXP (x2, 0, 15);
  if (XWINT (x10, 0) != 31L
      || pattern205 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern51 (x1))
    {
    case 0:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 559; /* lsx_vfrintrp_d */

    case 1:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 564; /* lsx_vfrintrp_s */

    case 2:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 569; /* lasx_xvfrintrp_d */

    case 3:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 574; /* lasx_xvfrintrp_s */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V8SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !nonimmediate_operand (operands[1], E_V8SImode)
          || !
#line 481 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1542; /* lasx_xvperm_w */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode)
          || !
#line 481 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1543; /* lasx_xvperm_w_f */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_uimm8_operand (operands[2], E_SImode))
    return -1;
  switch (pattern141 (x3))
    {
    case 0:
      if (!
#line 493 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1544; /* lasx_xvpermi_d_v4di */

    case 1:
      if (!
#line 493 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1545; /* lasx_xvpermi_d_v8si */

    case 2:
      if (!
#line 493 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1546; /* lasx_xvpermi_d_v16hi */

    case 3:
      if (!
#line 493 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1547; /* lasx_xvpermi_d_v32qi */

    case 4:
      if (!
#line 493 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1548; /* lasx_xvpermi_d_v4df */

    case 5:
      if (!
#line 493 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1549; /* lasx_xvpermi_d_v8sf */

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 2030 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1849; /* lasx_xvsrar_d */

    case 1:
      if (!
#line 2030 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1850; /* lasx_xvsrar_w */

    case 2:
      if (!
#line 2030 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1851; /* lasx_xvsrar_h */

    case 3:
      if (!
#line 2030 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1852; /* lasx_xvsrar_b */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 1116 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1690; /* lasx_xvbitclr_d */

    case 1:
      if (!
#line 1116 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1691; /* lasx_xvbitclr_w */

    case 2:
      if (!
#line 1116 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1692; /* lasx_xvbitclr_h */

    case 3:
      if (!
#line 1116 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1693; /* lasx_xvbitclr_b */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern67 (x1))
    {
    case 0:
      if (!
#line 1675 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1233; /* lsx_vsat_u_du */

    case 1:
      if (!
#line 1675 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1234; /* lsx_vsat_u_wu */

    case 2:
      if (!
#line 1675 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1235; /* lsx_vsat_u_hu */

    case 3:
      if (!
#line 1675 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1236; /* lsx_vsat_u_bu */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 956 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1080; /* lsx_vavgr_s_d */

    case 1:
      if (!
#line 956 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1081; /* lsx_vavgr_s_w */

    case 2:
      if (!
#line 956 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1082; /* lsx_vavgr_s_h */

    case 3:
      if (!
#line 956 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1083; /* lsx_vavgr_s_b */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 23:
      switch (pattern45 (x1))
        {
        case 0:
          if (!(
#line 1038 "../../gcc/config/loongarch/loongarch.md"
(ISA_HAS_FRECIPE) && 
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 27; /* loongarch_frecipe_s */

        case 1:
          if (!(
#line 1038 "../../gcc/config/loongarch/loongarch.md"
(ISA_HAS_FRECIPE) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 28; /* loongarch_frecipe_d */

        default:
          return -1;
        }

    case 21:
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 1294 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 63; /* *rsqrtsf2 */

        case 1:
          if (!(
#line 1294 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 64; /* *rsqrtdf2 */

        default:
          return -1;
        }

    case 22:
      switch (pattern45 (x1))
        {
        case 0:
          if (!(
#line 1305 "../../gcc/config/loongarch/loongarch.md"
(ISA_HAS_FRECIPE) && 
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 65; /* loongarch_frsqrte_s */

        case 1:
          if (!(
#line 1305 "../../gcc/config/loongarch/loongarch.md"
(ISA_HAS_FRECIPE) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 66; /* loongarch_frsqrte_d */

        default:
          return -1;
        }

    case 13:
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 1386 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 73; /* logb_non_negativesf2 */

        case 1:
          if (!(
#line 1386 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 74; /* logb_non_negativedf2 */

        default:
          return -1;
        }

    case 34:
      switch (pattern47 (x1))
        {
        case 0:
          if (!
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return -1;
          return 180; /* tls_lowsi */

        case 1:
          if (!
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return -1;
          return 181; /* tls_lowdi */

        default:
          return -1;
        }

    case 26:
      switch (pattern47 (x1))
        {
        case 0:
          if (!
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return -1;
          return 182; /* ld_from_gotsi */

        case 1:
          if (!
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return -1;
          return 183; /* ld_from_gotdi */

        default:
          return -1;
        }

    case 31:
      switch (pattern48 (x1))
        {
        case 0:
          if (!
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return -1;
          return 184; /* lui_l_hi20si */

        case 1:
          if (!
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return -1;
          return 185; /* lui_l_hi20di */

        default:
          return -1;
        }

    case 27:
      switch (pattern48 (x1))
        {
        case 0:
          if (!
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return -1;
          return 186; /* pcalau12isi */

        case 1:
          if (!
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return -1;
          return 187; /* pcalau12idi */

        default:
          return -1;
        }

    case 28:
      switch (pattern48 (x1))
        {
        case 0:
          if (!
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return -1;
          return 188; /* pcalau12i_grsi */

        case 1:
          if (!
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return -1;
          return 189; /* pcalau12i_grdi */

        default:
          return -1;
        }

    case 5:
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 196; /* rintsf2 */

        case 1:
          if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 197; /* rintdf2 */

        default:
          return -1;
        }

    case 9:
      return recog_13 (x1, insn, pnum_clobbers);

    case 10:
      return recog_12 (x1, insn, pnum_clobbers);

    case 11:
      return recog_11 (x1, insn, pnum_clobbers);

    case 18:
      return recog_2 (x1, insn, pnum_clobbers);

    case 17:
      switch (pattern48 (x1))
        {
        case 0:
          if (!
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return -1;
          return 213; /* load_tlssi */

        case 1:
          if (!
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return -1;
          return 214; /* load_tlsdi */

        default:
          return -1;
        }

    case 6:
      return recog_3 (x1, insn, pnum_clobbers);

    case 15:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 432; /* bitrev_4b */

    case 16:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 433; /* bitrev_8b */

    case 53:
      return recog_10 (x1, insn, pnum_clobbers);

    case 54:
      return recog_9 (x1, insn, pnum_clobbers);

    case 55:
      return recog_8 (x1, insn, pnum_clobbers);

    case 56:
      return recog_7 (x1, insn, pnum_clobbers);

    case 57:
      return recog_6 (x1, insn, pnum_clobbers);

    case 78:
      switch (pattern52 (x1))
        {
        case 0:
          if (!
#line 1101 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1137; /* lsx_vfclass_d */

        case 1:
          if (!
#line 1101 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1138; /* lsx_vfclass_s */

        default:
          return -1;
        }

    case 82:
      switch (pattern53 (x1))
        {
        case 0:
          if (!
#line 1155 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1147; /* logbv2df2 */

        case 1:
          if (!
#line 1155 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1148; /* logbv4sf2 */

        default:
          return -1;
        }

    case 83:
      switch (pattern53 (x1))
        {
        case 0:
          if (!
#line 1229 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX && ISA_HAS_FRECIPE))
            return -1;
          return 1161; /* lsx_vfrecipe_d */

        case 1:
          if (!
#line 1229 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX && ISA_HAS_FRECIPE))
            return -1;
          return 1162; /* lsx_vfrecipe_s */

        default:
          return -1;
        }

    case 84:
      switch (pattern53 (x1))
        {
        case 0:
          if (!
#line 1251 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1163; /* *rsqrtv2df2 */

        case 1:
          if (!
#line 1251 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1164; /* *rsqrtv4sf2 */

        default:
          return -1;
        }

    case 85:
      switch (pattern53 (x1))
        {
        case 0:
          if (!
#line 1262 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX && ISA_HAS_FRECIPE))
            return -1;
          return 1165; /* lsx_vfrsqrte_d */

        case 1:
          if (!
#line 1262 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX && ISA_HAS_FRECIPE))
            return -1;
          return 1166; /* lsx_vfrsqrte_s */

        default:
          return -1;
        }

    case 86:
      switch (pattern52 (x1))
        {
        case 0:
          if (!
#line 1271 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1167; /* lsx_vftint_u_lu_d */

        case 1:
          if (!
#line 1271 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1168; /* lsx_vftint_u_wu_s */

        default:
          return -1;
        }

    case 80:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 1813 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1284; /* lsx_vfcvth_s_h */

    case 81:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 1833 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1286; /* lsx_vfcvtl_s_h */

    case 92:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SImode)
          || !
#line 2043 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1328; /* lsx_vextw_s_d */

    case 93:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SImode)
          || !
#line 2052 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1329; /* lsx_vextw_u_d */

    case 112:
      return recog_5 (x1, insn, pnum_clobbers);

    case 125:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2470 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1418; /* lsx_vftinth_l_s */

    case 118:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2479 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1419; /* lsx_vftintl_l_s */

    case 120:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2532 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1424; /* lsx_vftintrph_l_s */

    case 119:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2541 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1425; /* lsx_vftintrpl_l_s */

    case 121:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2550 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1426; /* lsx_vftintrmh_l_s */

    case 122:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2559 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1427; /* lsx_vftintrml_l_s */

    case 124:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2568 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1428; /* lsx_vftintrneh_l_s */

    case 123:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2577 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1429; /* lsx_vftintrnel_l_s */

    case 131:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!const_imm13_operand (operands[1], E_VOIDmode)
          || !
#line 2719 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1464; /* lsx_vldi */

    case 133:
      if (pattern54 (x1, 
E_V16QImode) != 0
          || !
#line 2754 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1466; /* lsx_vstx */

    case 134:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DImode)
          || !
#line 2765 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1467; /* lsx_vextl_qu_du */

    case 140:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16QImode)
          || !
#line 2986 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1471; /* lsx_vmskgez_b */

    case 141:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16QImode)
          || !
#line 2995 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1472; /* lsx_vmsknz_b */

    case 138:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DImode)
          || !
#line 3041 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1479; /* lsx_vexth_q_d */

    case 139:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DImode)
          || !
#line 3050 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1480; /* lsx_vexth_qu_du */

    case 142:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DImode)
          || !
#line 3059 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1481; /* lsx_vextl_q_d */

    case 168:
      switch (pattern55 (x1))
        {
        case 0:
          if (!
#line 1211 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1741; /* lasx_xvfclass_d */

        case 1:
          if (!
#line 1211 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1742; /* lasx_xvfclass_s */

        default:
          return -1;
        }

    case 172:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1266 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1751; /* logbv4df2 */

        case 1:
          if (!
#line 1266 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1752; /* logbv8sf2 */

        default:
          return -1;
        }

    case 173:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1340 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX && ISA_HAS_FRECIPE))
            return -1;
          return 1765; /* lasx_xvfrecipe_d */

        case 1:
          if (!
#line 1340 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX && ISA_HAS_FRECIPE))
            return -1;
          return 1766; /* lasx_xvfrecipe_s */

        default:
          return -1;
        }

    case 174:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1362 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1767; /* *rsqrtv4df2 */

        case 1:
          if (!
#line 1362 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1768; /* *rsqrtv8sf2 */

        default:
          return -1;
        }

    case 175:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1373 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX && ISA_HAS_FRECIPE))
            return -1;
          return 1769; /* lasx_xvfrsqrte_d */

        case 1:
          if (!
#line 1373 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX && ISA_HAS_FRECIPE))
            return -1;
          return 1770; /* lasx_xvfrsqrte_s */

        default:
          return -1;
        }

    case 176:
      switch (pattern55 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1771; /* lasx_xvftint_u_lu_d */

        case 1:
          if (!
#line 1382 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1772; /* lasx_xvftint_u_wu_s */

        default:
          return -1;
        }

    case 224:
      if (GET_MODE (x2) != E_V32QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V32QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V32QImode)
          || !
#line 2183 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1889; /* lasx_xvreplve0_q */

    case 170:
      if (GET_MODE (x2) != E_V8SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V8SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16HImode)
          || !
#line 2224 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1893; /* lasx_xvfcvth_s_h */

    case 171:
      if (GET_MODE (x2) != E_V8SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V8SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16HImode)
          || !
#line 2262 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1896; /* lasx_xvfcvtl_s_h */

    case 204:
      return recog_4 (x1, insn, pnum_clobbers);

    case 212:
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8SFmode)
          || !
#line 2906 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2032; /* lasx_xvftinth_l_s */

    case 213:
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8SFmode)
          || !
#line 2915 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2033; /* lasx_xvftintl_l_s */

    case 214:
      if (GET_MODE (x2) != E_V4DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8SImode)
          || !
#line 2948 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2034; /* lasx_xvffinth_d_w */

    case 215:
      if (GET_MODE (x2) != E_V4DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8SImode)
          || !
#line 2957 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2035; /* lasx_xvffintl_d_w */

    case 216:
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8SFmode)
          || !
#line 2978 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2036; /* lasx_xvftintrzh_l_s */

    case 217:
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8SFmode)
          || !
#line 2999 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2037; /* lasx_xvftintrzl_l_s */

    case 218:
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8SFmode)
          || !
#line 3008 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2038; /* lasx_xvftintrph_l_s */

    case 219:
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8SFmode)
          || !
#line 3017 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2039; /* lasx_xvftintrpl_l_s */

    case 220:
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8SFmode)
          || !
#line 3026 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2040; /* lasx_xvftintrmh_l_s */

    case 221:
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8SFmode)
          || !
#line 3035 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2041; /* lasx_xvftintrml_l_s */

    case 223:
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8SFmode)
          || !
#line 3044 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2042; /* lasx_xvftintrneh_l_s */

    case 222:
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8SFmode)
          || !
#line 3053 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2043; /* lasx_xvftintrnel_l_s */

    case 231:
      if (GET_MODE (x2) != E_V32QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V32QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V32QImode)
          || !
#line 3158 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2069; /* lasx_xvmskgez_b */

    case 232:
      if (GET_MODE (x2) != E_V32QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V32QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V32QImode)
          || !
#line 3167 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2070; /* lasx_xvmsknz_b */

    case 233:
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4DImode)
          || !
#line 3220 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2077; /* lasx_xvexth_q_d */

    case 234:
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4DImode)
          || !
#line 3229 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2078; /* lasx_xvexth_qu_du */

    case 235:
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4DImode)
          || !
#line 3238 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2079; /* lasx_xvextl_q_d */

    case 253:
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4DImode)
          || !
#line 3552 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2161; /* lasx_xvextl_qu_du */

    case 254:
      if (GET_MODE (x2) != E_V4DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!const_imm13_operand (operands[1], E_VOIDmode)
          || !
#line 3561 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2162; /* lasx_xvldi */

    case 255:
      if (pattern54 (x1, 
E_V32QImode) != 0
          || !
#line 3587 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2163; /* lasx_xvstx */

    default:
      return -1;
    }
}

 int
recog_99 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 15:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 217; /* loongarch_cpucfg */

        case 13:
          if (!const_uimm5_operand (operands[1], E_VOIDmode)
              || !
#line 4176 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 374; /* loongarch_movfcsr2gr */

        default:
          return -1;
        }

    case 3:
      if (XINT (x3, 1) != 12)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern160 (x3, 
E_SImode) != 0
              || !
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return -1;
          return 344; /* probe_stack_rangesi */

        case E_DImode:
          if (pattern160 (x3, 
E_DImode) != 0
              || !
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return -1;
          return 345; /* probe_stack_rangedi */

        default:
          return -1;
        }

    case 2:
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 51:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode
                  || !memory_operand (operands[1], E_QImode))
                return -1;
              return 491; /* atomic_loadqi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !memory_operand (operands[1], E_HImode))
                return -1;
              return 492; /* atomic_loadhi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !memory_operand (operands[1], E_SImode))
                return -1;
              return 493; /* atomic_loadsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !memory_operand (operands[1], E_DImode)
                  || !
#line 401 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 494; /* atomic_loaddi */

            default:
              return -1;
            }

        case 50:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!memory_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode
                  || !reg_or_0_operand (operands[1], E_QImode))
                return -1;
              return 495; /* atomic_storeqi */

            case E_HImode:
              if (!memory_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !reg_or_0_operand (operands[1], E_HImode))
                return -1;
              return 496; /* atomic_storehi */

            case E_SImode:
              if (!memory_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !reg_or_0_operand (operands[1], E_SImode))
                return -1;
              return 497; /* atomic_storesi */

            case E_DImode:
              if (!memory_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !reg_or_0_operand (operands[1], E_DImode)
                  || !
#line 401 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 498; /* atomic_storedi */

            default:
              return -1;
            }

        case 48:
          x4 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x4))
            {
            case PLUS:
              x7 = XEXP (x4, 1);
              operands[1] = x7;
              x8 = XEXP (x4, 0);
              if (!rtx_equal_p (x8, operands[0]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern151 (x3, 
E_SImode) != 0)
                    return -1;
                  return 499; /* atomic_addsi */

                case E_DImode:
                  if (pattern151 (x3, 
E_DImode) != 0
                      || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 503; /* atomic_adddi */

                case E_QImode:
                  if (pattern151 (x3, 
E_QImode) != 0
                      || !
#line 196 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAM_BH))
                    return -1;
                  return 507; /* atomic_addqi */

                case E_HImode:
                  if (pattern151 (x3, 
E_HImode) != 0
                      || !
#line 196 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAM_BH))
                    return -1;
                  return 508; /* atomic_addhi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern152 (x3))
                {
                case 0:
                  return 500; /* atomic_orsi */

                case 1:
                  if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 504; /* atomic_ordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern152 (x3))
                {
                case 0:
                  return 501; /* atomic_xorsi */

                case 1:
                  if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 505; /* atomic_xordi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern152 (x3))
                {
                case 0:
                  return 502; /* atomic_andsi */

                case 1:
                  if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 506; /* atomic_anddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern10 (x1))
    {
    case 0:
      return 243; /* *ashrsi3 */

    case 1:
      if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 246; /* *ashrdi3 */

    case 2:
      if (const_uimm6_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 628; /* ashrv2di3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V2DImode)
          || !
#line 747 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1030; /* vashrv2di3 */

    case 3:
      if (const_uimm5_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 632; /* ashrv4si3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V4SImode)
          || !
#line 747 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1031; /* vashrv4si3 */

    case 4:
      if (const_uimm4_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 636; /* ashrv8hi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V8HImode)
          || !
#line 747 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1032; /* vashrv8hi3 */

    case 5:
      if (const_uimm3_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 640; /* ashrv16qi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V16QImode)
          || !
#line 747 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1033; /* vashrv16qi3 */

    case 6:
      if (const_uimm6_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 644; /* ashrv4di3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V4DImode)
          || !
#line 887 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1632; /* vashrv4di3 */

    case 7:
      if (const_uimm5_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 648; /* ashrv8si3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V8SImode)
          || !
#line 887 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1633; /* vashrv8si3 */

    case 8:
      if (const_uimm4_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 652; /* ashrv16hi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V16HImode)
          || !
#line 887 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1634; /* vashrv16hi3 */

    case 9:
      if (const_uimm3_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 656; /* ashrv32qi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V32QImode)
          || !
#line 887 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1635; /* vashrv32qi3 */

    case 10:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
        return -1;
      return 919; /* simd_ashr_imm_round_v2di */

    case 11:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
        return -1;
      return 921; /* simd_ashr_imm_round_v4si */

    case 12:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
        return -1;
      return 923; /* simd_ashr_imm_round_v8hi */

    case 13:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
        return -1;
      return 925; /* simd_ashr_imm_round_v16qi */

    case 14:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return -1;
      return 927; /* simd_ashr_imm_round_v4di */

    case 15:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return -1;
      return 929; /* simd_ashr_imm_round_v8si */

    case 16:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return -1;
      return 931; /* simd_ashr_imm_round_v16hi */

    case 17:
      if (!(
#line 954 "../../gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return -1;
      return 933; /* simd_ashr_imm_round_v32qi */

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 61; /* *sqrtsf2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 62; /* *sqrtdf2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 884 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1050; /* *sqrtv2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 884 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1051; /* *sqrtv4sf2 */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !
#line 1025 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1652; /* *sqrtv4df2 */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !
#line 1025 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1653; /* *sqrtv8sf2 */

    default:
      return -1;
    }
}

 int
recog_126 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern3 (x1))
    {
    case 0:
      if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 81; /* sminsf3 */

    case 1:
      if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 82; /* smindf3 */

    case 2:
      if (!
#line 1197 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1155; /* sminv2df3 */

    case 3:
      if (!
#line 1197 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1156; /* sminv4sf3 */

    case 4:
      if (!
#line 1579 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1199; /* sminv2di3 */

    case 5:
      if (!
#line 1579 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1200; /* sminv4si3 */

    case 6:
      if (!
#line 1579 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1201; /* sminv8hi3 */

    case 7:
      if (!
#line 1579 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1202; /* sminv16qi3 */

    case 8:
      if (!
#line 1308 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1759; /* sminv4df3 */

    case 9:
      if (!
#line 1308 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1760; /* sminv8sf3 */

    case 10:
      if (!
#line 1759 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1803; /* sminv4di3 */

    case 11:
      if (!
#line 1759 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1804; /* sminv8si3 */

    case 12:
      if (!
#line 1759 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1805; /* sminv16hi3 */

    case 13:
      if (!
#line 1759 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1806; /* sminv32qi3 */

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36;
  int res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 3:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x5;
          x6 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x6))
            {
            case UNSPEC:
              if (pattern106 (x6) != 0
                  || !register_operand (operands[0], E_DImode)
                  || !symbolic_off64_or_reg_operand (operands[1], E_DImode))
                return -1;
              x7 = XEXP (x3, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_DImode)
                  || !
#line 2240 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && TARGET_CMODEL_EXTREME))
                return -1;
              return 154; /* movdi_symbolic_off64 */

            case SET:
              x8 = XEXP (x6, 1);
              if (GET_CODE (x8) != UNSPEC_VOLATILE)
                return -1;
              x9 = XEXP (x6, 0);
              if (!rtx_equal_p (x9, operands[1]))
                return -1;
              switch (XVECLEN (x8, 0))
                {
                case 3:
                  if (XINT (x8, 1) != 41)
                    return -1;
                  x10 = XVECEXP (x8, 0, 0);
                  operands[2] = x10;
                  x11 = XVECEXP (x8, 0, 1);
                  operands[3] = x11;
                  x12 = XVECEXP (x8, 0, 2);
                  operands[4] = x12;
                  if (!const_int_operand (operands[4], E_SImode))
                    return -1;
                  x7 = XEXP (x3, 0);
                  operands[5] = x7;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern215 (x8, 
E_SImode) != 0)
                        return -1;
                      return 521; /* atomic_cas_value_strongsi */

                    case E_DImode:
                      if (pattern215 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 522; /* atomic_cas_value_strongdi */

                    default:
                      return -1;
                    }

                case 5:
                  x10 = XVECEXP (x8, 0, 0);
                  operands[2] = x10;
                  x11 = XVECEXP (x8, 0, 1);
                  operands[3] = x11;
                  x12 = XVECEXP (x8, 0, 2);
                  operands[4] = x12;
                  x13 = XVECEXP (x8, 0, 3);
                  operands[5] = x13;
                  x14 = XVECEXP (x8, 0, 4);
                  operands[6] = x14;
                  if (!const_int_operand (operands[6], E_SImode))
                    return -1;
                  x7 = XEXP (x3, 0);
                  operands[7] = x7;
                  switch (XINT (x8, 1))
                    {
                    case 41:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern217 (x8, 
E_SImode) != 0)
                            return -1;
                          return 527; /* atomic_cas_value_cmp_and_7_si */

                        case E_DImode:
                          if (pattern217 (x8, 
E_DImode) != 0
                              || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 528; /* atomic_cas_value_cmp_and_7_di */

                        default:
                          return -1;
                        }

                    case 49:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern217 (x8, 
E_SImode) != 0)
                            return -1;
                          return 541; /* atomic_cas_value_exchange_7_si */

                        case E_DImode:
                          if (pattern217 (x8, 
E_DImode) != 0
                              || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 542; /* atomic_cas_value_exchange_7_di */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CALL:
          x15 = XEXP (x5, 0);
          if (GET_CODE (x15) != MEM)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != CALL)
            return -1;
          x16 = XEXP (x8, 0);
          if (GET_CODE (x16) != MEM)
            return -1;
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 1
              || GET_MODE (x7) != E_SImode
              || !register_operand (operands[0], E_VOIDmode))
            return -1;
          x9 = XEXP (x6, 0);
          if (!register_operand (x9, E_VOIDmode))
            return -1;
          x17 = XEXP (x15, 0);
          switch (GET_CODE (x17))
            {
            case CONST:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
              operands[1] = x17;
              if (!call_insn_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x15) != E_SImode)
                return -1;
              x18 = XEXP (x5, 1);
              operands[2] = x18;
              operands[3] = x9;
              if (GET_MODE (x16) != E_SImode)
                return -1;
              x19 = XEXP (x16, 0);
              if (!rtx_equal_p (x19, operands[1]))
                return -1;
              x20 = XEXP (x8, 1);
              if (!rtx_equal_p (x20, operands[2]))
                return -1;
              return 369; /* call_value_multiple_internal */

            case UNSPEC:
              if (XVECLEN (x17, 0) != 2
                  || XINT (x17, 1) != 37)
                return -1;
              x19 = XEXP (x16, 0);
              if (GET_CODE (x19) != UNSPEC
                  || XVECLEN (x19, 0) != 2
                  || XINT (x19, 1) != 37)
                return -1;
              x21 = XVECEXP (x17, 0, 0);
              operands[1] = x21;
              x22 = XVECEXP (x17, 0, 1);
              operands[2] = x22;
              x18 = XEXP (x5, 1);
              operands[3] = x18;
              operands[4] = x9;
              x23 = XVECEXP (x19, 0, 0);
              if (!rtx_equal_p (x23, operands[1]))
                return -1;
              x24 = XVECEXP (x19, 0, 1);
              if (!rtx_equal_p (x24, operands[2]))
                return -1;
              x20 = XEXP (x8, 1);
              if (!rtx_equal_p (x20, operands[3]))
                return -1;
              switch (GET_MODE (x15))
                {
                case E_SImode:
                  if (pattern220 (x1, 
E_SImode) != 0
                      || !(
#line 4114 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                    return -1;
                  return 370; /* call_value_multiple_internal_1si */

                case E_DImode:
                  if (pattern220 (x1, 
E_DImode) != 0
                      || !(
#line 4114 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                    return -1;
                  return 371; /* call_value_multiple_internal_1di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x2 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x2))
        {
        case SET:
          return recog_133 (x1, insn, pnum_clobbers);

        case UNSPEC_VOLATILE:
          x6 = XVECEXP (x1, 0, 1);
          if (pattern19 (x6) != 0)
            return -1;
          switch (XVECLEN (x2, 0))
            {
            case 1:
              if (GET_MODE (x2) != E_SImode)
                return -1;
              x25 = XVECEXP (x2, 0, 0);
              operands[0] = x25;
              if (!const_uimm15_operand (operands[0], E_VOIDmode))
                return -1;
              switch (XINT (x2, 1))
                {
                case 2:
                  return 215; /* loongarch_ibar */

                case 1:
                  return 216; /* loongarch_dbar */

                case 18:
                  return 218; /* loongarch_syscall */

                case 19:
                  return 219; /* loongarch_break */

                default:
                  return -1;
                }

            case 2:
              x25 = XVECEXP (x2, 0, 0);
              operands[0] = x25;
              x26 = XVECEXP (x2, 0, 1);
              operands[1] = x26;
              switch (XINT (x2, 1))
                {
                case 7:
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  switch (GET_MODE (x2))
                    {
                    case E_QImode:
                      if (!register_operand (operands[0], E_QImode))
                        return -1;
                      return 232; /* loongarch_iocsrwr_b */

                    case E_HImode:
                      if (!register_operand (operands[0], E_HImode))
                        return -1;
                      return 233; /* loongarch_iocsrwr_h */

                    case E_SImode:
                      if (!register_operand (operands[0], E_SImode))
                        return -1;
                      return 234; /* loongarch_iocsrwr_w */

                    case E_DImode:
                      if (!register_operand (operands[0], E_DImode)
                          || !
#line 401 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 235; /* loongarch_iocsrwr_d */

                    default:
                      return -1;
                    }

                case 10:
                  if (!const_uimm5_operand (operands[1], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (x2))
                    {
                    case E_SImode:
                      if (!register_operand (operands[0], E_SImode)
                          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                        return -1;
                      return 240; /* loongarch_ldpte_w */

                    case E_DImode:
                      if (!register_operand (operands[0], E_DImode)
                          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 241; /* loongarch_ldpte_d */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 3:
              x25 = XVECEXP (x2, 0, 0);
              operands[0] = x25;
              x26 = XVECEXP (x2, 0, 1);
              operands[1] = x26;
              x27 = XVECEXP (x2, 0, 2);
              operands[2] = x27;
              switch (XINT (x2, 1))
                {
                case 8:
                  if (!const_uimm5_operand (operands[0], E_VOIDmode)
                      || !const_imm12_operand (operands[2], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (x2))
                    {
                    case E_SImode:
                      if (!register_operand (operands[1], E_SImode)
                          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                        return -1;
                      return 236; /* loongarch_cacop_w */

                    case E_DImode:
                      if (!register_operand (operands[1], E_DImode)
                          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 237; /* loongarch_cacop_d */

                    default:
                      return -1;
                    }

                case 9:
                  if (!const_uimm5_operand (operands[2], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (x2))
                    {
                    case E_SImode:
                      if (!register_operand (operands[0], E_SImode)
                          || !register_operand (operands[1], E_SImode)
                          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                        return -1;
                      return 238; /* loongarch_lddir_w */

                    case E_DImode:
                      if (!register_operand (operands[0], E_DImode)
                          || !register_operand (operands[1], E_DImode)
                          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 239; /* loongarch_lddir_d */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case RETURN:
          x6 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x6))
            {
            case USE:
              x9 = XEXP (x6, 0);
              operands[0] = x9;
              if (!pmode_register_operand (operands[0], E_VOIDmode))
                return -1;
              return 348; /* return_internal */

            case UNSPEC_VOLATILE:
              if (XVECLEN (x6, 0) != 1
                  || XINT (x6, 1) != 11)
                return -1;
              x28 = XVECEXP (x6, 0, 0);
              if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 350; /* loongarch_ertn */

            default:
              return -1;
            }

        case SIMPLE_RETURN:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x9 = XEXP (x6, 0);
          operands[0] = x9;
          if (!pmode_register_operand (operands[0], E_VOIDmode))
            return -1;
          return 349; /* simple_return_internal */

        case UNSPEC:
          if (XVECLEN (x2, 0) != 1
              || XINT (x2, 1) != 14)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x25 = XVECEXP (x2, 0, 0);
          operands[0] = x25;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !scratch_operand (operands[1], E_SImode)
                  || !
#line 3717 "../../gcc/config/loongarch/loongarch.md"
(! TARGET_64BIT))
                return -1;
              return 352; /* eh_set_ra_si */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !scratch_operand (operands[1], E_DImode)
                  || !
#line 3723 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 353; /* eh_set_ra_di */

            default:
              return -1;
            }

        case CALL:
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != MEM)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern99 (x6) != 0)
            return -1;
          x29 = XEXP (x4, 0);
          switch (GET_CODE (x29))
            {
            case CONST:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
              operands[0] = x29;
              if (!call_insn_operand (operands[0], E_VOIDmode)
                  || GET_MODE (x4) != E_SImode)
                return -1;
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              return 363; /* call_internal */

            case LO_SUM:
              x30 = XEXP (x29, 0);
              operands[0] = x30;
              x31 = XEXP (x29, 1);
              operands[1] = x31;
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              switch (GET_MODE (x4))
                {
                case E_SImode:
                  if (GET_MODE (x29) != E_SImode
                      || !register_operand (operands[0], E_SImode)
                      || !symbolic_operand (operands[1], E_SImode)
                      || !(
#line 3990 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                    return -1;
                  return 364; /* call_internal_1si */

                case E_DImode:
                  if (GET_MODE (x29) != E_DImode
                      || !register_operand (operands[0], E_DImode)
                      || !symbolic_operand (operands[1], E_DImode)
                      || !(
#line 3990 "../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                    return -1;
                  return 365; /* call_internal_1di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 10:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 18)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 4
          || pattern155 (x1) != 0)
        return -1;
      x32 = XVECEXP (x5, 0, 0);
      operands[0] = x32;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || !symbolic_operand (operands[0], E_SImode)
              || !(
#line 2748 "../../gcc/config/loongarch/loongarch.md"
(TARGET_TLS_DESC) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
            return -1;
          return 210; /* got_load_tls_descsi */

        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || !symbolic_operand (operands[0], E_DImode)
              || !(
#line 2748 "../../gcc/config/loongarch/loongarch.md"
(TARGET_TLS_DESC) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
            return -1;
          return 211; /* got_load_tls_descdi */

        default:
          return -1;
        }

    case 11:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 19
          || GET_MODE (x5) != E_DImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 4
          || GET_MODE (x4) != E_DImode
          || pattern155 (x1) != 0)
        return -1;
      x33 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x33) != CLOBBER)
        return -1;
      x32 = XVECEXP (x5, 0, 0);
      operands[0] = x32;
      if (!symbolic_operand (operands[0], E_DImode))
        return -1;
      x34 = XEXP (x33, 0);
      operands[1] = x34;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 2776 "../../gcc/config/loongarch/loongarch.md"
(TARGET_TLS_DESC && TARGET_CMODEL_EXTREME))
        return -1;
      return 212; /* got_load_tls_desc_off64 */

    case 4:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != UNSPEC_VOLATILE
          || XVECLEN (x8, 0) != 5)
        return -1;
      x3 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x35 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x35) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x10 = XVECEXP (x8, 0, 0);
      operands[2] = x10;
      x11 = XVECEXP (x8, 0, 1);
      operands[3] = x11;
      x12 = XVECEXP (x8, 0, 2);
      operands[4] = x12;
      x13 = XVECEXP (x8, 0, 3);
      operands[5] = x13;
      x14 = XVECEXP (x8, 0, 4);
      operands[6] = x14;
      if (!const_int_operand (operands[6], E_SImode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[7] = x7;
      x36 = XEXP (x35, 0);
      operands[8] = x36;
      x9 = XEXP (x6, 0);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      switch (XINT (x8, 1))
        {
        case 42:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 529; /* atomic_cas_value_add_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 530; /* atomic_cas_value_add_7_di */

            default:
              return -1;
            }

        case 43:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 531; /* atomic_cas_value_sub_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 532; /* atomic_cas_value_sub_7_di */

            default:
              return -1;
            }

        case 44:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 533; /* atomic_cas_value_and_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 534; /* atomic_cas_value_and_7_di */

            default:
              return -1;
            }

        case 45:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 535; /* atomic_cas_value_xor_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 536; /* atomic_cas_value_xor_7_di */

            default:
              return -1;
            }

        case 46:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 537; /* atomic_cas_value_or_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 538; /* atomic_cas_value_or_7_di */

            default:
              return -1;
            }

        case 47:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 539; /* atomic_cas_value_nand_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 540; /* atomic_cas_value_nand_7_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
