/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_simm5_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern16 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern16 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern16 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern16 (x3, 
E_V16QImode) != 0)
        return -1;
      return 3;

    case E_V4DImode:
      if (pattern16 (x3, 
E_V4DImode) != 0)
        return -1;
      return 4;

    case E_V8SImode:
      if (pattern16 (x3, 
E_V8SImode) != 0)
        return -1;
      return 5;

    case E_V16HImode:
      if (pattern16 (x3, 
E_V16HImode) != 0)
        return -1;
      return 6;

    case E_V32QImode:
      if (pattern16 (x3, 
E_V32QImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 1);
  switch (GET_CODE (x6))
    {
    case ZERO_EXTEND:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != VEC_SELECT)
        return -1;
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          return pattern27 (x1, 
E_V2DImode, 
E_V1DImode, 
E_V1TImode); /* [-1, 0] */

        case E_V2DImode:
          if (pattern27 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern27 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern27 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V2TImode:
          if (pattern27 (x1, 
E_V4DImode, 
E_V2DImode, 
E_V2TImode) != 0)
            return -1;
          return 4;

        case E_V4DImode:
          if (pattern27 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V4DImode) != 0)
            return -1;
          return 5;

        case E_V8SImode:
          if (pattern27 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V8SImode) != 0)
            return -1;
          return 6;

        case E_V16HImode:
          if (pattern27 (x1, 
E_V32QImode, 
E_V16QImode, 
E_V16HImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern30 (x1);
      if (res >= 0)
        return res + 8; /* [8, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern53 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern58 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern58 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern58 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern58 (x3, 
E_V16QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      return pattern58 (x3, 
E_V4DImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern58 (x3, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V16HImode:
      if (pattern58 (x3, 
E_V16HImode) != 0)
        return -1;
      return 2;

    case E_V32QImode:
      if (pattern58 (x3, 
E_V32QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern85 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern96 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!non_volatile_mem_operand (operands[1], E_HImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!non_volatile_mem_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

int
pattern105 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XWINT (x2, 0) != 0L)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern104 (x1, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !reg_or_0_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !reg_or_0_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  return 0;
}

int
pattern132 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !and_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern139 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_0_or_1_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_uimm8_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern58 (x1, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern58 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern58 (x1, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern58 (x1, 
E_V16QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern153 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern161 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern167 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern174 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTRACT
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x4, 1);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  x9 = XEXP (x5, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern193 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern201 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern214 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 4)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (GET_MODE (x3) != E_SImode
          || !symbolic_operand (operands[0], E_SImode)
          || !(
#line 2748 "../../gcc/config/loongarch/loongarch.md"
(TARGET_TLS_DESC) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
        return -1;
      *pnum_clobbers = 9;
      return 210; /* got_load_tls_descsi */

    case E_DImode:
      if (GET_MODE (x3) != E_DImode
          || !symbolic_operand (operands[0], E_DImode)
          || !(
#line 2748 "../../gcc/config/loongarch/loongarch.md"
(TARGET_TLS_DESC) && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
        return -1;
      *pnum_clobbers = 9;
      return 211; /* got_load_tls_descdi */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      if (pattern139 (x3, 
E_V4DImode) != 0
          || !
#line 2165 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1881; /* lasx_xvrepl128vei_d */

    case E_V8SImode:
      if (pattern140 (x3, 
E_V8SImode) != 0
          || !
#line 2165 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1882; /* lasx_xvrepl128vei_w */

    case E_V16HImode:
      if (pattern70 (x3, 
E_V16HImode, 
E_V16HImode) != 0
          || !
#line 2165 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1883; /* lasx_xvrepl128vei_h */

    case E_V32QImode:
      if (pattern65 (x3, 
E_V32QImode) != 0
          || !
#line 2165 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1884; /* lasx_xvrepl128vei_b */

    case E_V4DFmode:
      if (pattern139 (x3, 
E_V4DFmode) != 0
          || !
#line 2165 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1885; /* lasx_xvrepl128vei_d_f */

    case E_V8SFmode:
      if (pattern140 (x3, 
E_V8SFmode) != 0
          || !
#line 2165 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1886; /* lasx_xvrepl128vei_w_f */

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_uimm5_operand (operands[2], E_VOIDmode))
    return -1;
  switch (pattern110 (x3))
    {
    case 0:
      if (!
#line 2257 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1386; /* lsx_vbsll_d */

    case 1:
      if (!
#line 2257 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1387; /* lsx_vbsll_w */

    case 2:
      if (!
#line 2257 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1388; /* lsx_vbsll_h */

    case 3:
      if (!
#line 2257 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1389; /* lsx_vbsll_b */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern81 (x1))
    {
    case 0:
      if (!
#line 2667 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2000; /* lasx_xvbsll_d */

    case 1:
      if (!
#line 2667 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2001; /* lasx_xvbsll_w */

    case 2:
      if (!
#line 2667 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2002; /* lasx_xvbsll_h */

    case 3:
      if (!
#line 2667 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2003; /* lasx_xvbsll_b */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 1180 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1713; /* lasx_xvbitset_d */

    case 1:
      if (!
#line 1180 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1714; /* lasx_xvbitset_w */

    case 2:
      if (!
#line 1180 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1715; /* lasx_xvbitset_h */

    case 3:
      if (!
#line 1180 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1716; /* lasx_xvbitset_b */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 2287 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1398; /* lsx_vsigncov_d */

    case 1:
      if (!
#line 2287 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1399; /* lsx_vsigncov_w */

    case 2:
      if (!
#line 2287 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1400; /* lsx_vsigncov_h */

    case 3:
      if (!
#line 2287 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1401; /* lsx_vsigncov_b */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 996 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1096; /* lsx_vbitrev_d */

    case 1:
      if (!
#line 996 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1097; /* lsx_vbitrev_w */

    case 2:
      if (!
#line 996 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1098; /* lsx_vbitrev_h */

    case 3:
      if (!
#line 996 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1099; /* lsx_vbitrev_b */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_uimm8_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V2DImode, 
E_V4DImode) != 0
          || !
#line 543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1558; /* lasx_vecinit_merge_v4di */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V4SImode, 
E_V8SImode) != 0
          || !
#line 543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1559; /* lasx_vecinit_merge_v8si */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V8HImode, 
E_V16HImode) != 0
          || !
#line 543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1560; /* lasx_vecinit_merge_v16hi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V16QImode, 
E_V32QImode) != 0
          || !
#line 543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1561; /* lasx_vecinit_merge_v32qi */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
          || !
#line 543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1562; /* lasx_vecinit_merge_v4df */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
          || !
#line 543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1563; /* lasx_vecinit_merge_v8sf */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x5, 0, 4);
  if (!const_4_to_7_operand (x7, E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && pattern207 (x5) == 0
          && 
#line 2007 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX
   && INTVAL (operands[2]) + 4 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 4 == INTVAL (operands[9])))
        return 1847; /* lasx_xvshuf4i_w_1 */
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      operands[3] = x7;
      x8 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XVECEXP (x5, 0, 2);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x10 = XVECEXP (x5, 0, 3);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (!rtx_equal_p (x11, operands[3]))
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (!rtx_equal_p (x13, operands[3])
          || !
#line 2142 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX && ((INTVAL (operands[3]) - INTVAL (operands[2])) == 4)))
        return -1;
      return 1879; /* lasx_xvrepl128vei_w_internal */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode)
          || pattern207 (x5) != 0
          || !
#line 2007 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX
   && INTVAL (operands[2]) + 4 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 4 == INTVAL (operands[9])))
        return -1;
      return 1848; /* lasx_xvshuf4i_w_f_1 */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern154 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  switch (XWINT (x4, 0))
    {
    case 0L:
      x5 = XVECEXP (x3, 0, 1);
      switch (XWINT (x5, 0))
        {
        case 16L:
          x6 = XVECEXP (x3, 0, 2);
          switch (XWINT (x6, 0))
            {
            case 2L:
              x7 = XVECEXP (x3, 0, 3);
              if (XWINT (x7, 0) != 18L)
                return -1;
              x8 = XVECEXP (x3, 0, 4);
              if (XWINT (x8, 0) != 4L)
                return -1;
              x9 = XVECEXP (x3, 0, 5);
              if (XWINT (x9, 0) != 20L)
                return -1;
              x10 = XVECEXP (x3, 0, 6);
              if (XWINT (x10, 0) != 6L)
                return -1;
              x11 = XVECEXP (x3, 0, 7);
              if (XWINT (x11, 0) != 22L)
                return -1;
              x12 = XVECEXP (x3, 0, 8);
              if (XWINT (x12, 0) != 8L)
                return -1;
              x13 = XVECEXP (x3, 0, 9);
              if (XWINT (x13, 0) != 24L)
                return -1;
              x14 = XVECEXP (x3, 0, 10);
              if (XWINT (x14, 0) != 10L)
                return -1;
              x15 = XVECEXP (x3, 0, 11);
              if (XWINT (x15, 0) != 26L)
                return -1;
              x16 = XVECEXP (x3, 0, 12);
              if (XWINT (x16, 0) != 12L)
                return -1;
              x17 = XVECEXP (x3, 0, 13);
              if (XWINT (x17, 0) != 28L)
                return -1;
              x18 = XVECEXP (x3, 0, 14);
              if (XWINT (x18, 0) != 14L)
                return -1;
              x19 = XVECEXP (x3, 0, 15);
              if (XWINT (x19, 0) != 30L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern205 (x2, 
E_V16QImode, 
E_V32QImode) != 0
                      || !
#line 1300 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1171; /* lsx_vpackev_b */

                case E_V16HImode:
                  if (pattern205 (x2, 
E_V16HImode, 
E_V32HImode) != 0
                      || !
#line 1439 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1776; /* lasx_xvpackev_h */

                default:
                  return -1;
                }

            case 1L:
              x7 = XVECEXP (x3, 0, 3);
              if (XWINT (x7, 0) != 17L)
                return -1;
              x8 = XVECEXP (x3, 0, 4);
              if (XWINT (x8, 0) != 2L)
                return -1;
              x9 = XVECEXP (x3, 0, 5);
              if (XWINT (x9, 0) != 18L)
                return -1;
              x10 = XVECEXP (x3, 0, 6);
              if (XWINT (x10, 0) != 3L)
                return -1;
              x11 = XVECEXP (x3, 0, 7);
              if (XWINT (x11, 0) != 19L)
                return -1;
              x12 = XVECEXP (x3, 0, 8);
              switch (XWINT (x12, 0))
                {
                case 4L:
                  x13 = XVECEXP (x3, 0, 9);
                  if (XWINT (x13, 0) != 20L)
                    return -1;
                  x14 = XVECEXP (x3, 0, 10);
                  if (XWINT (x14, 0) != 5L)
                    return -1;
                  x15 = XVECEXP (x3, 0, 11);
                  if (XWINT (x15, 0) != 21L)
                    return -1;
                  x16 = XVECEXP (x3, 0, 12);
                  if (XWINT (x16, 0) != 6L)
                    return -1;
                  x17 = XVECEXP (x3, 0, 13);
                  if (XWINT (x17, 0) != 22L)
                    return -1;
                  x18 = XVECEXP (x3, 0, 14);
                  if (XWINT (x18, 0) != 7L)
                    return -1;
                  x19 = XVECEXP (x3, 0, 15);
                  if (XWINT (x19, 0) != 23L
                      || pattern205 (x2, 
E_V16QImode, 
E_V32QImode) != 0
                      || !
#line 1483 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1185; /* lsx_vilvl_b */

                case 8L:
                  x13 = XVECEXP (x3, 0, 9);
                  if (XWINT (x13, 0) != 24L)
                    return -1;
                  x14 = XVECEXP (x3, 0, 10);
                  if (XWINT (x14, 0) != 9L)
                    return -1;
                  x15 = XVECEXP (x3, 0, 11);
                  if (XWINT (x15, 0) != 25L)
                    return -1;
                  x16 = XVECEXP (x3, 0, 12);
                  if (XWINT (x16, 0) != 10L)
                    return -1;
                  x17 = XVECEXP (x3, 0, 13);
                  if (XWINT (x17, 0) != 26L)
                    return -1;
                  x18 = XVECEXP (x3, 0, 14);
                  if (XWINT (x18, 0) != 11L)
                    return -1;
                  x19 = XVECEXP (x3, 0, 15);
                  if (XWINT (x19, 0) != 27L
                      || pattern205 (x2, 
E_V16HImode, 
E_V32HImode) != 0
                      || !
#line 1672 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1790; /* lasx_xvilvl_h */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2L:
          x6 = XVECEXP (x3, 0, 2);
          if (XWINT (x6, 0) != 4L)
            return -1;
          x7 = XVECEXP (x3, 0, 3);
          if (XWINT (x7, 0) != 6L)
            return -1;
          x8 = XVECEXP (x3, 0, 4);
          if (XWINT (x8, 0) != 16L)
            return -1;
          x9 = XVECEXP (x3, 0, 5);
          if (XWINT (x9, 0) != 18L)
            return -1;
          x10 = XVECEXP (x3, 0, 6);
          if (XWINT (x10, 0) != 20L)
            return -1;
          x11 = XVECEXP (x3, 0, 7);
          if (XWINT (x11, 0) != 22L)
            return -1;
          x12 = XVECEXP (x3, 0, 8);
          if (XWINT (x12, 0) != 8L)
            return -1;
          x13 = XVECEXP (x3, 0, 9);
          if (XWINT (x13, 0) != 10L)
            return -1;
          x14 = XVECEXP (x3, 0, 10);
          if (XWINT (x14, 0) != 12L)
            return -1;
          x15 = XVECEXP (x3, 0, 11);
          if (XWINT (x15, 0) != 14L)
            return -1;
          x16 = XVECEXP (x3, 0, 12);
          if (XWINT (x16, 0) != 24L)
            return -1;
          x17 = XVECEXP (x3, 0, 13);
          if (XWINT (x17, 0) != 26L)
            return -1;
          x18 = XVECEXP (x3, 0, 14);
          if (XWINT (x18, 0) != 28L)
            return -1;
          x19 = XVECEXP (x3, 0, 15);
          if (XWINT (x19, 0) != 30L
              || pattern205 (x2, 
E_V16HImode, 
E_V32HImode) != 0
              || !
#line 1845 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1824; /* lasx_xvpickev_h */

        default:
          return -1;
        }

    case 8L:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 24L)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 9L)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 25L)
        return -1;
      x8 = XVECEXP (x3, 0, 4);
      if (XWINT (x8, 0) != 10L)
        return -1;
      x9 = XVECEXP (x3, 0, 5);
      if (XWINT (x9, 0) != 26L)
        return -1;
      x10 = XVECEXP (x3, 0, 6);
      if (XWINT (x10, 0) != 11L)
        return -1;
      x11 = XVECEXP (x3, 0, 7);
      if (XWINT (x11, 0) != 27L
          || pattern221 (x2, 
E_V16QImode, 
E_V32QImode) != 0
          || !
#line 1360 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1175; /* lsx_vilvh_b */

    case 1L:
      x11 = XVECEXP (x3, 0, 7);
      if (XWINT (x11, 0) != 23L)
        return -1;
      x12 = XVECEXP (x3, 0, 8);
      if (XWINT (x12, 0) != 9L)
        return -1;
      x19 = XVECEXP (x3, 0, 15);
      if (XWINT (x19, 0) != 31L)
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      switch (XWINT (x5, 0))
        {
        case 17L:
          x6 = XVECEXP (x3, 0, 2);
          if (XWINT (x6, 0) != 3L)
            return -1;
          x7 = XVECEXP (x3, 0, 3);
          if (XWINT (x7, 0) != 19L)
            return -1;
          x8 = XVECEXP (x3, 0, 4);
          if (XWINT (x8, 0) != 5L)
            return -1;
          x9 = XVECEXP (x3, 0, 5);
          if (XWINT (x9, 0) != 21L)
            return -1;
          x10 = XVECEXP (x3, 0, 6);
          if (XWINT (x10, 0) != 7L)
            return -1;
          x13 = XVECEXP (x3, 0, 9);
          if (XWINT (x13, 0) != 25L)
            return -1;
          x14 = XVECEXP (x3, 0, 10);
          if (XWINT (x14, 0) != 11L)
            return -1;
          x15 = XVECEXP (x3, 0, 11);
          if (XWINT (x15, 0) != 27L)
            return -1;
          x16 = XVECEXP (x3, 0, 12);
          if (XWINT (x16, 0) != 13L)
            return -1;
          x17 = XVECEXP (x3, 0, 13);
          if (XWINT (x17, 0) != 29L)
            return -1;
          x18 = XVECEXP (x3, 0, 14);
          if (XWINT (x18, 0) != 15L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern205 (x2, 
E_V16QImode, 
E_V32QImode) != 0
                  || !
#line 1423 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1181; /* lsx_vpackod_b */

            case E_V16HImode:
              if (pattern205 (x2, 
E_V16HImode, 
E_V32HImode) != 0
                  || !
#line 1594 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1786; /* lasx_xvpackod_h */

            default:
              return -1;
            }

        case 3L:
          x6 = XVECEXP (x3, 0, 2);
          if (XWINT (x6, 0) != 5L)
            return -1;
          x7 = XVECEXP (x3, 0, 3);
          if (XWINT (x7, 0) != 7L)
            return -1;
          x8 = XVECEXP (x3, 0, 4);
          if (XWINT (x8, 0) != 17L)
            return -1;
          x9 = XVECEXP (x3, 0, 5);
          if (XWINT (x9, 0) != 19L)
            return -1;
          x10 = XVECEXP (x3, 0, 6);
          if (XWINT (x10, 0) != 21L)
            return -1;
          x13 = XVECEXP (x3, 0, 9);
          if (XWINT (x13, 0) != 11L)
            return -1;
          x14 = XVECEXP (x3, 0, 10);
          if (XWINT (x14, 0) != 13L)
            return -1;
          x15 = XVECEXP (x3, 0, 11);
          if (XWINT (x15, 0) != 15L)
            return -1;
          x16 = XVECEXP (x3, 0, 12);
          if (XWINT (x16, 0) != 25L)
            return -1;
          x17 = XVECEXP (x3, 0, 13);
          if (XWINT (x17, 0) != 27L)
            return -1;
          x18 = XVECEXP (x3, 0, 14);
          if (XWINT (x18, 0) != 29L
              || pattern205 (x2, 
E_V16HImode, 
E_V32HImode) != 0
              || !
#line 1921 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1828; /* lasx_xvpickod_h */

        default:
          return -1;
        }

    case 4L:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 20L)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 5L)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 21L)
        return -1;
      x8 = XVECEXP (x3, 0, 4);
      if (XWINT (x8, 0) != 6L)
        return -1;
      x9 = XVECEXP (x3, 0, 5);
      if (XWINT (x9, 0) != 22L)
        return -1;
      x10 = XVECEXP (x3, 0, 6);
      if (XWINT (x10, 0) != 7L)
        return -1;
      x11 = XVECEXP (x3, 0, 7);
      if (XWINT (x11, 0) != 23L
          || pattern221 (x2, 
E_V16HImode, 
E_V32HImode) != 0
          || !
#line 1515 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1780; /* lasx_xvilvh_h */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case FMA:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case NEG:
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern176 (x3, 
E_SFmode) != 0
                      || !(
#line 1201 "../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 53; /* *fmasf4 */

                case E_DFmode:
                  if (pattern176 (x3, 
E_DFmode) != 0
                      || !(
#line 1201 "../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 54; /* *fmadf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern177 (x3, 
E_SFmode) != 0
                      || !(
#line 1214 "../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 55; /* *fmssf4 */

                case E_DFmode:
                  if (pattern177 (x3, 
E_DFmode) != 0
                      || !(
#line 1214 "../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 56; /* *fmsdf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x6;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern178 (x3, 
E_SFmode) != 0
                      || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 57; /* *fnmssf4 */

                case E_DFmode:
                  if (pattern178 (x3, 
E_DFmode) != 0
                      || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                    return -1;
                  return 58; /* *fnmsdf4 */

                case E_V2DFmode:
                  if (pattern178 (x3, 
E_V2DFmode) != 0
                      || !
#line 2401 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1410; /* vfnmaddv2df4_nmadd4 */

                case E_V4SFmode:
                  if (pattern178 (x3, 
E_V4SFmode) != 0
                      || !
#line 2401 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1411; /* vfnmaddv4sf4_nmadd4 */

                case E_V4DFmode:
                  if (pattern178 (x3, 
E_V4DFmode) != 0
                      || !
#line 2811 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2024; /* xvfnmaddv4df4_nmadd4 */

                case E_V8SFmode:
                  if (pattern178 (x3, 
E_V8SFmode) != 0
                      || !
#line 2811 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2025; /* xvfnmaddv8sf4_nmadd4 */

                default:
                  return -1;
                }

            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern179 (x3, 
E_SFmode) != 0
                      || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 59; /* *fnmasf4 */

                case E_DFmode:
                  if (pattern179 (x3, 
E_DFmode) != 0
                      || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                    return -1;
                  return 60; /* *fnmadf4 */

                case E_V2DFmode:
                  if (pattern179 (x3, 
E_V2DFmode) != 0
                      || !
#line 2388 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1408; /* vfnmsubv2df4_nmsub4 */

                case E_V4SFmode:
                  if (pattern179 (x3, 
E_V4SFmode) != 0
                      || !
#line 2388 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1409; /* vfnmsubv4sf4_nmsub4 */

                case E_V4DFmode:
                  if (pattern179 (x3, 
E_V4DFmode) != 0
                      || !
#line 2798 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2022; /* xvfnmsubv4df4_nmsub4 */

                case E_V8SFmode:
                  if (pattern179 (x3, 
E_V8SFmode) != 0
                      || !
#line 2798 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2023; /* xvfnmsubv8sf4_nmsub4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 91; /* negsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 92; /* negdi2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 94; /* negsf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 95; /* negdf2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 787; /* negv2df2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 788; /* negv4sf2 */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode
              || !register_operand (operands[1], E_V4DFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 789; /* negv4df2 */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || !register_operand (operands[1], E_V8SFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 790; /* negv8sf2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 2034 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1324; /* vnegv2di2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 2034 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1325; /* vnegv4si2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 2034 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1326; /* vnegv8hi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2034 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1327; /* vnegv16qi2 */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode
              || !register_operand (operands[1], E_V4DImode)
              || !
#line 2494 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1951; /* negv4di2 */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode
              || !register_operand (operands[1], E_V8SImode)
              || !
#line 2494 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1952; /* negv8si2 */

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x3) != E_V16HImode
              || !register_operand (operands[1], E_V16HImode)
              || !
#line 2494 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1953; /* negv16hi2 */

        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x3) != E_V32QImode
              || !register_operand (operands[1], E_V32QImode)
              || !
#line 2494 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1954; /* negv32qi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x3, 
E_SFmode) != 0
              || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 12; /* mulsf3 */

        case E_DFmode:
          if (pattern0 (x3, 
E_DFmode) != 0
              || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 13; /* muldf3 */

        case E_SImode:
          if (pattern0 (x3, 
E_SImode) != 0)
            return -1;
          return 14; /* *mulsi3 */

        case E_DImode:
          if (pattern0 (x3, 
E_DImode) != 0
              || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 15; /* *muldi3 */

        case E_V2DImode:
          if (pattern0 (x3, 
E_V2DImode) != 0
              || !
#line 596 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 976; /* mulv2di3 */

        case E_V4SImode:
          if (pattern0 (x3, 
E_V4SImode) != 0
              || !
#line 596 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 977; /* mulv4si3 */

        case E_V8HImode:
          if (pattern0 (x3, 
E_V8HImode) != 0
              || !
#line 596 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 978; /* mulv8hi3 */

        case E_V16QImode:
          if (pattern0 (x3, 
E_V16QImode) != 0
              || !
#line 596 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 979; /* mulv16qi3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 813 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1042; /* mulv2df3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !
#line 813 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1043; /* mulv4sf3 */

        case E_V4DImode:
          if (pattern0 (x3, 
E_V4DImode) != 0
              || !
#line 720 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1578; /* mulv4di3 */

        case E_V8SImode:
          if (pattern0 (x3, 
E_V8SImode) != 0
              || !
#line 720 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1579; /* mulv8si3 */

        case E_V16HImode:
          if (pattern0 (x3, 
E_V16HImode) != 0
              || !
#line 720 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1580; /* mulv16hi3 */

        case E_V32QImode:
          if (pattern0 (x3, 
E_V32QImode) != 0
              || !
#line 720 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1581; /* mulv32qi3 */

        case E_V4DFmode:
          if (pattern0 (x3, 
E_V4DFmode) != 0
              || !
#line 954 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1644; /* mulv4df3 */

        case E_V8SFmode:
          if (pattern0 (x3, 
E_V8SFmode) != 0
              || !
#line 954 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1645; /* mulv8sf3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_DImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 949 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 19; /* mulsidi3_64bit */

        case VEC_SELECT:
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != VEC_SELECT)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x9 = XEXP (x6, 1);
          operands[3] = x9;
          switch (pattern158 (x3))
            {
            case 0:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 793; /* simd_mulw_evod_v2di_s */

            case 1:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 799; /* simd_mulw_evod_v4si_s */

            case 2:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 805; /* simd_mulw_evod_v8hi_s */

            case 3:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 811; /* simd_mulw_evod_v16qi_s */

            case 4:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 817; /* simd_mulw_evod_v4di_s */

            case 5:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 823; /* simd_mulw_evod_v8si_s */

            case 6:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 829; /* simd_mulw_evod_v16hi_s */

            case 7:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 835; /* simd_mulw_evod_v32qi_s */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ZERO_EXTEND
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 949 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 20; /* umulsidi3_64bit */

        case VEC_SELECT:
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x9 = XEXP (x6, 1);
          operands[3] = x9;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case ZERO_EXTEND:
              x7 = XEXP (x5, 0);
              if (GET_CODE (x7) != VEC_SELECT)
                return -1;
              switch (pattern158 (x3))
                {
                case 0:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 796; /* simd_mulw_evod_v2di_u */

                case 1:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 802; /* simd_mulw_evod_v4si_u */

                case 2:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 808; /* simd_mulw_evod_v8hi_u */

                case 3:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 814; /* simd_mulw_evod_v16qi_u */

                case 4:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 820; /* simd_mulw_evod_v4di_u */

                case 5:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 826; /* simd_mulw_evod_v8si_u */

                case 6:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 832; /* simd_mulw_evod_v16hi_u */

                case 7:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 838; /* simd_mulw_evod_v32qi_u */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern30 (x3))
                {
                case 0:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 841; /* simd_mulw_evod_v2di_hetero */

                case 1:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 844; /* simd_mulw_evod_v4si_hetero */

                case 2:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 847; /* simd_mulw_evod_v8hi_hetero */

                case 3:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 850; /* simd_mulw_evod_v16qi_hetero */

                case 4:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 853; /* simd_mulw_evod_v4di_hetero */

                case 5:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 856; /* simd_mulw_evod_v8si_hetero */

                case 6:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 859; /* simd_mulw_evod_v16hi_hetero */

                case 7:
                  if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 862; /* simd_mulw_evod_v32qi_hetero */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern5 (x3))
        {
        case 0:
          return 251; /* *rotrsi3 */

        case 1:
          if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 252; /* *rotrdi3 */

        case 2:
          if (register_operand (operands[2], E_V2DImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 619; /* vrotrv2di3 */
          if (!const_uimm6_operand (operands[2], E_SImode)
              || !
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 630; /* rotrv2di3 */

        case 3:
          if (register_operand (operands[2], E_V4SImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 620; /* vrotrv4si3 */
          if (!const_uimm5_operand (operands[2], E_SImode)
              || !
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 634; /* rotrv4si3 */

        case 4:
          if (register_operand (operands[2], E_V8HImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 621; /* vrotrv8hi3 */
          if (!const_uimm4_operand (operands[2], E_SImode)
              || !
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 638; /* rotrv8hi3 */

        case 5:
          if (register_operand (operands[2], E_V16QImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 622; /* vrotrv16qi3 */
          if (!const_uimm3_operand (operands[2], E_SImode)
              || !
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 642; /* rotrv16qi3 */

        case 6:
          if (register_operand (operands[2], E_V4DImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 623; /* vrotrv4di3 */
          if (!const_uimm6_operand (operands[2], E_SImode)
              || !(
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 646; /* rotrv4di3 */

        case 7:
          if (register_operand (operands[2], E_V8SImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 624; /* vrotrv8si3 */
          if (!const_uimm5_operand (operands[2], E_SImode)
              || !(
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 650; /* rotrv8si3 */

        case 8:
          if (register_operand (operands[2], E_V16HImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 625; /* vrotrv16hi3 */
          if (!const_uimm4_operand (operands[2], E_SImode)
              || !(
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 654; /* rotrv16hi3 */

        case 9:
          if (register_operand (operands[2], E_V32QImode)
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 626; /* vrotrv32qi3 */
          if (!const_uimm3_operand (operands[2], E_SImode)
              || !(
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 658; /* rotrv32qi3 */

        default:
          return -1;
        }

    case BSWAP:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XWINT (x5, 0))
        {
        case 16L:
          if (pattern111 (x3, 
E_SImode) != 0)
            return -1;
          return 269; /* revb_2h */

        case 32L:
          if (pattern111 (x3, 
E_DImode) != 0
              || !
#line 3243 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 272; /* revb_2w */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern83 (x3))
        {
        case 0:
          return 75; /* clzsi2 */

        case 1:
          if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 76; /* clzdi2 */

        case 2:
          if (!
#line 1608 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1211; /* clzv2di2 */

        case 3:
          if (!
#line 1608 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1212; /* clzv4si2 */

        case 4:
          if (!
#line 1608 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1213; /* clzv8hi2 */

        case 5:
          if (!
#line 1608 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1214; /* clzv16qi2 */

        case 6:
          if (!
#line 1788 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1815; /* clzv4di2 */

        case 7:
          if (!
#line 1788 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1816; /* clzv8si2 */

        case 8:
          if (!
#line 1788 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1817; /* clzv16hi2 */

        case 9:
          if (!
#line 1788 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1818; /* clzv32qi2 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern111 (x3, 
E_V2DImode) != 0
              || !
#line 1600 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1207; /* lsx_vclo_d */

        case E_V4SImode:
          if (pattern111 (x3, 
E_V4SImode) != 0
              || !
#line 1600 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1208; /* lsx_vclo_w */

        case E_V8HImode:
          if (pattern111 (x3, 
E_V8HImode) != 0
              || !
#line 1600 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1209; /* lsx_vclo_h */

        case E_V16QImode:
          if (pattern111 (x3, 
E_V16QImode) != 0
              || !
#line 1600 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1210; /* lsx_vclo_b */

        case E_V4DImode:
          if (pattern111 (x3, 
E_V4DImode) != 0
              || !
#line 1780 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1811; /* lasx_xvclo_d */

        case E_V8SImode:
          if (pattern111 (x3, 
E_V8SImode) != 0
              || !
#line 1780 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1812; /* lasx_xvclo_w */

        case E_V16HImode:
          if (pattern111 (x3, 
E_V16HImode) != 0
              || !
#line 1780 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1813; /* lasx_xvclo_h */

        case E_V32QImode:
          if (pattern111 (x3, 
E_V32QImode) != 0
              || !
#line 1780 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1814; /* lasx_xvclo_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case PC:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LABEL_REF)
        return -1;
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return -1;
          return 341; /* tablejumpsi */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return -1;
          return 342; /* tablejumpdi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x8;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern200 (
E_HImode) != 0
                  || !
#line 4401 "../../gcc/config/loongarch/loongarch.md"
(reload_completed))
                return -1;
              return 440; /* *join2_load_storehi */

            case E_SImode:
              if (pattern200 (
E_SImode) != 0
                  || !
#line 4401 "../../gcc/config/loongarch/loongarch.md"
(reload_completed))
                return -1;
              return 441; /* *join2_load_storesi */

            case E_SFmode:
              if (pattern200 (
E_SFmode) != 0
                  || !(
#line 4401 "../../gcc/config/loongarch/loongarch.md"
(reload_completed) && 
#line 381 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 442; /* *join2_load_storesf */

            case E_DFmode:
              if (pattern200 (
E_DFmode) != 0
                  || !(
#line 4401 "../../gcc/config/loongarch/loongarch.md"
(reload_completed) && 
#line 382 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 443; /* *join2_load_storedf */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          x5 = XEXP (x4, 0);
          if (!rtx_equal_p (x5, operands[1]))
            return -1;
          switch (XVECLEN (x8, 0))
            {
            case 2:
              if (XINT (x8, 1) != 48)
                return -1;
              x9 = XVECEXP (x8, 0, 1);
              operands[3] = x9;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              x10 = XVECEXP (x8, 0, 0);
              switch (GET_CODE (x10))
                {
                case PLUS:
                  x11 = XEXP (x10, 1);
                  operands[2] = x11;
                  x12 = XEXP (x10, 0);
                  if (!rtx_equal_p (x12, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern210 (x8, 
E_SImode) != 0)
                        return -1;
                      return 509; /* atomic_fetch_addsi */

                    case E_DImode:
                      if (pattern210 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 513; /* atomic_fetch_adddi */

                    case E_QImode:
                      if (pattern210 (x8, 
E_QImode) != 0
                          || !
#line 690 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAM_BH))
                        return -1;
                      return 543; /* atomic_fetch_addqi_short */

                    case E_HImode:
                      if (pattern210 (x8, 
E_HImode) != 0
                          || !
#line 690 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAM_BH))
                        return -1;
                      return 544; /* atomic_fetch_addhi_short */

                    default:
                      return -1;
                    }

                case IOR:
                  switch (pattern211 (x8))
                    {
                    case 0:
                      return 510; /* atomic_fetch_orsi */

                    case 1:
                      if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 514; /* atomic_fetch_ordi */

                    default:
                      return -1;
                    }

                case XOR:
                  switch (pattern211 (x8))
                    {
                    case 0:
                      return 511; /* atomic_fetch_xorsi */

                    case 1:
                      if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 515; /* atomic_fetch_xordi */

                    default:
                      return -1;
                    }

                case AND:
                  switch (pattern211 (x8))
                    {
                    case 0:
                      return 512; /* atomic_fetch_andsi */

                    case 1:
                      if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 516; /* atomic_fetch_anddi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 3:
              if (XINT (x8, 1) != 41)
                return -1;
              x10 = XVECEXP (x8, 0, 0);
              operands[2] = x10;
              x9 = XVECEXP (x8, 0, 1);
              operands[3] = x9;
              x13 = XVECEXP (x8, 0, 2);
              operands[4] = x13;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern214 (x8, 
E_SImode) != 0)
                    return -1;
                  if (pnum_clobbers != NULL)
                    {
                      *pnum_clobbers = 1;
                      return 521; /* atomic_cas_value_strongsi */
                    }
                  if (!
#line 293 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAMCAS))
                    return -1;
                  return 525; /* atomic_cas_value_strongsi_amcas */

                case E_DImode:
                  if (pattern214 (x8, 
E_DImode) != 0)
                    return -1;
                  if (pnum_clobbers != NULL
                      && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    {
                      *pnum_clobbers = 1;
                      return 522; /* atomic_cas_value_strongdi */
                    }
                  if (!(
#line 293 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAMCAS) && 
#line 401 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                    return -1;
                  return 526; /* atomic_cas_value_strongdi_amcas */

                case E_QImode:
                  if (pattern214 (x8, 
E_QImode) != 0
                      || !
#line 293 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAMCAS))
                    return -1;
                  return 523; /* atomic_cas_value_strongqi_amcas */

                case E_HImode:
                  if (pattern214 (x8, 
E_HImode) != 0
                      || !
#line 293 "../../gcc/config/loongarch/sync.md"
(ISA_HAS_LAMCAS))
                    return -1;
                  return 524; /* atomic_cas_value_stronghi_amcas */

                default:
                  return -1;
                }

            case 5:
              if (pnum_clobbers == NULL)
                return -1;
              x10 = XVECEXP (x8, 0, 0);
              operands[2] = x10;
              x9 = XVECEXP (x8, 0, 1);
              operands[3] = x9;
              x13 = XVECEXP (x8, 0, 2);
              operands[4] = x13;
              x14 = XVECEXP (x8, 0, 3);
              operands[5] = x14;
              x15 = XVECEXP (x8, 0, 4);
              operands[6] = x15;
              if (!const_int_operand (operands[6], E_SImode))
                return -1;
              switch (XINT (x8, 1))
                {
                case 41:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 1;
                      return 527; /* atomic_cas_value_cmp_and_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 1;
                      return 528; /* atomic_cas_value_cmp_and_7_di */

                    default:
                      return -1;
                    }

                case 42:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 529; /* atomic_cas_value_add_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 530; /* atomic_cas_value_add_7_di */

                    default:
                      return -1;
                    }

                case 43:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 531; /* atomic_cas_value_sub_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 532; /* atomic_cas_value_sub_7_di */

                    default:
                      return -1;
                    }

                case 44:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 533; /* atomic_cas_value_and_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 534; /* atomic_cas_value_and_7_di */

                    default:
                      return -1;
                    }

                case 45:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 535; /* atomic_cas_value_xor_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 536; /* atomic_cas_value_xor_7_di */

                    default:
                      return -1;
                    }

                case 46:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 537; /* atomic_cas_value_or_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 538; /* atomic_cas_value_or_7_di */

                    default:
                      return -1;
                    }

                case 47:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 539; /* atomic_cas_value_nand_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 540; /* atomic_cas_value_nand_7_di */

                    default:
                      return -1;
                    }

                case 49:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 1;
                      return 541; /* atomic_cas_value_exchange_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 1;
                      return 542; /* atomic_cas_value_exchange_7_di */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
