/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern0 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DImode:
      if (pattern2 (x3, 
E_V2DImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern2 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V8HImode:
      if (pattern2 (x3, 
E_V8HImode) != 0)
        return -1;
      return 6;

    case E_V16QImode:
      if (pattern2 (x3, 
E_V16QImode) != 0)
        return -1;
      return 7;

    case E_V4DFmode:
      if (pattern0 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 8;

    case E_V8SFmode:
      if (pattern0 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 9;

    case E_V4DImode:
      if (pattern2 (x3, 
E_V4DImode) != 0)
        return -1;
      return 10;

    case E_V8SImode:
      if (pattern2 (x3, 
E_V8SImode) != 0)
        return -1;
      return 11;

    case E_V16HImode:
      if (pattern2 (x3, 
E_V16HImode) != 0)
        return -1;
      return 12;

    case E_V32QImode:
      if (pattern2 (x3, 
E_V32QImode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != SIGN_EXTEND)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern27 (x1, 
E_V2DImode, 
E_V1DImode, 
E_V1TImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern27 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern27 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern27 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2TImode:
      if (pattern27 (x1, 
E_V4DImode, 
E_V2DImode, 
E_V2TImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern27 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 5;

    case E_V8SImode:
      if (pattern27 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V8SImode) != 0)
        return -1;
      return 6;

    case E_V16HImode:
      if (pattern27 (x1, 
E_V32QImode, 
E_V16QImode, 
E_V16HImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!reg_or_0_operand (operands[2], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_uimm6_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern70 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !const_uimm3_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      return pattern64 (x3, 
E_V4DImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern68 (x3, 
E_V8SImode, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V16HImode:
      if (pattern69 (x3, 
E_V16HImode, 
E_V16HImode) != 0)
        return -1;
      return 2;

    case E_V32QImode:
      if (pattern66 (x3, 
E_V32QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern86 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 2;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode))
        return -1;
      return 3;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 4;

    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern97 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 1
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern104 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern111 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !arith_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !arith_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern124 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode)
      || !plus_di_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_val_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern138 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (REGNO (x2) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != XOR
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  return pattern137 (x2); /* [-1, 2] */
}

int
pattern151 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern27 (x1, 
E_V2DImode, 
E_V1DImode, 
E_V1TImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern27 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern27 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern27 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2TImode:
      if (pattern27 (x1, 
E_V4DImode, 
E_V2DImode, 
E_V2TImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern27 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 5;

    case E_V8SImode:
      if (pattern27 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V8SImode) != 0)
        return -1;
      return 6;

    case E_V16HImode:
      if (pattern27 (x1, 
E_V32QImode, 
E_V16QImode, 
E_V16HImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern178 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern185 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode
      || !aq12h_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern194 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !const_vector_same_val_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!const_0_operand (operands[2], E_SImode))
    return -1;
  switch (XINT (x2, 1))
    {
    case 77:
      return pattern201 (); /* [-1, 5] */

    case 76:
      res = pattern201 ();
      if (res >= 0)
        return res + 6; /* [6, 11] */
      return -1;

    case 184:
      res = pattern202 ();
      if (res >= 0)
        return res + 12; /* [12, 17] */
      return -1;

    case 185:
      res = pattern202 ();
      if (res >= 0)
        return res + 18; /* [18, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (XWINT (x2, 0) != 6L)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (XWINT (x3, 0) != 14L)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (XWINT (x4, 0) != 7L)
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  if (XWINT (x5, 0) != 15L)
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (pattern110 (x3))
    {
    case 0:
      if (!
#line 2277 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1394; /* lsx_vmskltz_d */

    case 1:
      if (!
#line 2277 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1395; /* lsx_vmskltz_w */

    case 2:
      if (!
#line 2277 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1396; /* lsx_vmskltz_h */

    case 3:
      if (!
#line 2277 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1397; /* lsx_vmskltz_b */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_uimm5_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2247 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1380; /* lsx_vbsrl_d */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 2247 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1381; /* lsx_vbsrl_w */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 2247 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1382; /* lsx_vbsrl_h */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 2247 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1383; /* lsx_vbsrl_b */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 2247 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1384; /* lsx_vbsrl_d_f */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2247 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1385; /* lsx_vbsrl_w_f */

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_lsx_branch_operand (operands[2], E_VOIDmode))
    return -1;
  switch (pattern110 (x3))
    {
    case 0:
      if (!
#line 1006 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1100; /* lsx_vbitrevi_d */

    case 1:
      if (!
#line 1006 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1101; /* lsx_vbitrevi_w */

    case 2:
      if (!
#line 1006 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1102; /* lsx_vbitrevi_h */

    case 3:
      if (!
#line 1006 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1103; /* lsx_vbitrevi_b */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DFmode:
      if (pattern61 (x3, 
E_DFmode, 
E_V4DFmode) != 0
          || !
#line 1278 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1753; /* lasx_xvilvl_d_f_internal */

    case E_V8SFmode:
      if (pattern61 (x3, 
E_SFmode, 
E_V8SFmode) != 0
          || !
#line 1278 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1754; /* lasx_xvilvl_w_f_internal */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 1086 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1678; /* lasx_xvavg_u_du */

    case 1:
      if (!
#line 1086 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1679; /* lasx_xvavg_u_wu */

    case 2:
      if (!
#line 1086 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1680; /* lasx_xvavg_u_hu */

    case 3:
      if (!
#line 1086 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1681; /* lasx_xvavg_u_bu */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (pattern61 (x3, 
E_DFmode, 
E_V2DFmode) != 0
          || !
#line 1167 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1149; /* lsx_vilvl_d_f_internal */

    case E_V4SFmode:
      if (pattern61 (x3, 
E_SFmode, 
E_V4SFmode) != 0
          || !
#line 1167 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1150; /* lsx_vilvl_w_f_internal */

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 753; /* lsx_vfcmp_sor_d */

    case 1:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 761; /* lsx_vfcmp_sor_s */

    case 2:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 769; /* lasx_xvfcmp_sor_d */

    case 3:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 777; /* lasx_xvfcmp_sor_s */

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != ABS)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  x9 = XEXP (x2, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_CODE (x3))
    {
    case GT:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern192 (x2, 
E_SFmode) != 0
              || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 87; /* smaxasf3 */

        case E_DFmode:
          if (pattern192 (x2, 
E_DFmode) != 0
              || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 88; /* smaxadf3 */

        case E_V2DFmode:
          if (pattern192 (x2, 
E_V2DFmode) != 0
              || !
#line 1188 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1153; /* lsx_vfmaxa_d */

        case E_V4SFmode:
          if (pattern192 (x2, 
E_V4SFmode) != 0
              || !
#line 1188 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1154; /* lsx_vfmaxa_s */

        case E_V4DFmode:
          if (pattern192 (x2, 
E_V4DFmode) != 0
              || !
#line 1299 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1757; /* lasx_xvfmaxa_d */

        case E_V8SFmode:
          if (pattern192 (x2, 
E_V8SFmode) != 0
              || !
#line 1299 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1758; /* lasx_xvfmaxa_s */

        default:
          return -1;
        }

    case LT:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern192 (x2, 
E_SFmode) != 0
              || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 89; /* sminasf3 */

        case E_DFmode:
          if (pattern192 (x2, 
E_DFmode) != 0
              || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 90; /* sminadf3 */

        case E_V2DFmode:
          if (pattern192 (x2, 
E_V2DFmode) != 0
              || !
#line 1209 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1157; /* lsx_vfmina_d */

        case E_V4SFmode:
          if (pattern192 (x2, 
E_V4SFmode) != 0
              || !
#line 1209 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1158; /* lsx_vfmina_s */

        case E_V4DFmode:
          if (pattern192 (x2, 
E_V4DFmode) != 0
              || !
#line 1320 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1761; /* lasx_xvfmina_d */

        case E_V8SFmode:
          if (pattern192 (x2, 
E_V8SFmode) != 0
              || !
#line 1320 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1762; /* lasx_xvfmina_s */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_V16HImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_V16HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16HImode))
    return -1;
  x5 = XEXP (x3, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!const_uimm3_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x5, 0, 8);
  operands[3] = x7;
  if (!const_8_to_15_operand (operands[3], E_VOIDmode)
      || pattern208 (x5) != 0)
    return -1;
  x8 = XVECEXP (x5, 0, 9);
  if (!rtx_equal_p (x8, operands[3]))
    return -1;
  x9 = XVECEXP (x5, 0, 10);
  if (!rtx_equal_p (x9, operands[3]))
    return -1;
  x10 = XVECEXP (x5, 0, 11);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  x11 = XVECEXP (x5, 0, 12);
  if (!rtx_equal_p (x11, operands[3]))
    return -1;
  x12 = XVECEXP (x5, 0, 13);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  x13 = XVECEXP (x5, 0, 14);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  x14 = XVECEXP (x5, 0, 15);
  if (!rtx_equal_p (x14, operands[3])
      || !
#line 2129 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX && ((INTVAL (operands[3]) - INTVAL (operands[2])) == 8)))
    return -1;
  return 1878; /* lasx_xvrepl128vei_h_internal */
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  switch (XWINT (x4, 0))
    {
    case 0L:
      if (XWINT (x5, 0) != 4L)
        return -1;
      switch (XWINT (x6, 0))
        {
        case 2L:
          if (XWINT (x7, 0) != 6L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern205 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                  || !
#line 1328 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1173; /* lsx_vpackev_w */

            case E_V4SFmode:
              if (pattern205 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                  || !
#line 1341 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1174; /* lsx_vpackev_w_f */

            case E_V4DImode:
              if (pattern205 (x2, 
E_V4DImode, 
E_V8DImode) != 0
                  || !
#line 1715 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1793; /* lasx_xvilvl_d */

            case E_V4DFmode:
              if (pattern205 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
                  || !
#line 1728 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1794; /* lasx_xvilvl_d_f */

            default:
              return -1;
            }

        case 1L:
          if (XWINT (x7, 0) != 5L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern205 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                  || !
#line 1511 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1187; /* lsx_vilvl_w */

            case E_V4SFmode:
              if (pattern205 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                  || !
#line 1524 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1188; /* lsx_vilvl_w_f */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2L:
      if (XWINT (x5, 0) != 6L
          || XWINT (x6, 0) != 3L
          || XWINT (x7, 0) != 7L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern205 (x2, 
E_V4SImode, 
E_V8SImode) != 0
              || !
#line 1392 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1177; /* lsx_vilvh_w */

        case E_V4SFmode:
          if (pattern205 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 1392 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1178; /* lsx_vilvh_w_f */

        default:
          return -1;
        }

    case 1L:
      if (XWINT (x5, 0) != 5L
          || XWINT (x6, 0) != 3L
          || XWINT (x7, 0) != 7L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern205 (x2, 
E_V4SImode, 
E_V8SImode) != 0
              || !
#line 1451 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1183; /* lsx_vpackod_w */

        case E_V4SFmode:
          if (pattern205 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 1464 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1184; /* lsx_vpackod_w_f */

        case E_V4DImode:
          if (pattern205 (x2, 
E_V4DImode, 
E_V8DImode) != 0
              || !
#line 1547 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1783; /* lasx_xvilvh_d */

        case E_V4DFmode:
          if (pattern205 (x2, 
E_V4DFmode, 
E_V8DFmode) != 0
              || !
#line 1547 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1784; /* lasx_xvilvh_d_f */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern130 (x3, 
E_SImode) != 0)
            return -1;
          return 96; /* *iorsi3 */

        case E_DImode:
          if (pattern130 (x3, 
E_DImode) != 0
              || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 98; /* *iordi3 */

        case E_HImode:
          if (pattern130 (x3, 
E_HImode) != 0)
            return -1;
          return 111; /* *iorhi3 */

        case E_V2DImode:
          if (pattern131 (x3, 
E_V2DImode) != 0
              || !
#line 675 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1010; /* iorv2di3 */

        case E_V4SImode:
          if (pattern131 (x3, 
E_V4SImode) != 0
              || !
#line 675 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1011; /* iorv4si3 */

        case E_V8HImode:
          if (pattern131 (x3, 
E_V8HImode) != 0
              || !
#line 675 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1012; /* iorv8hi3 */

        case E_V16QImode:
          if (pattern131 (x3, 
E_V16QImode) != 0
              || !
#line 675 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1013; /* iorv16qi3 */

        case E_V2DFmode:
          if (pattern131 (x3, 
E_V2DFmode) != 0
              || !
#line 675 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1014; /* iorv2df3 */

        case E_V4SFmode:
          if (pattern131 (x3, 
E_V4SFmode) != 0
              || !
#line 675 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1015; /* iorv4sf3 */

        case E_V4DImode:
          if (pattern131 (x3, 
E_V4DImode) != 0
              || !
#line 813 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1612; /* iorv4di3 */

        case E_V8SImode:
          if (pattern131 (x3, 
E_V8SImode) != 0
              || !
#line 813 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1613; /* iorv8si3 */

        case E_V16HImode:
          if (pattern131 (x3, 
E_V16HImode) != 0
              || !
#line 813 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1614; /* iorv16hi3 */

        case E_V32QImode:
          if (pattern131 (x3, 
E_V32QImode) != 0
              || !
#line 813 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1615; /* iorv32qi3 */

        case E_V4DFmode:
          if (pattern131 (x3, 
E_V4DFmode) != 0
              || !
#line 813 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1616; /* iorv4df3 */

        case E_V8SFmode:
          if (pattern131 (x3, 
E_V8SFmode) != 0
              || !
#line 813 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1617; /* iorv8sf3 */

        default:
          return -1;
        }

    case AND:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              switch (pattern21 (x3))
                {
                case 0:
                  if (!
#line 1600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (SImode, operands)))
                    return -1;
                  return 105; /* *bstrins_si_for_ior_mask */

                case 1:
                  if (!(
#line 1600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (DImode, operands)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                    return -1;
                  return 108; /* *bstrins_di_for_ior_mask */

                default:
                  return -1;
                }

            case CONST_INT:
              operands[3] = x5;
              if (!const_lu52i_operand (operands[3], E_VOIDmode)
                  || pattern111 (x3, 
E_DImode) != 0
                  || !lu52i_mask_operand (operands[2], E_VOIDmode)
                  || !
#line 2592 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 177; /* lu52i_d */

            default:
              return -1;
            }

        case NOT:
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != AND)
            return -1;
          x8 = XEXP (x5, 1);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[2] = x8;
              x9 = XEXP (x6, 0);
              operands[3] = x9;
              x7 = XEXP (x4, 1);
              operands[1] = x7;
              x10 = XEXP (x5, 0);
              if (!rtx_equal_p (x10, operands[3]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern193 (x3, 
E_V2DImode) != 0
                      || !
#line 1018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1104; /* lsx_vbitsel_d */

                case E_V4SImode:
                  if (pattern193 (x3, 
E_V4SImode) != 0
                      || !
#line 1018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1105; /* lsx_vbitsel_w */

                case E_V8HImode:
                  if (pattern193 (x3, 
E_V8HImode) != 0
                      || !
#line 1018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1106; /* lsx_vbitsel_h */

                case E_V16QImode:
                  if (pattern193 (x3, 
E_V16QImode) != 0
                      || !
#line 1018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1107; /* lsx_vbitsel_b */

                case E_V4DImode:
                  if (pattern193 (x3, 
E_V4DImode) != 0
                      || !
#line 1158 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1706; /* lasx_xvbitsel_d */

                case E_V8SImode:
                  if (pattern193 (x3, 
E_V8SImode) != 0
                      || !
#line 1158 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1707; /* lasx_xvbitsel_w */

                case E_V16HImode:
                  if (pattern193 (x3, 
E_V16HImode) != 0
                      || !
#line 1158 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1708; /* lasx_xvbitsel_h */

                case E_V32QImode:
                  if (pattern193 (x3, 
E_V32QImode) != 0
                      || !
#line 1158 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1709; /* lasx_xvbitsel_b */

                case E_V4DFmode:
                  if (pattern193 (x3, 
E_V4DFmode) != 0
                      || !
#line 1158 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1710; /* lasx_xvbitsel_d_f */

                case E_V8SFmode:
                  if (pattern193 (x3, 
E_V8SFmode) != 0
                      || !
#line 1158 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1711; /* lasx_xvbitsel_w_f */

                default:
                  return -1;
                }

            case CONST_VECTOR:
              operands[3] = x8;
              x9 = XEXP (x6, 0);
              operands[1] = x9;
              x7 = XEXP (x4, 1);
              operands[2] = x7;
              x10 = XEXP (x5, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern194 (x3, 
E_V16QImode) != 0
                      || !
#line 1030 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1108; /* lsx_vbitseli_b */

                case E_V32QImode:
                  if (pattern194 (x3, 
E_V32QImode) != 0
                      || !
#line 1170 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1712; /* lasx_xvbitseli_b */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern102 (x3) != 0)
            return -1;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return 116; /* iornsi3 */
          operands[2] = x5;
          operands[1] = x6;
          if (!
#line 1707 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 120; /* *iornsi_internal */

        case E_DImode:
          if (pattern103 (x3, 
E_DImode) != 0
              || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 118; /* iorndi3 */

        case E_V2DImode:
          if (pattern103 (x3, 
E_V2DImode) != 0
              || !
#line 2710 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1460; /* iornv2di3 */

        case E_V4SImode:
          if (pattern103 (x3, 
E_V4SImode) != 0
              || !
#line 2710 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1461; /* iornv4si3 */

        case E_V8HImode:
          if (pattern103 (x3, 
E_V8HImode) != 0
              || !
#line 2710 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1462; /* iornv8hi3 */

        case E_V16QImode:
          if (pattern103 (x3, 
E_V16QImode) != 0
              || !
#line 2710 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1463; /* iornv16qi3 */

        case E_V4DImode:
          if (pattern103 (x3, 
E_V4DImode) != 0
              || !
#line 3543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2157; /* iornv4di3 */

        case E_V8SImode:
          if (pattern103 (x3, 
E_V8SImode) != 0
              || !
#line 3543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2158; /* iornv8si3 */

        case E_V16HImode:
          if (pattern103 (x3, 
E_V16HImode) != 0
              || !
#line 3543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2159; /* iornv16hi3 */

        case E_V32QImode:
          if (pattern103 (x3, 
E_V32QImode) != 0
              || !
#line 3543 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2160; /* iornv32qi3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != SUBREG
          || maybe_ne (SUBREG_BYTE (x6), 0)
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!const_lu32i_operand (operands[2], E_DImode)
          || !
#line 2578 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 176; /* lu32i_d */

    case ASHIFT:
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          operands[2] = x7;
          if (const_int_operand (operands[2], E_SImode))
            {
              switch (pattern89 (x3))
                {
                case 0:
                  if ((
#line 3136 "../../gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !uns_arith_operand (operands[3], SImode))
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       SImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)))
                    return 261; /* ior_shift_reversesi */
                  break;

                case 1:
                  if ((
#line 3136 "../../gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !uns_arith_operand (operands[3], DImode))
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       DImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                    return 264; /* ior_shift_reversedi */
                  break;

                default:
                  break;
                }
            }
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != LSHIFTRT)
            return -1;
          x8 = XEXP (x5, 1);
          if (GET_CODE (x8) != CONST_INT
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (pattern108 (x3))
            {
            case 0:
              if (!
#line 4296 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 411; /* *bytepick_d_1_rev */

            case 1:
              if (!
#line 4296 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 412; /* *bytepick_d_2_rev */

            case 2:
              if (!
#line 4296 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 413; /* *bytepick_d_3_rev */

            case 3:
              if (!
#line 4296 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 414; /* *bytepick_d_4_rev */

            case 4:
              if (!
#line 4296 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 415; /* *bytepick_d_5_rev */

            case 5:
              if (!
#line 4296 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 416; /* *bytepick_d_6_rev */

            case 6:
              if (!
#line 4296 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 417; /* *bytepick_d_7_rev */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x9 = XEXP (x6, 0);
          if (GET_CODE (x9) != SUBREG
              || maybe_ne (SUBREG_BYTE (x9), 0))
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ZERO_EXTRACT
              || GET_MODE (x5) != E_DImode)
            return -1;
          x8 = XEXP (x5, 1);
          if (GET_CODE (x8) != CONST_INT)
            return -1;
          x11 = XEXP (x5, 2);
          if (GET_CODE (x11) != CONST_INT
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x12 = XEXP (x9, 0);
          operands[1] = x12;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x10 = XEXP (x5, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_DImode))
            return -1;
          switch (XWINT (x7, 0))
            {
            case 24L:
              if (XWINT (x8, 0) != 24L
                  || XWINT (x11, 0) != 8L
                  || GET_MODE (x9) != E_QImode
                  || !
#line 4259 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 387; /* bytepick_w_3_extend */

            case 16L:
              if (XWINT (x8, 0) != 16L
                  || XWINT (x11, 0) != 16L
                  || GET_MODE (x9) != E_HImode
                  || !
#line 4259 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 388; /* bytepick_w_2_extend */

            default:
              return -1;
            }

        case SIGN_EXTRACT:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x13 = XEXP (x6, 1);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
            return -1;
          x14 = XEXP (x6, 2);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || XWINT (x7, 0) != 8L)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ZERO_EXTRACT
              || GET_MODE (x5) != E_DImode)
            return -1;
          x8 = XEXP (x5, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x11 = XEXP (x5, 2);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 24]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x10 = XEXP (x5, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_DImode)
              || !
#line 4274 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 389; /* bytepick_w_1_extend */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern25 (x3))
        {
        case 0:
          return 378; /* *bytepick_w_1 */

        case 1:
          if (!
#line 4285 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 394; /* *bytepick_d_5 */

        case 2:
          return 379; /* *bytepick_w_2 */

        case 3:
          if (!
#line 4285 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 395; /* *bytepick_d_6 */

        case 4:
          return 380; /* *bytepick_w_3 */

        case 5:
          if (!
#line 4285 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 396; /* *bytepick_d_7 */

        case 6:
          if (!
#line 4285 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 390; /* *bytepick_d_1 */

        case 7:
          if (!
#line 4285 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 391; /* *bytepick_d_2 */

        case 8:
          if (!
#line 4285 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 392; /* *bytepick_d_3 */

        case 9:
          if (!
#line 4285 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 393; /* *bytepick_d_4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern34 (x3))
        {
        case 0:
          if (nonimmediate_operand (operands[1], E_SImode)
              && 
#line 1766 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return 122; /* *zero_extendsidi2_internal */
          if (!mem_simple_ldst_operand (operands[1], E_SImode)
              || !(
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 483; /* simple_load_uextsidi */

        case 1:
          if (nonimmediate_operand (operands[1], E_QImode)
              && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return 124; /* zero_extendqidi2 */
          if (!mem_simple_ldst_operand (operands[1], E_QImode)
              || !(
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 479; /* simple_load_uextqidi */

        case 2:
          if (nonimmediate_operand (operands[1], E_HImode)
              && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return 126; /* zero_extendhidi2 */
          if (!mem_simple_ldst_operand (operands[1], E_HImode)
              || !(
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 481; /* simple_load_uexthidi */

        case 3:
          if (nonimmediate_operand (operands[1], E_QImode))
            return 123; /* zero_extendqisi2 */
          if (!mem_simple_ldst_operand (operands[1], E_QImode)
              || !
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)))
            return -1;
          return 473; /* simple_load_uextqisi */

        case 4:
          if (nonimmediate_operand (operands[1], E_HImode))
            return 125; /* zero_extendhisi2 */
          if (!mem_simple_ldst_operand (operands[1], E_HImode)
              || !
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)))
            return -1;
          return 475; /* simple_load_uexthisi */

        case 5:
          if (!
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)))
            return -1;
          return 477; /* simple_load_uextsisi */

        case 6:
          return 127; /* zero_extendqihi2 */

        default:
          return -1;
        }

    case TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!
#line 1819 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 128; /* *zero_extendsi_truncqi */

            case E_HImode:
              if (!
#line 1819 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 130; /* *zero_extendsi_trunchi */

            default:
              return -1;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!
#line 1819 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 129; /* *zero_extenddi_truncqi */

            case E_HImode:
              if (!
#line 1819 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 131; /* *zero_extenddi_trunchi */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode
              || !
#line 1828 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 132; /* *zero_extendhi_truncqi */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      switch (GET_CODE (x5))
        {
        case ASHIFT:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!const_immalsl_operand (operands[2], E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[3] = x8;
          if (!register_operand (operands[3], E_SImode)
              || !
#line 3105 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 257; /* *alslsi3_extend */

        case SUBREG:
          if (maybe_ne (SUBREG_BYTE (x5), 0))
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != ASHIFT
              || GET_MODE (x6) != E_DImode
              || pattern195 (x4) != 0
              || !
#line 3119 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 259; /* *alslsi3_extend_subreg */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern42 (x3))
        {
        case 0:
          if (!
#line 468 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 953; /* lsx_vpickve2gr_hu */

        case 1:
          if (!
#line 468 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 955; /* lsx_vpickve2gr_bu */

        case 2:
          if (!
#line 479 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 957; /* lsx_vpickve2gr_wu */

        case 3:
          if (!
#line 3148 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2068; /* lasx_xvpickve2gr_wu */

        case 4:
          if (!
#line 479 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 959; /* lsx_vpickve2gr_w_fu */

        case 5:
          if (!
#line 554 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1565; /* lasx_xvpickve2gr_du */

        case 6:
          if (!
#line 3009 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1474; /* vec_unpacku_hi_v16qi */

        case 7:
          if (!
#line 2381 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1926; /* vec_unpacku_lo_v16qi_internal */

        case 8:
          if (!
#line 2395 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1928; /* vec_unpacku_lo_v16hi */

        case 9:
          if (!
#line 2444 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1936; /* lasx_vext2xv_wu_bu */

        case 10:
          if (!
#line 3199 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2074; /* lasx_xvexth_wu_hu */

        case 11:
          if (!
#line 3021 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1476; /* vec_unpacku_hi_v8hi */

        case 12:
          if (!
#line 2407 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1930; /* vec_unpacku_lo_v8hi_internal */

        case 13:
          if (!
#line 2419 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1932; /* vec_unpacku_lo_v8si */

        case 14:
          if (!
#line 2456 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1938; /* lasx_vext2xv_du_hu */

        case 15:
          if (!
#line 2468 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1940; /* lasx_vext2xv_du_bu */

        case 16:
          if (!
#line 3211 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2076; /* lasx_xvexth_du_wu */

        case 17:
          if (!
#line 3032 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1478; /* vec_unpacku_hi_v4si */

        case 18:
          if (!
#line 2430 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1934; /* vec_unpacku_lo_v4si_internal */

        case 19:
          if (!
#line 2367 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1924; /* vec_unpacku_lo_v32qi */

        case 20:
          if (!
#line 3185 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2072; /* lasx_xvexth_hu_bu */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern5 (x3))
    {
    case 0:
      return 242; /* *ashlsi3 */

    case 1:
      if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 245; /* *ashldi3 */

    case 2:
      if (const_uimm6_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 627; /* ashlv2di3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V2DImode)
          || !
#line 771 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1034; /* vashlv2di3 */

    case 3:
      if (const_uimm5_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 631; /* ashlv4si3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V4SImode)
          || !
#line 771 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1035; /* vashlv4si3 */

    case 4:
      if (const_uimm4_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 635; /* ashlv8hi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V8HImode)
          || !
#line 771 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1036; /* vashlv8hi3 */

    case 5:
      if (const_uimm3_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 639; /* ashlv16qi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V16QImode)
          || !
#line 771 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1037; /* vashlv16qi3 */

    case 6:
      if (const_uimm6_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 643; /* ashlv4di3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V4DImode)
          || !
#line 912 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1636; /* vashlv4di3 */

    case 7:
      if (const_uimm5_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 647; /* ashlv8si3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V8SImode)
          || !
#line 912 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1637; /* vashlv8si3 */

    case 8:
      if (const_uimm4_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 651; /* ashlv16hi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V16HImode)
          || !
#line 912 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1638; /* vashlv16hi3 */

    case 9:
      if (const_uimm3_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 655; /* ashlv32qi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V32QImode)
          || !
#line 912 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1639; /* vashlv32qi3 */

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (pattern121 (x3))
        {
        case 0:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 304; /* *sleu_sisi */

        case 1:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 306; /* *sleu_disi */

        case 2:
          if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 308; /* *sleu_didi */

        default:
          return -1;
        }

    case CONST_VECTOR:
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern16 (x3, 
E_V2DImode) != 0
              || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1119; /* lsx_vsle_du */

        case E_V4SImode:
          if (pattern16 (x3, 
E_V4SImode) != 0
              || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1124; /* lsx_vsle_wu */

        case E_V8HImode:
          if (pattern16 (x3, 
E_V8HImode) != 0
              || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1129; /* lsx_vsle_hu */

        case E_V16QImode:
          if (pattern16 (x3, 
E_V16QImode) != 0
              || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1134; /* lsx_vsle_bu */

        case E_V4DImode:
          if (pattern16 (x3, 
E_V4DImode) != 0
              || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1723; /* lasx_xvsle_du */

        case E_V8SImode:
          if (pattern16 (x3, 
E_V8SImode) != 0
              || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1728; /* lasx_xvsle_wu */

        case E_V16HImode:
          if (pattern16 (x3, 
E_V16HImode) != 0
              || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1733; /* lasx_xvsle_hu */

        case E_V32QImode:
          if (pattern16 (x3, 
E_V32QImode) != 0
              || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1738; /* lasx_xvsle_bu */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern1 (x1))
    {
    case 0:
      if (!
#line 421 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 32; /* *umoddi3 */

    case 1:
      if (!
#line 422 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT || ISA_HAS_DIV32))
        return -1;
      return 36; /* *umodsi3 */

    case 2:
      if (!
#line 652 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1000; /* umodv2di3 */

    case 3:
      if (!
#line 652 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1001; /* umodv4si3 */

    case 4:
      if (!
#line 652 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1002; /* umodv8hi3 */

    case 5:
      if (!
#line 652 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1003; /* umodv16qi3 */

    case 6:
      if (!
#line 787 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1602; /* umodv4di3 */

    case 7:
      if (!
#line 787 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1603; /* umodv8si3 */

    case 8:
      if (!
#line 787 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1604; /* umodv16hi3 */

    case 9:
      if (!
#line 787 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1605; /* umodv32qi3 */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2
      || GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != SET)
    return NULL;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode))
            {
              if (peep2_current_count >= 3
                  && pattern174 (x3, 
E_SImode) == 0
                  && 
#line 1654 "../../gcc/config/loongarch/loongarch.md"
(peep2_reg_dead_p (3, operands[0])))
                {
                  *pmatch_len_ = 2;
                  res = gen_peephole2_1 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (non_volatile_mem_operand (operands[1], E_SImode))
                {
                  x5 = XEXP (x3, 0);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_SImode))
                    {
                      x6 = XEXP (x3, 1);
                      operands[3] = x6;
                      if (non_volatile_mem_operand (operands[3], E_SImode)
                          && 
#line 4421 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SImode, true)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_4 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
          if (!memory_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode))
            return NULL;
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_SImode)
              || !
#line 4434 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SImode, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_8 (insn, operands);

        case E_DImode:
          if (peep2_current_count < 3
              || !register_operand (operands[0], E_DImode)
              || pattern174 (x3, 
E_DImode) != 0
              || !(
#line 1654 "../../gcc/config/loongarch/loongarch.md"
(peep2_reg_dead_p (3, operands[0])) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_2 (insn, operands);

        case E_HImode:
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (register_operand (operands[2], E_HImode)
              && register_operand (operands[0], E_HImode)
              && non_volatile_mem_operand (operands[1], E_HImode))
            {
              x6 = XEXP (x3, 1);
              operands[3] = x6;
              if (non_volatile_mem_operand (operands[3], E_HImode)
                  && 
#line 4421 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_3 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!memory_operand (operands[2], E_HImode)
              || !memory_operand (operands[0], E_HImode)
              || !register_operand (operands[1], E_HImode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_HImode)
              || !
#line 4434 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_7 (insn, operands);

        case E_SFmode:
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (register_operand (operands[2], E_SFmode)
              && register_operand (operands[0], E_SFmode)
              && non_volatile_mem_operand (operands[1], E_SFmode))
            {
              x6 = XEXP (x3, 1);
              operands[3] = x6;
              if (non_volatile_mem_operand (operands[3], E_SFmode)
                  && (
#line 4421 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SFmode, true)) && 
#line 381 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_5 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!memory_operand (operands[2], E_SFmode)
              || !memory_operand (operands[0], E_SFmode)
              || !register_operand (operands[1], E_SFmode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_SFmode)
              || !(
#line 4434 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SFmode, false)) && 
#line 381 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_9 (insn, operands);

        case E_DFmode:
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (register_operand (operands[2], E_DFmode)
              && register_operand (operands[0], E_DFmode)
              && non_volatile_mem_operand (operands[1], E_DFmode))
            {
              x6 = XEXP (x3, 1);
              operands[3] = x6;
              if (non_volatile_mem_operand (operands[3], E_DFmode)
                  && (
#line 4421 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, DFmode, true)) && 
#line 382 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_6 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!memory_operand (operands[2], E_DFmode)
              || !memory_operand (operands[0], E_DFmode)
              || !register_operand (operands[1], E_DFmode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_DFmode)
              || !(
#line 4434 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, DFmode, false)) && 
#line 382 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_10 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (pattern107 (x4, 
SIGN_EXTEND) != 0
          || !
#line 4466 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, true)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_11 (insn, operands);

    case ZERO_EXTEND:
      if (pattern107 (x4, 
ZERO_EXTEND) != 0
          || !
#line 4466 "../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, true)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_12 (insn, operands);

    case VEC_DUPLICATE:
      if (GET_MODE (x4) != E_V2DImode
          || !register_operand (operands[0], E_V2DImode))
        return NULL;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_MERGE
          || GET_MODE (x6) != E_V2DImode)
        return NULL;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != VEC_DUPLICATE
          || GET_MODE (x8) != E_V2DImode)
        return NULL;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2DImode))
        return NULL;
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!register_operand (operands[3], E_DImode))
        return NULL;
      x10 = XEXP (x6, 1);
      operands[4] = x10;
      if (!register_operand (operands[4], E_V2DImode))
        return NULL;
      x11 = XEXP (x6, 2);
      operands[5] = x11;
      if (!const_int_operand (operands[5], E_VOIDmode)
          || !
#line 3216 "../../gcc/config/loongarch/lsx.md"
(operands[0] == operands[2] &&
   operands[1] == operands[3] &&
   operands[2] == operands[4] &&
   INTVAL (operands[5]) == 2))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_13 (insn, operands);

    default:
      return NULL;
    }
}
