/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_vector_same_val_operand (operands[2], i1)
      || !const_uimm6_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_FCCmode:
      return pattern11 (x1); /* [-1, 1] */

    case E_V2DImode:
      if (pattern12 (x1, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern12 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 3;

    case E_V4DImode:
      if (pattern12 (x1, 
E_V4DFmode, 
E_V4DImode) != 0)
        return -1;
      return 4;

    case E_V8SImode:
      if (pattern12 (x1, 
E_V8SFmode, 
E_V8SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != AND)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  return pattern21 (x1); /* [-1, 1] */
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != ASHIFT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (XWINT (x3, 0))
    {
    case 24L:
      switch (XWINT (x5, 0))
        {
        case 8L:
          return pattern23 (x1, 
E_SImode); /* [-1, 0] */

        case 40L:
          if (pattern24 (x1) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 16L:
      switch (XWINT (x5, 0))
        {
        case 16L:
          if (pattern23 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case 48L:
          if (pattern24 (x1) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 8L:
      switch (XWINT (x5, 0))
        {
        case 24L:
          if (pattern23 (x1, 
E_SImode) != 0)
            return -1;
          return 4;

        case 56L:
          if (pattern24 (x1) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case 56L:
      if (XWINT (x5, 0) != 8L
          || pattern24 (x1) != 0)
        return -1;
      return 6;

    case 48L:
      if (XWINT (x5, 0) != 16L
          || pattern24 (x1) != 0)
        return -1;
      return 7;

    case 40L:
      if (XWINT (x5, 0) != 24L
          || pattern24 (x1) != 0)
        return -1;
      return 8;

    case 32L:
      if (XWINT (x5, 0) != 32L
          || pattern24 (x1) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern65 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_uimm4_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern68 (x3, 
E_V2DImode, 
E_V4SImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern69 (x3, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern70 (x3, 
E_V16QImode, 
E_V8HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      return pattern61 (x3, 
E_V4DImode, 
E_V8SImode); /* [-1, 0] */

    case E_V16HImode:
      if (pattern61 (x3, 
E_V8SImode, 
E_V16HImode) != 0)
        return -1;
      return 1;

    case E_V32QImode:
      if (pattern61 (x3, 
E_V16HImode, 
E_V32QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  return pattern89 (x1); /* [-1, 1] */
}

int
pattern93 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CONST_INT
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  return pattern40 (x3, 
i1); /* [-1, 1] */
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern100 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern100 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern106 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 38
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern113 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern118 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode)
          || !register_operand (operands[2], E_V4SFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode)
          || !reg_or_vector_same_simm5_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern127 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 64L:
      return pattern126 (x1, 
E_DImode, 
E_TImode); /* [-1, 0] */

    case 32L:
      if (pattern126 (x1, 
E_SImode, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern141 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 2;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 3;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x1) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 4;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern162 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_0_to_3_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern168 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern175 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern182 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern189 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern199 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern211 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern210 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern210 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != VEC_SELECT)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != SIGN_EXTEND)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != VEC_SELECT)
        return -1;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      x10 = XEXP (x6, 1);
      operands[4] = x10;
      switch (pattern188 (x2))
        {
        case 0:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 895; /* simd_maddw_evod_v2di_s */

        case 1:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 897; /* simd_maddw_evod_v4si_s */

        case 2:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 899; /* simd_maddw_evod_v8hi_s */

        case 3:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 901; /* simd_maddw_evod_v16qi_s */

        case 4:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 903; /* simd_maddw_evod_v4di_s */

        case 5:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 905; /* simd_maddw_evod_v8si_s */

        case 6:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 907; /* simd_maddw_evod_v16hi_s */

        case 7:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 909; /* simd_maddw_evod_v32qi_s */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != VEC_SELECT)
        return -1;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      x10 = XEXP (x6, 1);
      operands[4] = x10;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case ZERO_EXTEND:
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != VEC_SELECT)
            return -1;
          switch (pattern188 (x2))
            {
            case 0:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 896; /* simd_maddw_evod_v2di_u */

            case 1:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 898; /* simd_maddw_evod_v4si_u */

            case 2:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 900; /* simd_maddw_evod_v8hi_u */

            case 3:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 902; /* simd_maddw_evod_v16qi_u */

            case 4:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 904; /* simd_maddw_evod_v4di_u */

            case 5:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 906; /* simd_maddw_evod_v8si_u */

            case 6:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 908; /* simd_maddw_evod_v16hi_u */

            case 7:
              if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 910; /* simd_maddw_evod_v32qi_u */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != VEC_SELECT)
            return -1;
          x11 = XEXP (x8, 0);
          operands[3] = x11;
          x12 = XEXP (x8, 1);
          if (!rtx_equal_p (x12, operands[4]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1TImode:
              if (pattern206 (x2, 
E_V1TImode, 
E_V2DImode, 
E_V1DImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 911; /* simd_maddw_evod_v2di_hetero */

            case E_V2DImode:
              if (pattern206 (x2, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 912; /* simd_maddw_evod_v4si_hetero */

            case E_V4SImode:
              if (pattern206 (x2, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 913; /* simd_maddw_evod_v8hi_hetero */

            case E_V8HImode:
              if (pattern206 (x2, 
E_V8HImode, 
E_V16QImode, 
E_V8QImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 914; /* simd_maddw_evod_v16qi_hetero */

            case E_V2TImode:
              if (pattern206 (x2, 
E_V2TImode, 
E_V4DImode, 
E_V2DImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 915; /* simd_maddw_evod_v4di_hetero */

            case E_V4DImode:
              if (pattern206 (x2, 
E_V4DImode, 
E_V8SImode, 
E_V4SImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 916; /* simd_maddw_evod_v8si_hetero */

            case E_V8SImode:
              if (pattern206 (x2, 
E_V8SImode, 
E_V16HImode, 
E_V8HImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 917; /* simd_maddw_evod_v16hi_hetero */

            case E_V16HImode:
              if (pattern206 (x2, 
E_V16HImode, 
E_V32QImode, 
E_V16QImode) != 0
                  || !
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 918; /* simd_maddw_evod_v32qi_hetero */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[2] = x5;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern156 (x2, 
E_V2DImode) != 0
              || !
#line 606 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 980; /* lsx_vmadd_d */

        case E_V4SImode:
          if (pattern156 (x2, 
E_V4SImode) != 0
              || !
#line 606 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 981; /* lsx_vmadd_w */

        case E_V8HImode:
          if (pattern156 (x2, 
E_V8HImode) != 0
              || !
#line 606 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 982; /* lsx_vmadd_h */

        case E_V16QImode:
          if (pattern156 (x2, 
E_V16QImode) != 0
              || !
#line 606 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 983; /* lsx_vmadd_b */

        case E_V4DImode:
          if (pattern156 (x2, 
E_V4DImode) != 0
              || !
#line 730 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1582; /* lasx_xvmadd_d */

        case E_V8SImode:
          if (pattern156 (x2, 
E_V8SImode) != 0
              || !
#line 730 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1583; /* lasx_xvmadd_w */

        case E_V16HImode:
          if (pattern156 (x2, 
E_V16HImode) != 0
              || !
#line 730 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1584; /* lasx_xvmadd_h */

        case E_V32QImode:
          if (pattern156 (x2, 
E_V32QImode) != 0
              || !
#line 730 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1585; /* lasx_xvmadd_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode)
          || !
#line 2160 "../../gcc/config/loongarch/loongarch.md"
(loongarch_use_ins_ext_p (operands[0], INTVAL (operands[1]),
			    INTVAL (operands[2]))))
        return -1;
      return 150; /* *insvsi */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode)
          || !(
#line 2160 "../../gcc/config/loongarch/loongarch.md"
(loongarch_use_ins_ext_p (operands[0], INTVAL (operands[1]),
			    INTVAL (operands[2]))) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
        return -1;
      return 151; /* *insvdi */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_V32QImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_V32QImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V32QImode))
    return -1;
  x5 = XEXP (x3, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!const_uimm4_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x5, 0, 16);
  operands[3] = x7;
  if (!const_16_to_31_operand (operands[3], E_VOIDmode)
      || pattern208 (x5) != 0)
    return -1;
  x8 = XVECEXP (x5, 0, 8);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XVECEXP (x5, 0, 9);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XVECEXP (x5, 0, 10);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XVECEXP (x5, 0, 11);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XVECEXP (x5, 0, 12);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XVECEXP (x5, 0, 13);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XVECEXP (x5, 0, 14);
  if (!rtx_equal_p (x14, operands[2]))
    return -1;
  x15 = XVECEXP (x5, 0, 15);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XVECEXP (x5, 0, 17);
  if (!rtx_equal_p (x16, operands[3]))
    return -1;
  x17 = XVECEXP (x5, 0, 18);
  if (!rtx_equal_p (x17, operands[3]))
    return -1;
  x18 = XVECEXP (x5, 0, 19);
  if (!rtx_equal_p (x18, operands[3]))
    return -1;
  x19 = XVECEXP (x5, 0, 20);
  if (!rtx_equal_p (x19, operands[3]))
    return -1;
  x20 = XVECEXP (x5, 0, 21);
  if (!rtx_equal_p (x20, operands[3]))
    return -1;
  x21 = XVECEXP (x5, 0, 22);
  if (!rtx_equal_p (x21, operands[3]))
    return -1;
  x22 = XVECEXP (x5, 0, 23);
  if (!rtx_equal_p (x22, operands[3]))
    return -1;
  x23 = XVECEXP (x5, 0, 24);
  if (!rtx_equal_p (x23, operands[3]))
    return -1;
  x24 = XVECEXP (x5, 0, 25);
  if (!rtx_equal_p (x24, operands[3]))
    return -1;
  x25 = XVECEXP (x5, 0, 26);
  if (!rtx_equal_p (x25, operands[3]))
    return -1;
  x26 = XVECEXP (x5, 0, 27);
  if (!rtx_equal_p (x26, operands[3]))
    return -1;
  x27 = XVECEXP (x5, 0, 28);
  if (!rtx_equal_p (x27, operands[3]))
    return -1;
  x28 = XVECEXP (x5, 0, 29);
  if (!rtx_equal_p (x28, operands[3]))
    return -1;
  x29 = XVECEXP (x5, 0, 30);
  if (!rtx_equal_p (x29, operands[3]))
    return -1;
  x30 = XVECEXP (x5, 0, 31);
  if (!rtx_equal_p (x30, operands[3])
      || !
#line 2112 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX && ((INTVAL (operands[3]) - INTVAL (operands[2])) == 16)))
    return -1;
  return 1877; /* lasx_xvrepl128vei_b_internal */
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_83 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x4;
  if (!const_0_to_3_operand (operands[3], E_VOIDmode))
    return -1;
  operands[4] = x5;
  if (!const_0_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[5] = x6;
  if (!const_8_to_11_operand (operands[5], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[6] = x7;
  if (!const_8_to_11_operand (operands[6], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  operands[7] = x8;
  if (!const_4_to_7_operand (operands[7], E_VOIDmode))
    return -1;
  x9 = XVECEXP (x3, 0, 5);
  operands[8] = x9;
  if (!const_4_to_7_operand (operands[8], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 6);
  operands[9] = x10;
  if (!const_12_to_15_operand (operands[9], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x3, 0, 7);
  operands[10] = x11;
  if (!const_12_to_15_operand (operands[10], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      if (pattern205 (x2, 
E_V8SImode, 
E_V16SImode) != 0
          || !
#line 3404 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX
  && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
  && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
  && INTVAL (operands[5]) + 4 == INTVAL (operands[9])
  && INTVAL (operands[6]) + 4 == INTVAL (operands[10])))
        return -1;
      return 2130; /* lasx_xvpermi_w_1 */

    case E_V8SFmode:
      if (pattern205 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
          || !
#line 3404 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX
  && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
  && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
  && INTVAL (operands[5]) + 4 == INTVAL (operands[9])
  && INTVAL (operands[6]) + 4 == INTVAL (operands[10])))
        return -1;
      return 2131; /* lasx_xvpermi_w_f_1 */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 16);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 17);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 18);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 19);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x3, 0, 20);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x3, 0, 21);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x3, 0, 22);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x3, 0, 23);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x3, 0, 24);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x3, 0, 25);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x3, 0, 26);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x3, 0, 27);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x3, 0, 28);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x3, 0, 29);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  x18 = XVECEXP (x3, 0, 30);
  if (GET_CODE (x18) != CONST_INT)
    return -1;
  x19 = XVECEXP (x3, 0, 31);
  if (GET_CODE (x19) != CONST_INT
      || pattern205 (x2, 
E_V32QImode, 
E_V64QImode) != 0)
    return -1;
  x20 = XVECEXP (x3, 0, 0);
  switch (XWINT (x20, 0))
    {
    case 0L:
      if (XWINT (x4, 0) != 16L)
        return -1;
      x21 = XVECEXP (x3, 0, 1);
      switch (XWINT (x21, 0))
        {
        case 32L:
          if (XWINT (x5, 0) != 48L)
            return -1;
          x22 = XVECEXP (x3, 0, 2);
          switch (XWINT (x22, 0))
            {
            case 2L:
              x23 = XVECEXP (x3, 0, 3);
              if (XWINT (x23, 0) != 34L)
                return -1;
              x24 = XVECEXP (x3, 0, 4);
              if (XWINT (x24, 0) != 4L)
                return -1;
              x25 = XVECEXP (x3, 0, 5);
              if (XWINT (x25, 0) != 36L)
                return -1;
              x26 = XVECEXP (x3, 0, 6);
              if (XWINT (x26, 0) != 6L)
                return -1;
              x27 = XVECEXP (x3, 0, 7);
              if (XWINT (x27, 0) != 38L)
                return -1;
              x28 = XVECEXP (x3, 0, 8);
              if (XWINT (x28, 0) != 8L)
                return -1;
              x29 = XVECEXP (x3, 0, 9);
              if (XWINT (x29, 0) != 40L)
                return -1;
              x30 = XVECEXP (x3, 0, 10);
              if (XWINT (x30, 0) != 10L)
                return -1;
              x31 = XVECEXP (x3, 0, 11);
              if (XWINT (x31, 0) != 42L)
                return -1;
              x32 = XVECEXP (x3, 0, 12);
              if (XWINT (x32, 0) != 12L)
                return -1;
              x33 = XVECEXP (x3, 0, 13);
              if (XWINT (x33, 0) != 44L)
                return -1;
              x34 = XVECEXP (x3, 0, 14);
              if (XWINT (x34, 0) != 14L)
                return -1;
              x35 = XVECEXP (x3, 0, 15);
              if (XWINT (x35, 0) != 46L
                  || XWINT (x6, 0) != 18L
                  || XWINT (x7, 0) != 50L
                  || XWINT (x8, 0) != 20L
                  || XWINT (x9, 0) != 52L
                  || XWINT (x10, 0) != 22L
                  || XWINT (x11, 0) != 54L
                  || XWINT (x12, 0) != 24L
                  || XWINT (x13, 0) != 56L
                  || XWINT (x14, 0) != 26L
                  || XWINT (x15, 0) != 58L
                  || XWINT (x16, 0) != 28L
                  || XWINT (x17, 0) != 60L
                  || XWINT (x18, 0) != 30L
                  || XWINT (x19, 0) != 62L
                  || !
#line 1419 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1775; /* lasx_xvpackev_b */

            case 1L:
              x23 = XVECEXP (x3, 0, 3);
              if (XWINT (x23, 0) != 33L)
                return -1;
              x24 = XVECEXP (x3, 0, 4);
              if (XWINT (x24, 0) != 2L)
                return -1;
              x25 = XVECEXP (x3, 0, 5);
              if (XWINT (x25, 0) != 34L)
                return -1;
              x26 = XVECEXP (x3, 0, 6);
              if (XWINT (x26, 0) != 3L)
                return -1;
              x27 = XVECEXP (x3, 0, 7);
              if (XWINT (x27, 0) != 35L)
                return -1;
              x28 = XVECEXP (x3, 0, 8);
              if (XWINT (x28, 0) != 4L)
                return -1;
              x29 = XVECEXP (x3, 0, 9);
              if (XWINT (x29, 0) != 36L)
                return -1;
              x30 = XVECEXP (x3, 0, 10);
              if (XWINT (x30, 0) != 5L)
                return -1;
              x31 = XVECEXP (x3, 0, 11);
              if (XWINT (x31, 0) != 37L)
                return -1;
              x32 = XVECEXP (x3, 0, 12);
              if (XWINT (x32, 0) != 6L)
                return -1;
              x33 = XVECEXP (x3, 0, 13);
              if (XWINT (x33, 0) != 38L)
                return -1;
              x34 = XVECEXP (x3, 0, 14);
              if (XWINT (x34, 0) != 7L)
                return -1;
              x35 = XVECEXP (x3, 0, 15);
              if (XWINT (x35, 0) != 39L
                  || XWINT (x6, 0) != 17L
                  || XWINT (x7, 0) != 49L
                  || XWINT (x8, 0) != 18L
                  || XWINT (x9, 0) != 50L
                  || XWINT (x10, 0) != 19L
                  || XWINT (x11, 0) != 51L
                  || XWINT (x12, 0) != 20L
                  || XWINT (x13, 0) != 52L
                  || XWINT (x14, 0) != 21L
                  || XWINT (x15, 0) != 53L
                  || XWINT (x16, 0) != 22L
                  || XWINT (x17, 0) != 54L
                  || XWINT (x18, 0) != 23L
                  || XWINT (x19, 0) != 55L
                  || !
#line 1653 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1789; /* lasx_xvilvl_b */

            default:
              return -1;
            }

        case 2L:
          x22 = XVECEXP (x3, 0, 2);
          if (XWINT (x22, 0) != 4L)
            return -1;
          x23 = XVECEXP (x3, 0, 3);
          if (XWINT (x23, 0) != 6L)
            return -1;
          x24 = XVECEXP (x3, 0, 4);
          if (XWINT (x24, 0) != 8L)
            return -1;
          x25 = XVECEXP (x3, 0, 5);
          if (XWINT (x25, 0) != 10L)
            return -1;
          x26 = XVECEXP (x3, 0, 6);
          if (XWINT (x26, 0) != 12L)
            return -1;
          x27 = XVECEXP (x3, 0, 7);
          if (XWINT (x27, 0) != 14L)
            return -1;
          x28 = XVECEXP (x3, 0, 8);
          if (XWINT (x28, 0) != 32L)
            return -1;
          x29 = XVECEXP (x3, 0, 9);
          if (XWINT (x29, 0) != 34L)
            return -1;
          x30 = XVECEXP (x3, 0, 10);
          if (XWINT (x30, 0) != 36L)
            return -1;
          x31 = XVECEXP (x3, 0, 11);
          if (XWINT (x31, 0) != 38L)
            return -1;
          x32 = XVECEXP (x3, 0, 12);
          if (XWINT (x32, 0) != 40L)
            return -1;
          x33 = XVECEXP (x3, 0, 13);
          if (XWINT (x33, 0) != 42L)
            return -1;
          x34 = XVECEXP (x3, 0, 14);
          if (XWINT (x34, 0) != 44L)
            return -1;
          x35 = XVECEXP (x3, 0, 15);
          if (XWINT (x35, 0) != 46L
              || XWINT (x5, 0) != 18L
              || XWINT (x6, 0) != 20L
              || XWINT (x7, 0) != 22L
              || XWINT (x8, 0) != 24L
              || XWINT (x9, 0) != 26L
              || XWINT (x10, 0) != 28L
              || XWINT (x11, 0) != 30L
              || XWINT (x12, 0) != 48L
              || XWINT (x13, 0) != 50L
              || XWINT (x14, 0) != 52L
              || XWINT (x15, 0) != 54L
              || XWINT (x16, 0) != 56L
              || XWINT (x17, 0) != 58L
              || XWINT (x18, 0) != 60L
              || XWINT (x19, 0) != 62L
              || !
#line 1826 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1823; /* lasx_xvpickev_b */

        default:
          return -1;
        }

    case 8L:
      x21 = XVECEXP (x3, 0, 1);
      if (XWINT (x21, 0) != 40L)
        return -1;
      x22 = XVECEXP (x3, 0, 2);
      if (XWINT (x22, 0) != 9L)
        return -1;
      x23 = XVECEXP (x3, 0, 3);
      if (XWINT (x23, 0) != 41L)
        return -1;
      x24 = XVECEXP (x3, 0, 4);
      if (XWINT (x24, 0) != 10L)
        return -1;
      x25 = XVECEXP (x3, 0, 5);
      if (XWINT (x25, 0) != 42L)
        return -1;
      x26 = XVECEXP (x3, 0, 6);
      if (XWINT (x26, 0) != 11L)
        return -1;
      x27 = XVECEXP (x3, 0, 7);
      if (XWINT (x27, 0) != 43L)
        return -1;
      x28 = XVECEXP (x3, 0, 8);
      if (XWINT (x28, 0) != 12L)
        return -1;
      x29 = XVECEXP (x3, 0, 9);
      if (XWINT (x29, 0) != 44L)
        return -1;
      x30 = XVECEXP (x3, 0, 10);
      if (XWINT (x30, 0) != 13L)
        return -1;
      x31 = XVECEXP (x3, 0, 11);
      if (XWINT (x31, 0) != 45L)
        return -1;
      x32 = XVECEXP (x3, 0, 12);
      if (XWINT (x32, 0) != 14L)
        return -1;
      x33 = XVECEXP (x3, 0, 13);
      if (XWINT (x33, 0) != 46L)
        return -1;
      x34 = XVECEXP (x3, 0, 14);
      if (XWINT (x34, 0) != 15L)
        return -1;
      x35 = XVECEXP (x3, 0, 15);
      if (XWINT (x35, 0) != 47L
          || XWINT (x4, 0) != 24L
          || XWINT (x5, 0) != 56L
          || XWINT (x6, 0) != 25L
          || XWINT (x7, 0) != 57L
          || XWINT (x8, 0) != 26L
          || XWINT (x9, 0) != 58L
          || XWINT (x10, 0) != 27L
          || XWINT (x11, 0) != 59L
          || XWINT (x12, 0) != 28L
          || XWINT (x13, 0) != 60L
          || XWINT (x14, 0) != 29L
          || XWINT (x15, 0) != 61L
          || XWINT (x16, 0) != 30L
          || XWINT (x17, 0) != 62L
          || XWINT (x18, 0) != 31L
          || XWINT (x19, 0) != 63L
          || !
#line 1496 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1779; /* lasx_xvilvh_b */

    case 1L:
      x35 = XVECEXP (x3, 0, 15);
      if (XWINT (x35, 0) != 47L
          || XWINT (x4, 0) != 17L
          || XWINT (x19, 0) != 63L)
        return -1;
      x21 = XVECEXP (x3, 0, 1);
      switch (XWINT (x21, 0))
        {
        case 33L:
          x22 = XVECEXP (x3, 0, 2);
          if (XWINT (x22, 0) != 3L)
            return -1;
          x23 = XVECEXP (x3, 0, 3);
          if (XWINT (x23, 0) != 35L)
            return -1;
          x24 = XVECEXP (x3, 0, 4);
          if (XWINT (x24, 0) != 5L)
            return -1;
          x25 = XVECEXP (x3, 0, 5);
          if (XWINT (x25, 0) != 37L)
            return -1;
          x26 = XVECEXP (x3, 0, 6);
          if (XWINT (x26, 0) != 7L)
            return -1;
          x27 = XVECEXP (x3, 0, 7);
          if (XWINT (x27, 0) != 39L)
            return -1;
          x28 = XVECEXP (x3, 0, 8);
          if (XWINT (x28, 0) != 9L)
            return -1;
          x29 = XVECEXP (x3, 0, 9);
          if (XWINT (x29, 0) != 41L)
            return -1;
          x30 = XVECEXP (x3, 0, 10);
          if (XWINT (x30, 0) != 11L)
            return -1;
          x31 = XVECEXP (x3, 0, 11);
          if (XWINT (x31, 0) != 43L)
            return -1;
          x32 = XVECEXP (x3, 0, 12);
          if (XWINT (x32, 0) != 13L)
            return -1;
          x33 = XVECEXP (x3, 0, 13);
          if (XWINT (x33, 0) != 45L)
            return -1;
          x34 = XVECEXP (x3, 0, 14);
          if (XWINT (x34, 0) != 15L
              || XWINT (x5, 0) != 49L
              || XWINT (x6, 0) != 19L
              || XWINT (x7, 0) != 51L
              || XWINT (x8, 0) != 21L
              || XWINT (x9, 0) != 53L
              || XWINT (x10, 0) != 23L
              || XWINT (x11, 0) != 55L
              || XWINT (x12, 0) != 25L
              || XWINT (x13, 0) != 57L
              || XWINT (x14, 0) != 27L
              || XWINT (x15, 0) != 59L
              || XWINT (x16, 0) != 29L
              || XWINT (x17, 0) != 61L
              || XWINT (x18, 0) != 31L
              || !
#line 1574 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1785; /* lasx_xvpackod_b */

        case 3L:
          x22 = XVECEXP (x3, 0, 2);
          if (XWINT (x22, 0) != 5L)
            return -1;
          x23 = XVECEXP (x3, 0, 3);
          if (XWINT (x23, 0) != 7L)
            return -1;
          x24 = XVECEXP (x3, 0, 4);
          if (XWINT (x24, 0) != 9L)
            return -1;
          x25 = XVECEXP (x3, 0, 5);
          if (XWINT (x25, 0) != 11L)
            return -1;
          x26 = XVECEXP (x3, 0, 6);
          if (XWINT (x26, 0) != 13L)
            return -1;
          x27 = XVECEXP (x3, 0, 7);
          if (XWINT (x27, 0) != 15L)
            return -1;
          x28 = XVECEXP (x3, 0, 8);
          if (XWINT (x28, 0) != 33L)
            return -1;
          x29 = XVECEXP (x3, 0, 9);
          if (XWINT (x29, 0) != 35L)
            return -1;
          x30 = XVECEXP (x3, 0, 10);
          if (XWINT (x30, 0) != 37L)
            return -1;
          x31 = XVECEXP (x3, 0, 11);
          if (XWINT (x31, 0) != 39L)
            return -1;
          x32 = XVECEXP (x3, 0, 12);
          if (XWINT (x32, 0) != 41L)
            return -1;
          x33 = XVECEXP (x3, 0, 13);
          if (XWINT (x33, 0) != 43L)
            return -1;
          x34 = XVECEXP (x3, 0, 14);
          if (XWINT (x34, 0) != 45L
              || XWINT (x5, 0) != 19L
              || XWINT (x6, 0) != 21L
              || XWINT (x7, 0) != 23L
              || XWINT (x8, 0) != 25L
              || XWINT (x9, 0) != 27L
              || XWINT (x10, 0) != 29L
              || XWINT (x11, 0) != 31L
              || XWINT (x12, 0) != 49L
              || XWINT (x13, 0) != 51L
              || XWINT (x14, 0) != 53L
              || XWINT (x15, 0) != 55L
              || XWINT (x16, 0) != 57L
              || XWINT (x17, 0) != 59L
              || XWINT (x18, 0) != 61L
              || !
#line 1902 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1827; /* lasx_xvpickod_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_95 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern132 (x3, 
E_SImode) != 0)
            return -1;
          return 100; /* *andsi3 */

        case E_DImode:
          if (pattern132 (x3, 
E_DImode) != 0
              || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 101; /* *anddi3 */

        case E_V2DImode:
          if (pattern131 (x3, 
E_V2DImode) != 0
              || !
#line 688 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1016; /* andv2di3 */

        case E_V4SImode:
          if (pattern131 (x3, 
E_V4SImode) != 0
              || !
#line 688 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1017; /* andv4si3 */

        case E_V8HImode:
          if (pattern131 (x3, 
E_V8HImode) != 0
              || !
#line 688 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1018; /* andv8hi3 */

        case E_V16QImode:
          if (pattern131 (x3, 
E_V16QImode) != 0
              || !
#line 688 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1019; /* andv16qi3 */

        case E_V2DFmode:
          if (pattern131 (x3, 
E_V2DFmode) != 0
              || !
#line 688 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1020; /* andv2df3 */

        case E_V4SFmode:
          if (pattern131 (x3, 
E_V4SFmode) != 0
              || !
#line 688 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1021; /* andv4sf3 */

        case E_V4DImode:
          if (pattern131 (x3, 
E_V4DImode) != 0
              || !
#line 826 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1618; /* andv4di3 */

        case E_V8SImode:
          if (pattern131 (x3, 
E_V8SImode) != 0
              || !
#line 826 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1619; /* andv8si3 */

        case E_V16HImode:
          if (pattern131 (x3, 
E_V16HImode) != 0
              || !
#line 826 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1620; /* andv16hi3 */

        case E_V32QImode:
          if (pattern131 (x3, 
E_V32QImode) != 0
              || !
#line 826 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1621; /* andv32qi3 */

        case E_V4DFmode:
          if (pattern131 (x3, 
E_V4DFmode) != 0
              || !
#line 826 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1622; /* andv4df3 */

        case E_V8SFmode:
          if (pattern131 (x3, 
E_V8SFmode) != 0
              || !
#line 826 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1623; /* andv8sf3 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case NOT:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern23 (x3, 
E_SImode) != 0)
                return -1;
              if (
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return 112; /* norsi3 */
              if (!
#line 1687 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 114; /* *norsi3_internal */

            case E_DImode:
              if (pattern23 (x3, 
E_DImode) != 0
                  || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 113; /* nordi3 */

            case E_V2DImode:
              if (pattern149 (x3, 
E_V2DImode) != 0
                  || !
#line 1617 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1215; /* lsx_nor_d */

            case E_V4SImode:
              if (pattern149 (x3, 
E_V4SImode) != 0
                  || !
#line 1617 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1216; /* lsx_nor_w */

            case E_V8HImode:
              if (pattern149 (x3, 
E_V8HImode) != 0
                  || !
#line 1617 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1217; /* lsx_nor_h */

            case E_V16QImode:
              if (pattern149 (x3, 
E_V16QImode) != 0
                  || !
#line 1617 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1218; /* lsx_nor_b */

            case E_V4DImode:
              if (pattern149 (x3, 
E_V4DImode) != 0
                  || !
#line 1797 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1819; /* lasx_xvnor_d */

            case E_V8SImode:
              if (pattern149 (x3, 
E_V8SImode) != 0
                  || !
#line 1797 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1820; /* lasx_xvnor_w */

            case E_V16HImode:
              if (pattern149 (x3, 
E_V16HImode) != 0
                  || !
#line 1797 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1821; /* lasx_xvnor_h */

            case E_V32QImode:
              if (pattern149 (x3, 
E_V32QImode) != 0
                  || !
#line 1797 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1822; /* lasx_xvnor_b */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern102 (x3) != 0)
                return -1;
              operands[1] = x5;
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              if (
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return 115; /* andnsi3 */
              operands[2] = x5;
              operands[1] = x6;
              if (!
#line 1707 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 119; /* *andnsi_internal */

            case E_DImode:
              if (pattern103 (x3, 
E_DImode) != 0
                  || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 117; /* andndi3 */

            case E_V2DImode:
              if (pattern103 (x3, 
E_V2DImode) != 0
                  || !
#line 2018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1314; /* andnv2di3 */

            case E_V4SImode:
              if (pattern103 (x3, 
E_V4SImode) != 0
                  || !
#line 2018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1315; /* andnv4si3 */

            case E_V8HImode:
              if (pattern103 (x3, 
E_V8HImode) != 0
                  || !
#line 2018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1316; /* andnv8hi3 */

            case E_V16QImode:
              if (pattern103 (x3, 
E_V16QImode) != 0
                  || !
#line 2018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1317; /* andnv16qi3 */

            case E_V2DFmode:
              if (pattern103 (x3, 
E_V2DFmode) != 0
                  || !
#line 2018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1318; /* andnv2df3 */

            case E_V4SFmode:
              if (pattern103 (x3, 
E_V4SFmode) != 0
                  || !
#line 2018 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1319; /* andnv4sf3 */

            case E_V4DImode:
              if (pattern103 (x3, 
E_V4DImode) != 0
                  || !
#line 2478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1941; /* andnv4di3 */

            case E_V8SImode:
              if (pattern103 (x3, 
E_V8SImode) != 0
                  || !
#line 2478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1942; /* andnv8si3 */

            case E_V16HImode:
              if (pattern103 (x3, 
E_V16HImode) != 0
                  || !
#line 2478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1943; /* andnv16hi3 */

            case E_V32QImode:
              if (pattern103 (x3, 
E_V32QImode) != 0
                  || !
#line 2478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1944; /* andnv32qi3 */

            case E_V4DFmode:
              if (pattern103 (x3, 
E_V4DFmode) != 0
                  || !
#line 2478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1945; /* andnv4df3 */

            case E_V8SFmode:
              if (pattern103 (x3, 
E_V8SFmode) != 0
                  || !
#line 2478 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1946; /* andnv8sf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern90 (x3))
        {
        case 0:
          if (!(
#line 3136 "../../gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !and_operand (operands[3], SImode))
   && loongarch_reassoc_shift_bitwise (true, operands[2], operands[3],
				       SImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)))
            return -1;
          return 260; /* and_shift_reversesi */

        case 1:
          if (!(
#line 3136 "../../gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !and_operand (operands[3], DImode))
   && loongarch_reassoc_shift_bitwise (true, operands[2], operands[3],
				       DImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 263; /* and_shift_reversedi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern83 (x3))
        {
        case 0:
          if (
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return 102; /* one_cmplsi2 */
          if (!
#line 1588 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 104; /* *one_cmplsi2_internal */

        case 1:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 103; /* one_cmpldi2 */

        case 2:
          if (!
#line 713 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1022; /* one_cmplv2di2 */

        case 3:
          if (!
#line 713 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1023; /* one_cmplv4si2 */

        case 4:
          if (!
#line 713 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1024; /* one_cmplv8hi2 */

        case 5:
          if (!
#line 713 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1025; /* one_cmplv16qi2 */

        case 6:
          if (!
#line 851 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1624; /* one_cmplv4di2 */

        case 7:
          if (!
#line 851 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1625; /* one_cmplv8si2 */

        case 8:
          if (!
#line 851 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1626; /* one_cmplv16hi2 */

        case 9:
          if (!
#line 851 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1627; /* one_cmplv32qi2 */

        default:
          return -1;
        }

    case GE:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 715; /* lsx_vfcmp_sult_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 719; /* lsx_vfcmp_sult_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 723; /* lasx_xvfcmp_sult_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 727; /* lasx_xvfcmp_sult_s */

        default:
          return -1;
        }

    case GT:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 716; /* lsx_vfcmp_sule_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 720; /* lsx_vfcmp_sule_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 724; /* lasx_xvfcmp_sule_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 728; /* lasx_xvfcmp_sule_s */

        default:
          return -1;
        }

    case UNGE:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 717; /* lsx_vfcmp_clt_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 721; /* lsx_vfcmp_clt_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 725; /* lasx_xvfcmp_clt_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 729; /* lasx_xvfcmp_clt_s */

        default:
          return -1;
        }

    case UNGT:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 718; /* lsx_vfcmp_cle_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 722; /* lsx_vfcmp_cle_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 726; /* lasx_xvfcmp_cle_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 730; /* lasx_xvfcmp_cle_s */

        default:
          return -1;
        }

    case LE:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 731; /* lsx_vfcmp_sugt_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 735; /* lsx_vfcmp_sugt_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 739; /* lasx_xvfcmp_sugt_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 743; /* lasx_xvfcmp_sugt_s */

        default:
          return -1;
        }

    case LT:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 732; /* lsx_vfcmp_suge_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 736; /* lsx_vfcmp_suge_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 740; /* lasx_xvfcmp_suge_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 744; /* lasx_xvfcmp_suge_s */

        default:
          return -1;
        }

    case UNLE:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 733; /* lsx_vfcmp_cgt_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 737; /* lsx_vfcmp_cgt_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 741; /* lasx_xvfcmp_cgt_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 745; /* lasx_xvfcmp_cgt_s */

        default:
          return -1;
        }

    case UNLT:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 734; /* lsx_vfcmp_cge_d */

        case 1:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 738; /* lsx_vfcmp_cge_s */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 742; /* lasx_xvfcmp_cge_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 746; /* lasx_xvfcmp_cge_s */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (pattern121 (x3))
        {
        case 0:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 303; /* *sle_sisi */

        case 1:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 305; /* *sle_disi */

        case 2:
          if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 307; /* *sle_didi */

        default:
          return -1;
        }

    case CONST_VECTOR:
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_FCCmode:
          switch (pattern11 (x3))
            {
            case 0:
              if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 315; /* sle_sf_using_FCCmode */

            case 1:
              if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 329; /* sle_df_using_FCCmode */

            default:
              return -1;
            }

        case E_V2DImode:
          switch (pattern117 (x3))
            {
            case 0:
              if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 665; /* lsx_vfcmp_sle_d */

            case 1:
              if (!
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1118; /* lsx_vsle_d */

            default:
              return -1;
            }

        case E_V4SImode:
          switch (pattern118 (x3))
            {
            case 0:
              if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 675; /* lsx_vfcmp_sle_s */

            case 1:
              if (!
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1123; /* lsx_vsle_w */

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern119 (x3))
            {
            case 0:
              if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 685; /* lasx_xvfcmp_sle_d */

            case 1:
              if (!
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1722; /* lasx_xvsle_d */

            default:
              return -1;
            }

        case E_V8SImode:
          switch (pattern120 (x3))
            {
            case 0:
              if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 695; /* lasx_xvfcmp_sle_s */

            case 1:
              if (!
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1727; /* lasx_xvsle_w */

            default:
              return -1;
            }

        case E_V8HImode:
          if (pattern2 (x3, 
E_V8HImode) != 0
              || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1128; /* lsx_vsle_h */

        case E_V16QImode:
          if (pattern2 (x3, 
E_V16QImode) != 0
              || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1133; /* lsx_vsle_b */

        case E_V16HImode:
          if (pattern2 (x3, 
E_V16HImode) != 0
              || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1732; /* lasx_xvsle_h */

        case E_V32QImode:
          if (pattern2 (x3, 
E_V32QImode) != 0
              || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1737; /* lasx_xvsle_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern114 (x3))
        {
        case 0:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 291; /* *sgt_sisi */

        case 1:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 293; /* *sgt_disi */

        default:
          return -1;
        }

    case E_DImode:
      if (pattern115 (x3) != 0
          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 295; /* *sgt_didi */

    case E_FCCmode:
      switch (pattern11 (x3))
        {
        case 0:
          if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 320; /* sgt_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 334; /* sgt_df_using_FCCmode */

        default:
          return -1;
        }

    case E_V2DImode:
      if (pattern12 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 700; /* lsx_vfcmp_sgt_d */

    case E_V4SImode:
      if (pattern12 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
          || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 704; /* lsx_vfcmp_sgt_s */

    case E_V4DImode:
      if (pattern12 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
          || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 708; /* lasx_xvfcmp_sgt_d */

    case E_V8SImode:
      if (pattern12 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
          || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 712; /* lasx_xvfcmp_sgt_s */

    default:
      return -1;
    }
}

 int
recog_134 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      return recog_91 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_93 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_92 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_96 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != LSHIFTRT)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MULT)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          switch (pattern127 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 921 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 17; /* smuldi3_highpart */

            case 1:
              return 21; /* smulsi3_highpart */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern127 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 921 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 18; /* umuldi3_highpart */

            case 1:
              return 22; /* umulsi3_highpart */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      return recog_105 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_88 (x1, insn, pnum_clobbers);

    case UDIV:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 421 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 30; /* *udivdi3 */

        case 1:
          if (!
#line 422 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT || ISA_HAS_DIV32))
            return -1;
          return 34; /* *udivsi3 */

        case 2:
          if (!
#line 634 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 992; /* udivv2di3 */

        case 3:
          if (!
#line 634 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 993; /* udivv4si3 */

        case 4:
          if (!
#line 634 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 994; /* udivv8hi3 */

        case 5:
          if (!
#line 634 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 995; /* udivv16qi3 */

        case 6:
          if (!
#line 763 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1594; /* udivv4di3 */

        case 7:
          if (!
#line 763 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1595; /* udivv8si3 */

        case 8:
          if (!
#line 763 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1596; /* udivv16hi3 */

        case 9:
          if (!
#line 763 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1597; /* udivv32qi3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 421 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 31; /* *moddi3 */

        case 1:
          if (!
#line 422 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT || ISA_HAS_DIV32))
            return -1;
          return 35; /* *modsi3 */

        case 2:
          if (!
#line 643 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 996; /* modv2di3 */

        case 3:
          if (!
#line 643 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 997; /* modv4si3 */

        case 4:
          if (!
#line 643 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 998; /* modv8hi3 */

        case 5:
          if (!
#line 643 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 999; /* modv16qi3 */

        case 6:
          if (!
#line 775 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1598; /* modv4di3 */

        case 7:
          if (!
#line 775 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1599; /* modv8si3 */

        case 8:
          if (!
#line 775 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1600; /* modv16hi3 */

        case 9:
          if (!
#line 775 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1601; /* modv32qi3 */

        default:
          return -1;
        }

    case UMOD:
      return recog_131 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_104 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_94 (x1, insn, pnum_clobbers);

    case SQRT:
      return recog_119 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_100 (x1, insn, pnum_clobbers);

    case COPYSIGN:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x2, 
E_SFmode) != 0
              || !
#line 1336 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 69; /* copysignsf3 */

        case E_DFmode:
          if (pattern0 (x2, 
E_DFmode) != 0
              || !(
#line 1336 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 70; /* copysigndf3 */

        default:
          return -1;
        }

    case CLZ:
      return recog_117 (x1, insn, pnum_clobbers);

    case CTZ:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern84 (x2))
        {
        case 0:
          return 77; /* ctzsi2 */

        case 1:
          if (!
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 78; /* ctzdi2 */

        default:
          return -1;
        }

    case SMAX:
      return recog_127 (x1, insn, pnum_clobbers);

    case SMIN:
      return recog_126 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_120 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_90 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_101 (x1, insn, pnum_clobbers);

    case AND:
      return recog_95 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_102 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 1722 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 121; /* truncdfsf2 */

    case ZERO_EXTEND:
      return recog_98 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_114 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_97 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_118 (x1, insn, pnum_clobbers);

    case ZERO_EXTRACT:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      switch (pattern84 (x2))
        {
        case 0:
          if (!(
#line 2134 "../../gcc/config/loongarch/loongarch.md"
(loongarch_use_ins_ext_p (operands[1], INTVAL (operands[2]),
			    INTVAL (operands[3]))) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)))
            return -1;
          return 148; /* *extzvsi */

        case 1:
          if (!(
#line 2134 "../../gcc/config/loongarch/loongarch.md"
(loongarch_use_ins_ext_p (operands[1], INTVAL (operands[2]),
			    INTVAL (operands[3]))) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 149; /* *extzvdi */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x6 = XEXP (x1, 0);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTRACT:
          res = recog_75 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
        case MEM:
          res = recog_76 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case PC:
          operands[0] = x2;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
                return 339; /* indirect_jumpsi */
              break;

            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && 
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
                return 340; /* indirect_jumpdi */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x2) != LABEL_REF
          || GET_CODE (x6) != PC)
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (
#line 3512 "../../gcc/config/loongarch/loongarch.md"
(!flag_pic))
        return 337; /* *jump_absolute */
      if (!
#line 3521 "../../gcc/config/loongarch/loongarch.md"
(flag_pic))
        return -1;
      return 338; /* *jump_pic */

    case LO_SUM:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern113 (x2, 
E_SImode) != 0
              || !
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return -1;
          return 178; /* *lowsi */

        case E_DImode:
          if (pattern113 (x2, 
E_DImode) != 0
              || !
#line 386 "../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return -1;
          return 179; /* *lowdi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_99 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_112 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      return recog_107 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_108 (x1, insn, pnum_clobbers);

    case ROTATERT:
      return recog_109 (x1, insn, pnum_clobbers);

    case BSWAP:
      return recog_129 (x1, insn, pnum_clobbers);

    case EQ:
      return recog_110 (x1, insn, pnum_clobbers);

    case NE:
      return recog_128 (x1, insn, pnum_clobbers);

    case GT:
      return recog_125 (x1, insn, pnum_clobbers);

    case GTU:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern114 (x2))
            {
            case 0:
              if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 292; /* *sgtu_sisi */

            case 1:
              if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 294; /* *sgtu_disi */

            default:
              return -1;
            }

        case E_DImode:
          if (pattern115 (x2) != 0
              || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 296; /* *sgtu_didi */

        default:
          return -1;
        }

    case LT:
      return recog_116 (x1, insn, pnum_clobbers);

    case LTU:
      return recog_122 (x1, insn, pnum_clobbers);

    case LE:
      return recog_115 (x1, insn, pnum_clobbers);

    case LEU:
      return recog_121 (x1, insn, pnum_clobbers);

    case UNORDERED:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 309; /* sunordered_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 323; /* sunordered_df_using_FCCmode */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 659; /* lsx_vfcmp_cun_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 669; /* lsx_vfcmp_cun_s */

        case 4:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 679; /* lasx_xvfcmp_cun_d */

        case 5:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 689; /* lasx_xvfcmp_cun_s */

        default:
          return -1;
        }

    case UNEQ:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 310; /* suneq_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 324; /* suneq_df_using_FCCmode */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 660; /* lsx_vfcmp_cueq_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 670; /* lsx_vfcmp_cueq_s */

        case 4:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 680; /* lasx_xvfcmp_cueq_d */

        case 5:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 690; /* lasx_xvfcmp_cueq_s */

        default:
          return -1;
        }

    case UNLT:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 311; /* sunlt_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 325; /* sunlt_df_using_FCCmode */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 661; /* lsx_vfcmp_cult_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 671; /* lsx_vfcmp_cult_s */

        case 4:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 681; /* lasx_xvfcmp_cult_d */

        case 5:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 691; /* lasx_xvfcmp_cult_s */

        default:
          return -1;
        }

    case UNLE:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 312; /* sunle_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 326; /* sunle_df_using_FCCmode */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 662; /* lsx_vfcmp_cule_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 672; /* lsx_vfcmp_cule_s */

        case 4:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 682; /* lasx_xvfcmp_cule_d */

        case 5:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 692; /* lasx_xvfcmp_cule_s */

        default:
          return -1;
        }

    case ORDERED:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 316; /* sordered_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 330; /* sordered_df_using_FCCmode */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 666; /* lsx_vfcmp_cor_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 676; /* lsx_vfcmp_cor_s */

        case 4:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 686; /* lasx_xvfcmp_cor_d */

        case 5:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 696; /* lasx_xvfcmp_cor_s */

        default:
          return -1;
        }

    case LTGT:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 317; /* sltgt_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 331; /* sltgt_df_using_FCCmode */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 667; /* lsx_vfcmp_sne_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 677; /* lsx_vfcmp_sne_s */

        case 4:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 687; /* lasx_xvfcmp_sne_d */

        case 5:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 697; /* lasx_xvfcmp_sne_s */

        default:
          return -1;
        }

    case GE:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 319; /* sge_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 333; /* sge_df_using_FCCmode */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 699; /* lsx_vfcmp_sge_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 703; /* lsx_vfcmp_sge_s */

        case 4:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 707; /* lasx_xvfcmp_sge_d */

        case 5:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 711; /* lasx_xvfcmp_sge_s */

        default:
          return -1;
        }

    case UNGE:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 321; /* sunge_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 335; /* sunge_df_using_FCCmode */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 701; /* lsx_vfcmp_cuge_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 705; /* lsx_vfcmp_cuge_s */

        case 4:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 709; /* lasx_xvfcmp_cuge_d */

        case 5:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 713; /* lasx_xvfcmp_cuge_s */

        default:
          return -1;
        }

    case UNGT:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 322; /* sungt_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 336; /* sungt_df_using_FCCmode */

        case 2:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 702; /* lsx_vfcmp_cugt_d */

        case 3:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 706; /* lsx_vfcmp_cugt_s */

        case 4:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 710; /* lasx_xvfcmp_cugt_d */

        case 5:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 714; /* lasx_xvfcmp_cugt_s */

        default:
          return -1;
        }

    case CALL:
      return recog_123 (x1, insn, pnum_clobbers);

    case BITREVERSE:
      return recog_130 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_106 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_111 (x1, insn, pnum_clobbers);

    case VEC_MERGE:
      return recog_103 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 903 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1056; /* ssaddv2di3 */

        case 1:
          if (!
#line 903 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1057; /* ssaddv4si3 */

        case 2:
          if (!
#line 903 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1058; /* ssaddv8hi3 */

        case 3:
          if (!
#line 903 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1059; /* ssaddv16qi3 */

        case 4:
          if (!
#line 1043 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1658; /* ssaddv4di3 */

        case 5:
          if (!
#line 1043 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1659; /* ssaddv8si3 */

        case 6:
          if (!
#line 1043 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1660; /* ssaddv16hi3 */

        case 7:
          if (!
#line 1043 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1661; /* ssaddv32qi3 */

        default:
          return -1;
        }

    case US_PLUS:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 912 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1060; /* usaddv2di3 */

        case 1:
          if (!
#line 912 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1061; /* usaddv4si3 */

        case 2:
          if (!
#line 912 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1062; /* usaddv8hi3 */

        case 3:
          if (!
#line 912 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1063; /* usaddv16qi3 */

        case 4:
          if (!
#line 1052 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1662; /* usaddv4di3 */

        case 5:
          if (!
#line 1052 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1663; /* usaddv8si3 */

        case 6:
          if (!
#line 1052 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1664; /* usaddv16hi3 */

        case 7:
          if (!
#line 1052 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1665; /* usaddv32qi3 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      return recog_124 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_89 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      switch (pattern18 (x2))
        {
        case 0:
          if (!
#line 1280 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1169; /* fixuns_truncv2dfv2di2 */

        case 1:
          if (!
#line 1280 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1170; /* fixuns_truncv4sfv4si2 */

        case 2:
          if (!
#line 1391 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1773; /* fixuns_truncv4dfv4di2 */

        case 3:
          if (!
#line 1391 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1774; /* fixuns_truncv8sfv8si2 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern17 (x1))
        {
        case 0:
          if (!
#line 1568 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1195; /* umaxv2di3 */

        case 1:
          if (!
#line 1568 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1196; /* umaxv4si3 */

        case 2:
          if (!
#line 1568 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1197; /* umaxv8hi3 */

        case 3:
          if (!
#line 1568 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1198; /* umaxv16qi3 */

        case 4:
          if (!
#line 1748 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1799; /* umaxv4di3 */

        case 5:
          if (!
#line 1748 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1800; /* umaxv8si3 */

        case 6:
          if (!
#line 1748 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1801; /* umaxv16hi3 */

        case 7:
          if (!
#line 1748 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1802; /* umaxv32qi3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern17 (x1))
        {
        case 0:
          if (!
#line 1590 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1203; /* uminv2di3 */

        case 1:
          if (!
#line 1590 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1204; /* uminv4si3 */

        case 2:
          if (!
#line 1590 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1205; /* uminv8hi3 */

        case 3:
          if (!
#line 1590 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1206; /* uminv16qi3 */

        case 4:
          if (!
#line 1770 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1807; /* uminv4di3 */

        case 5:
          if (!
#line 1770 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1808; /* uminv8si3 */

        case 6:
          if (!
#line 1770 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1809; /* uminv16hi3 */

        case 7:
          if (!
#line 1770 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1810; /* uminv32qi3 */

        default:
          return -1;
        }

    case POPCOUNT:
      return recog_113 (x1, insn, pnum_clobbers);

    case SS_MINUS:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 1724 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1249; /* lsx_vssub_s_d */

        case 1:
          if (!
#line 1724 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1250; /* lsx_vssub_s_w */

        case 2:
          if (!
#line 1724 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1251; /* lsx_vssub_s_h */

        case 3:
          if (!
#line 1724 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1252; /* lsx_vssub_s_b */

        case 4:
          if (!
#line 2049 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1857; /* lasx_xvssub_s_d */

        case 5:
          if (!
#line 2049 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1858; /* lasx_xvssub_s_w */

        case 6:
          if (!
#line 2049 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1859; /* lasx_xvssub_s_h */

        case 7:
          if (!
#line 2049 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1860; /* lasx_xvssub_s_b */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 1733 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1253; /* lsx_vssub_u_du */

        case 1:
          if (!
#line 1733 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1254; /* lsx_vssub_u_wu */

        case 2:
          if (!
#line 1733 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1255; /* lsx_vssub_u_hu */

        case 3:
          if (!
#line 1733 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1256; /* lsx_vssub_u_bu */

        case 4:
          if (!
#line 2058 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1861; /* lasx_xvssub_u_du */

        case 5:
          if (!
#line 2058 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1862; /* lasx_xvssub_u_wu */

        case 6:
          if (!
#line 2058 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1863; /* lasx_xvssub_u_hu */

        case 7:
          if (!
#line 2058 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1864; /* lasx_xvssub_u_bu */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
