/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_vector_same_val_operand (operands[2], i1)
      || !const_uimm5_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern13 (x3); /* [-1, 5] */
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 2;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern29 (x1, 
E_V2DImode, 
E_V1DImode, 
E_V2TImode, 
E_V1TImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern29 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V4DImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern29 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V8SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern29 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V16HImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2TImode:
      if (pattern29 (x1, 
E_V4DImode, 
E_V2DImode, 
E_V4TImode, 
E_V2TImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern29 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V8DImode, 
E_V4DImode) != 0)
        return -1;
      return 5;

    case E_V8SImode:
      if (pattern29 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V16SImode, 
E_V8SImode) != 0)
        return -1;
      return 6;

    case E_V16HImode:
      if (pattern29 (x1, 
E_V32QImode, 
E_V16QImode, 
E_V32HImode, 
E_V16HImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern49 (x3, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern49 (x3, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 0;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern67 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern64 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !const_uimm5_operand (operands[2], E_VOIDmode))
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern65 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern66 (x3, 
E_V16QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      return pattern68 (x3, 
E_V4DImode, 
E_V8SImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern69 (x3, 
E_V8SImode, 
E_V16HImode) != 0)
        return -1;
      return 1;

    case E_V16HImode:
      if (pattern70 (x3, 
E_V32QImode, 
E_V16HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern88 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern91 (x1, 
E_V2DFmode, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern91 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V4DImode:
      if (pattern91 (x1, 
E_V4DFmode, 
E_V4DImode) != 0)
        return -1;
      return 2;

    case E_V8SImode:
      if (pattern91 (x1, 
E_V8SFmode, 
E_V8SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (!register_operand (x3, E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (!register_operand (x4, E_SImode))
    return -1;
  return 0;
}

int
pattern108 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 1);
  switch (XWINT (x5, 0))
    {
    case 8L:
      x6 = XEXP (x2, 1);
      if (XWINT (x6, 0) != 56L)
        return -1;
      return 0;

    case 16L:
      x6 = XEXP (x2, 1);
      if (XWINT (x6, 0) != 48L)
        return -1;
      return 1;

    case 24L:
      x6 = XEXP (x2, 1);
      if (XWINT (x6, 0) != 40L)
        return -1;
      return 2;

    case 32L:
      x6 = XEXP (x2, 1);
      if (XWINT (x6, 0) != 32L)
        return -1;
      return 3;

    case 40L:
      x6 = XEXP (x2, 1);
      if (XWINT (x6, 0) != 24L)
        return -1;
      return 4;

    case 48L:
      x6 = XEXP (x2, 1);
      if (XWINT (x6, 0) != 16L)
        return -1;
      return 5;

    case 56L:
      x6 = XEXP (x2, 1);
      if (XWINT (x6, 0) != 8L)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !register_operand (operands[1], E_SImode)
      || !plus_si_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern130 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !uns_arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !reg_or_vector_same_val_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern157 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern164 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern170 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !const_exp_4_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern176 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern186 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode
      || !aq12b_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern196 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !const_0_or_1_operand (operands[2], i1))
        return -1;
      return 0;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode)
          || !const_0_to_3_operand (operands[2], i1))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFT
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_immalsl_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  x8 = XEXP (x1, 1);
  operands[4] = x8;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern213 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern220 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern51 (x1))
    {
    case 0:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 560; /* lsx_vfrintrz_d */

    case 1:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 565; /* lsx_vfrintrz_s */

    case 2:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 570; /* lasx_xvfrintrz_d */

    case 3:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 575; /* lasx_xvfrintrz_s */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_SImode)
          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
        return -1;
      return 438; /* stack_tiesi */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !register_operand (operands[1], E_DImode)
          || !
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 439; /* stack_tiedi */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      if (pattern140 (x3, 
E_V4DImode) != 0
          || !
#line 3514 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2148; /* lasx_xvpickve_d */

    case E_V4DFmode:
      if (pattern140 (x3, 
E_V4DFmode) != 0
          || !
#line 3514 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2149; /* lasx_xvpickve_d_f */

    case E_V8SImode:
      if (pattern142 (x3, 
E_V8SImode) != 0
          || !
#line 3514 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2150; /* lasx_xvpickve_w */

    case E_V8SFmode:
      if (pattern142 (x3, 
E_V8SFmode) != 0
          || !
#line 3514 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2151; /* lasx_xvpickve_w_f */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 2697 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2012; /* lasx_xvsigncov_d */

    case 1:
      if (!
#line 2697 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2013; /* lasx_xvsigncov_w */

    case 2:
      if (!
#line 2697 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2014; /* lasx_xvsigncov_h */

    case 3:
      if (!
#line 2697 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2015; /* lasx_xvsigncov_b */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern77 (x1))
    {
    case 0:
      if (!
#line 1190 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1717; /* lasx_xvbitseti_d */

    case 1:
      if (!
#line 1190 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1718; /* lasx_xvbitseti_w */

    case 2:
      if (!
#line 1190 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1719; /* lasx_xvbitseti_h */

    case 3:
      if (!
#line 1190 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1720; /* lasx_xvbitseti_b */

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 1076 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1674; /* lasx_xvavg_s_d */

    case 1:
      if (!
#line 1076 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1675; /* lasx_xvavg_s_w */

    case 2:
      if (!
#line 1076 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1676; /* lasx_xvavg_s_h */

    case 3:
      if (!
#line 1076 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1677; /* lasx_xvavg_s_b */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 1040 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1109; /* lsx_vbitset_d */

    case 1:
      if (!
#line 1040 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1110; /* lsx_vbitset_w */

    case 2:
      if (!
#line 1040 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1111; /* lsx_vbitset_h */

    case 3:
      if (!
#line 1040 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1112; /* lsx_vbitset_b */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 754; /* lsx_vfcmp_sune_d */

    case 1:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 762; /* lsx_vfcmp_sune_s */

    case 2:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 770; /* lasx_xvfcmp_sune_d */

    case 3:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 778; /* lasx_xvfcmp_sune_s */

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (pattern87 (x1, pnum_clobbers))
    {
    case 0:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      x5 = XEXP (x3, 2);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern189 (x3, 
E_SImode))
            {
            case 0:
              if (!(
#line 2518 "../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)))
                return -1;
              return 166; /* *seleqsi_using_si */

            case 1:
              if (!(
#line 2518 "../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 170; /* *seleqsi_using_di */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern189 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 2518 "../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && ((((
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))))
                return -1;
              return 168; /* *seleqdi_using_si */

            case 1:
              if (!(
#line 2518 "../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 172; /* *seleqdi_using_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1288; /* lsx_bz_d */

    case 2:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1290; /* lsx_bz_w */

    case 3:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1292; /* lsx_bz_h */

    case 4:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1294; /* lsx_bz_b */

    case 5:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1296; /* lsx_bz_d_f */

    case 6:
      if (!
#line 1878 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1298; /* lsx_bz_w_f */

    case 7:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1300; /* lsx_bz_v_d */

    case 8:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1302; /* lsx_bz_v_w */

    case 9:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1304; /* lsx_bz_v_h */

    case 10:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1306; /* lsx_bz_v_b */

    case 11:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1308; /* lsx_bz_v_d_f */

    case 12:
      if (!
#line 1896 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1310; /* lsx_bz_v_w_f */

    case 13:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1899; /* lasx_xbz_d */

    case 14:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1901; /* lasx_xbz_w */

    case 15:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1903; /* lasx_xbz_h */

    case 16:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1905; /* lasx_xbz_b */

    case 17:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1907; /* lasx_xbz_d_f */

    case 18:
      if (!
#line 2325 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1909; /* lasx_xbz_w_f */

    case 19:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1911; /* lasx_xbz_v_d */

    case 20:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1913; /* lasx_xbz_v_w */

    case 21:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1915; /* lasx_xbz_v_h */

    case 22:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1917; /* lasx_xbz_v_b */

    case 23:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1919; /* lasx_xbz_v_d_f */

    case 24:
      if (!
#line 2344 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1921; /* lasx_xbz_v_w_f */

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  switch (XWINT (x4, 0))
    {
    case 1L:
      if (XWINT (x5, 0) != 3L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern205 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !
#line 1404 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1179; /* lsx_vilvh_d */

        case E_V2DFmode:
          if (pattern205 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 1404 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1180; /* lsx_vilvh_d_f */

        default:
          return -1;
        }

    case 0L:
      if (XWINT (x5, 0) != 2L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern205 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !
#line 1536 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1189; /* lsx_vilvl_d */

        case E_V2DFmode:
          if (pattern205 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 1548 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1190; /* lsx_vilvl_d_f */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode)
            return -1;
          if (reg_or_0_operand (operands[1], E_DImode)
              && 
#line 1141 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 1143; /* lsx_vreplgr2vr_d */
          if (!register_operand (operands[1], E_DImode)
              || !
#line 1774 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1275; /* lsx_vreplvei_d_scalar */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode)
            return -1;
          if (reg_or_0_operand (operands[1], E_SImode)
              && 
#line 1141 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 1144; /* lsx_vreplgr2vr_w */
          if (!register_operand (operands[1], E_SImode)
              || !
#line 1774 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1276; /* lsx_vreplvei_w_scalar */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode)
            return -1;
          if (reg_or_0_operand (operands[1], E_HImode)
              && 
#line 1141 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 1145; /* lsx_vreplgr2vr_h */
          if (!register_operand (operands[1], E_HImode)
              || !
#line 1774 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1277; /* lsx_vreplvei_h_scalar */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode)
            return -1;
          if (reg_or_0_operand (operands[1], E_QImode)
              && 
#line 1141 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 1146; /* lsx_vreplgr2vr_b */
          if (!register_operand (operands[1], E_QImode)
              || !
#line 1774 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1278; /* lsx_vreplvei_b_scalar */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 1774 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1279; /* lsx_vreplvei_d_f_scalar */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 1774 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1280; /* lsx_vreplvei_w_f_scalar */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode
              || !reg_or_0_operand (operands[1], E_DImode)
              || !
#line 1251 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1747; /* lasx_xvreplgr2vr_d */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode
              || !reg_or_0_operand (operands[1], E_SImode)
              || !
#line 1251 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1748; /* lasx_xvreplgr2vr_w */

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x3) != E_V16HImode
              || !reg_or_0_operand (operands[1], E_HImode)
              || !
#line 1251 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1749; /* lasx_xvreplgr2vr_h */

        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x3) != E_V32QImode
              || !reg_or_0_operand (operands[1], E_QImode)
              || !
#line 1251 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1750; /* lasx_xvreplgr2vr_b */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 2174 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1887; /* lasx_xvreplve0_d_f_scalar */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 2174 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1888; /* lasx_xvreplve0_w_f_scalar */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern182 (x3, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 1744 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1257; /* lsx_vreplve_d */

            case E_V4SImode:
              if (pattern182 (x3, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 1744 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1258; /* lsx_vreplve_w */

            case E_V8HImode:
              if (pattern182 (x3, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 1744 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1259; /* lsx_vreplve_h */

            case E_V16QImode:
              if (pattern182 (x3, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 1744 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1260; /* lsx_vreplve_b */

            case E_V2DFmode:
              if (pattern182 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 1744 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1261; /* lsx_vreplve_d_f */

            case E_V4SFmode:
              if (pattern182 (x3, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 1744 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1262; /* lsx_vreplve_w_f */

            default:
              return -1;
            }

        case CONST_INT:
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern180 (x3, 
E_V2DImode, 
E_DImode) == 0
                  && 
#line 1765 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1269; /* lsx_vreplvei_d */
              break;

            case E_V4SImode:
              if (pattern181 (x3, 
E_V4SImode, 
E_SImode) == 0
                  && 
#line 1765 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1270; /* lsx_vreplvei_w */
              break;

            case E_V8HImode:
              if (register_operand (operands[0], E_V8HImode)
                  && GET_MODE (x3) == E_V8HImode
                  && GET_MODE (x4) == E_HImode
                  && register_operand (operands[1], E_V8HImode)
                  && const_uimm3_operand (operands[2], E_VOIDmode)
                  && 
#line 1765 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1271; /* lsx_vreplvei_h */
              break;

            case E_V16QImode:
              if (register_operand (operands[0], E_V16QImode)
                  && GET_MODE (x3) == E_V16QImode
                  && GET_MODE (x4) == E_QImode
                  && register_operand (operands[1], E_V16QImode)
                  && const_uimm4_operand (operands[2], E_VOIDmode)
                  && 
#line 1765 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1272; /* lsx_vreplvei_b */
              break;

            case E_V2DFmode:
              if (pattern180 (x3, 
E_V2DFmode, 
E_DFmode) == 0
                  && 
#line 1765 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1273; /* lsx_vreplvei_d_f */
              break;

            case E_V4SFmode:
              if (pattern181 (x3, 
E_V4SFmode, 
E_SFmode) == 0
                  && 
#line 1765 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1274; /* lsx_vreplvei_w_f */
              break;

            default:
              break;
            }
          if (XWINT (x7, 0) != 0L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4DImode:
              if (pattern182 (x3, 
E_V4DImode, 
E_DImode) != 0
                  || !
#line 2091 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1871; /* lasx_xvreplve0_d */

            case E_V8SImode:
              if (pattern182 (x3, 
E_V8SImode, 
E_SImode) != 0
                  || !
#line 2091 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1872; /* lasx_xvreplve0_w */

            case E_V16HImode:
              if (pattern182 (x3, 
E_V16HImode, 
E_HImode) != 0
                  || !
#line 2091 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1873; /* lasx_xvreplve0_h */

            case E_V32QImode:
              if (pattern182 (x3, 
E_V32QImode, 
E_QImode) != 0
                  || !
#line 2091 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1874; /* lasx_xvreplve0_b */

            case E_V4DFmode:
              if (pattern182 (x3, 
E_V4DFmode, 
E_DFmode) != 0
                  || !
#line 2091 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1875; /* lasx_xvreplve0_d_f */

            case E_V8SFmode:
              if (pattern182 (x3, 
E_V8SFmode, 
E_SFmode) != 0
                  || !
#line 2091 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1876; /* lasx_xvreplve0_w_f */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MEM:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case PLUS:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x6, 1);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern183 (x3, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 2599 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1430; /* lsx_vldrepl_d_insn */

            case E_V4SImode:
              if (pattern184 (x3, 
E_SImode, 
E_V4SImode) != 0
                  || !
#line 2599 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1431; /* lsx_vldrepl_w_insn */

            case E_V8HImode:
              if (pattern185 (x3, 
E_V8HImode) != 0
                  || !
#line 2599 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1432; /* lsx_vldrepl_h_insn */

            case E_V16QImode:
              if (pattern186 (x3, 
E_V16QImode) != 0
                  || !
#line 2599 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1433; /* lsx_vldrepl_b_insn */

            case E_V2DFmode:
              if (pattern183 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 2599 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1434; /* lsx_vldrepl_d_f_insn */

            case E_V4SFmode:
              if (pattern184 (x3, 
E_SFmode, 
E_V4SFmode) != 0
                  || !
#line 2599 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1435; /* lsx_vldrepl_w_f_insn */

            case E_V4DImode:
              if (pattern183 (x3, 
E_DImode, 
E_V4DImode) != 0
                  || !
#line 3075 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2044; /* lasx_xvldrepl_d_insn */

            case E_V8SImode:
              if (pattern184 (x3, 
E_SImode, 
E_V8SImode) != 0
                  || !
#line 3075 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2045; /* lasx_xvldrepl_w_insn */

            case E_V16HImode:
              if (pattern185 (x3, 
E_V16HImode) != 0
                  || !
#line 3075 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2046; /* lasx_xvldrepl_h_insn */

            case E_V32QImode:
              if (pattern186 (x3, 
E_V32QImode) != 0
                  || !
#line 3075 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2047; /* lasx_xvldrepl_b_insn */

            case E_V4DFmode:
              if (pattern183 (x3, 
E_DFmode, 
E_V4DFmode) != 0
                  || !
#line 3075 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2048; /* lasx_xvldrepl_d_f_insn */

            case E_V8SFmode:
              if (pattern184 (x3, 
E_SFmode, 
E_V8SFmode) != 0
                  || !
#line 3075 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2049; /* lasx_xvldrepl_w_f_insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x3) != E_V2DImode
                  || GET_MODE (x4) != E_DImode
                  || !
#line 2611 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1436; /* lsx_vldrepl_d_insn_0 */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x3) != E_V4SImode
                  || GET_MODE (x4) != E_SImode
                  || !
#line 2611 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1437; /* lsx_vldrepl_w_insn_0 */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x3) != E_V8HImode
                  || GET_MODE (x4) != E_HImode
                  || !
#line 2611 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1438; /* lsx_vldrepl_h_insn_0 */

            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x3) != E_V16QImode
                  || GET_MODE (x4) != E_QImode
                  || !
#line 2611 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1439; /* lsx_vldrepl_b_insn_0 */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || GET_MODE (x4) != E_DFmode
                  || !
#line 2611 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1440; /* lsx_vldrepl_d_f_insn_0 */

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || GET_MODE (x4) != E_SFmode
                  || !
#line 2611 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1441; /* lsx_vldrepl_w_f_insn_0 */

            case E_V4DImode:
              if (!register_operand (operands[0], E_V4DImode)
                  || GET_MODE (x3) != E_V4DImode
                  || GET_MODE (x4) != E_DImode
                  || !
#line 3088 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2050; /* lasx_xvldrepl_d_insn_0 */

            case E_V8SImode:
              if (!register_operand (operands[0], E_V8SImode)
                  || GET_MODE (x3) != E_V8SImode
                  || GET_MODE (x4) != E_SImode
                  || !
#line 3088 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2051; /* lasx_xvldrepl_w_insn_0 */

            case E_V16HImode:
              if (!register_operand (operands[0], E_V16HImode)
                  || GET_MODE (x3) != E_V16HImode
                  || GET_MODE (x4) != E_HImode
                  || !
#line 3088 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2052; /* lasx_xvldrepl_h_insn_0 */

            case E_V32QImode:
              if (!register_operand (operands[0], E_V32QImode)
                  || GET_MODE (x3) != E_V32QImode
                  || GET_MODE (x4) != E_QImode
                  || !
#line 3088 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2053; /* lasx_xvldrepl_b_insn_0 */

            case E_V4DFmode:
              if (!register_operand (operands[0], E_V4DFmode)
                  || GET_MODE (x3) != E_V4DFmode
                  || GET_MODE (x4) != E_DFmode
                  || !
#line 3088 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2054; /* lasx_xvldrepl_d_f_insn_0 */

            case E_V8SFmode:
              if (!register_operand (operands[0], E_V8SFmode)
                  || GET_MODE (x3) != E_V8SFmode
                  || GET_MODE (x4) != E_SFmode
                  || !
#line 3088 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2055; /* lasx_xvldrepl_w_f_insn_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern112 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 140; /* fix_truncsfsi2 */

            case 1:
              if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 142; /* fix_truncdfsi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern112 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 141; /* fix_truncsfdi2 */

            case 1:
              if (!(
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 143; /* fix_truncdfdi2 */

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 599; /* fix_truncv2dfv2di2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 600; /* fix_truncv4sfv4si2 */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode
              || !register_operand (operands[1], E_V4DFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 601; /* fix_truncv4dfv4di2 */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode
              || !register_operand (operands[1], E_V8SFmode)
              || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 602; /* fix_truncv8sfv8si2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      switch (XINT (x4, 1))
        {
        case 53:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern150 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 579; /* lsx_vftintrp_l_d */

            case E_V4SImode:
              if (pattern150 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 584; /* lsx_vftintrp_w_s */

            case E_V4DImode:
              if (pattern150 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 589; /* lasx_xvftintrp_l_d */

            case E_V8SImode:
              if (pattern150 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 594; /* lasx_xvftintrp_w_s */

            default:
              return -1;
            }

        case 54:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern150 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 580; /* lsx_vftintrz_l_d */

            case E_V4SImode:
              if (pattern150 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 585; /* lsx_vftintrz_w_s */

            case E_V4DImode:
              if (pattern150 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 590; /* lasx_xvftintrz_l_d */

            case E_V8SImode:
              if (pattern150 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 595; /* lasx_xvftintrz_w_s */

            default:
              return -1;
            }

        case 55:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern150 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 581; /* lsx_vftint_l_d */

            case E_V4SImode:
              if (pattern150 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 586; /* lsx_vftint_w_s */

            case E_V4DImode:
              if (pattern150 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 591; /* lasx_xvftint_l_d */

            case E_V8SImode:
              if (pattern150 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 596; /* lasx_xvftint_w_s */

            default:
              return -1;
            }

        case 56:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern150 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 582; /* lsx_vftintrm_l_d */

            case E_V4SImode:
              if (pattern150 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 587; /* lsx_vftintrm_w_s */

            case E_V4DImode:
              if (pattern150 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 592; /* lasx_xvftintrm_l_d */

            case E_V8SImode:
              if (pattern150 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 597; /* lasx_xvftintrm_w_s */

            default:
              return -1;
            }

        case 57:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern150 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 583; /* lsx_vftintrne_l_d */

            case E_V4SImode:
              if (pattern150 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 588; /* lsx_vftintrne_w_s */

            case E_V4DImode:
              if (pattern150 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 593; /* lasx_xvftintrne_l_d */

            case E_V8SImode:
              if (pattern150 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
                  || !
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 598; /* lasx_xvftintrne_w_s */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern93 (x3, 
E_V4SFmode, 
E_V2DImode, 
E_V2SFmode))
        {
        case 0:
          if (!
#line 2512 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1422; /* vec_unpack_sfix_trunc_hi_v4sf */

        case 1:
          if (!
#line 2523 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1423; /* vec_unpack_sfix_trunc_lo_v4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern153 (x3, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
              || !
#line 302 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 935; /* vec_pack_trunc_v2di */

        case E_V8HImode:
          if (pattern153 (x3, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
              || !
#line 302 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 936; /* vec_pack_trunc_v4si */

        case E_V16QImode:
          if (pattern153 (x3, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
              || !
#line 302 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 937; /* vec_pack_trunc_v8hi */

        case E_V8SImode:
          if (pattern153 (x3, 
E_V4DImode, 
E_V4SImode, 
E_V8SImode) != 0
              || !
#line 400 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1531; /* vec_pack_trunc_v4di */

        case E_V16HImode:
          if (pattern153 (x3, 
E_V8SImode, 
E_V8HImode, 
E_V16HImode) != 0
              || !
#line 400 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1532; /* vec_pack_trunc_v8si */

        case E_V32QImode:
          if (pattern153 (x3, 
E_V16HImode, 
E_V16QImode, 
E_V32QImode) != 0
              || !
#line 400 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1533; /* vec_pack_trunc_v16hi */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != FLOAT_TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern153 (x3, 
E_V2DFmode, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !
#line 1804 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1283; /* vec_pack_trunc_v2df */

        case E_V8SFmode:
          if (pattern153 (x3, 
E_V4DFmode, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 2213 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1892; /* vec_pack_trunc_v4df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern12 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 1926 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1312; /* vec_concatv2df */

        case E_V4DImode:
          if (pattern12 (x3, 
E_V2DImode, 
E_V4DImode) != 0
              || !
#line 467 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1536; /* vec_concatv4di */

        case E_V8SImode:
          if (pattern12 (x3, 
E_V4SImode, 
E_V8SImode) != 0
              || !
#line 467 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1537; /* vec_concatv8si */

        case E_V16HImode:
          if (pattern12 (x3, 
E_V8HImode, 
E_V16HImode) != 0
              || !
#line 467 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1538; /* vec_concatv16hi */

        case E_V32QImode:
          if (pattern12 (x3, 
E_V16QImode, 
E_V32QImode) != 0
              || !
#line 467 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1539; /* vec_concatv32qi */

        case E_V4DFmode:
          if (pattern12 (x3, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 467 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1540; /* vec_concatv4df */

        case E_V8SFmode:
          if (pattern12 (x3, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 467 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1541; /* vec_concatv8sf */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (pattern94 (x3) != 0
          || !
#line 1949 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1313; /* vec_concatv4sf */

    case FLOAT:
      if (pattern95 (x3, 
E_V2DImode, 
E_V4SFmode, 
E_V2SFmode, 
FLOAT) != 0
          || !
#line 2421 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1413; /* vec_packs_float_v2di */

    case FIX:
      if (pattern95 (x3, 
E_V2DFmode, 
E_V4SImode, 
E_V2SImode, 
FIX) != 0
          || !
#line 2431 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1414; /* vec_pack_sfix_trunc_v2df */

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern116 (x3))
        {
        case 0:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 297; /* *slt_sisi */

        case 1:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 299; /* *slt_disi */

        default:
          return -1;
        }

    case E_DImode:
      if (pattern4 (x3, 
E_DImode) != 0
          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 301; /* *slt_didi */

    case E_FCCmode:
      switch (pattern11 (x3))
        {
        case 0:
          if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 314; /* slt_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 328; /* slt_df_using_FCCmode */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern117 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 664; /* lsx_vfcmp_slt_d */

        case 1:
          if (!
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1120; /* lsx_vslt_d */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern118 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 674; /* lsx_vfcmp_slt_s */

        case 1:
          if (!
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1125; /* lsx_vslt_w */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern119 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 684; /* lasx_xvfcmp_slt_d */

        case 1:
          if (!
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1724; /* lasx_xvslt_d */

        default:
          return -1;
        }

    case E_V8SImode:
      switch (pattern120 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 694; /* lasx_xvfcmp_slt_s */

        case 1:
          if (!
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1729; /* lasx_xvslt_w */

        default:
          return -1;
        }

    case E_V8HImode:
      if (pattern2 (x3, 
E_V8HImode) != 0
          || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1130; /* lsx_vslt_h */

    case E_V16QImode:
      if (pattern2 (x3, 
E_V16QImode) != 0
          || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1135; /* lsx_vslt_b */

    case E_V16HImode:
      if (pattern2 (x3, 
E_V16HImode) != 0
          || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1734; /* lasx_xvslt_h */

    case E_V32QImode:
      if (pattern2 (x3, 
E_V32QImode) != 0
          || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1739; /* lasx_xvslt_b */

    default:
      return -1;
    }
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern3 (x1))
    {
    case 0:
      if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 79; /* smaxsf3 */

    case 1:
      if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 80; /* smaxdf3 */

    case 2:
      if (!
#line 1176 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1151; /* smaxv2df3 */

    case 3:
      if (!
#line 1176 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1152; /* smaxv4sf3 */

    case 4:
      if (!
#line 1557 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1191; /* smaxv2di3 */

    case 5:
      if (!
#line 1557 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1192; /* smaxv4si3 */

    case 6:
      if (!
#line 1557 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1193; /* smaxv8hi3 */

    case 7:
      if (!
#line 1557 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1194; /* smaxv16qi3 */

    case 8:
      if (!
#line 1287 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1755; /* smaxv4df3 */

    case 9:
      if (!
#line 1287 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1756; /* smaxv8sf3 */

    case 10:
      if (!
#line 1737 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1795; /* smaxv4di3 */

    case 11:
      if (!
#line 1737 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1796; /* smaxv8si3 */

    case 12:
      if (!
#line 1737 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1797; /* smaxv16hi3 */

    case 13:
      if (!
#line 1737 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1798; /* smaxv32qi3 */

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case EH_RETURN:
      if (!
#line 3704 "../../gcc/config/loongarch/loongarch.md"
(epilogue_completed))
        return NULL;
      return gen_split_25 (insn, operands);

    case PARALLEL:
    case UNSPEC:
    case UNSPEC_VOLATILE:
    case PREFETCH:
    case SET:
      switch (GET_CODE (x1))
        {
        case SET:
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case PARALLEL:
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      operands[0] = x1;
      if (small_data_pattern (operands[0], E_VOIDmode)
          && 
#line 4388 "../../gcc/config/loongarch/loongarch.md"
(reload_completed))
        return gen_split_27 (insn, operands);
      if (GET_CODE (x1) != SET)
        return NULL;
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case UNSPEC:
          if (XVECLEN (x3, 0) != 2)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 0)
            return NULL;
          x5 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != XOR
              || GET_MODE (x6) != E_DImode)
            return NULL;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != SUBREG
              || maybe_ne (SUBREG_BYTE (x7), 0)
              || GET_MODE (x7) != E_DImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_DImode))
            return NULL;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          switch (XINT (x3, 1))
            {
            case 24:
              switch (pattern137 (x4))
                {
                case 0:
                  if (!(
#line 4571 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()) && 
#line 4573 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return NULL;
                  return gen_split_28 (insn, operands);

                case 1:
                  if (!(
#line 4571 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()) && 
#line 4573 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return NULL;
                  return gen_split_30 (insn, operands);

                case 2:
                  if (!(
#line 4571 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()) && 
#line 4573 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return NULL;
                  return gen_split_32 (insn, operands);

                default:
                  return NULL;
                }

            case 25:
              switch (pattern137 (x4))
                {
                case 0:
                  if (!(
#line 4571 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()) && 
#line 4573 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return NULL;
                  return gen_split_29 (insn, operands);

                case 1:
                  if (!(
#line 4571 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()) && 
#line 4573 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return NULL;
                  return gen_split_31 (insn, operands);

                case 2:
                  if (!(
#line 4571 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()) && 
#line 4573 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return NULL;
                  return gen_split_33 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          switch (pattern101 (x3))
            {
            case 0:
              if (!(
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4617 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_38 (insn, operands);

            case 1:
              if (!(
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4617 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_40 (insn, operands);

            case 2:
              if (!(
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4617 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_42 (insn, operands);

            case 3:
              if (!((
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4617 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_44 (insn, operands);

            case 4:
              if (!((
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4617 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_46 (insn, operands);

            case 5:
              if (!((
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4617 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_48 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern101 (x3))
            {
            case 0:
              if (!(
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4617 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_39 (insn, operands);

            case 1:
              if (!(
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4617 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_41 (insn, operands);

            case 2:
              if (!(
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4617 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_43 (insn, operands);

            case 3:
              if (!((
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4617 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_45 (insn, operands);

            case 4:
              if (!((
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4617 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_47 (insn, operands);

            case 5:
              if (!((
#line 4613 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4617 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_49 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x3;
          switch (GET_CODE (operands[1]))
            {
            case MEM:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (register_operand (operands[0], E_SImode)
                      && mem_simple_ldst_operand (operands[1], E_SImode)
                      && (
#line 4600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4604 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_34 (insn, operands);
                  break;

                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && mem_simple_ldst_operand (operands[1], E_DImode)
                      && ((
#line 4600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4604 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_35 (insn, operands);
                  break;

                case E_SFmode:
                  if (register_operand (operands[0], E_SFmode)
                      && mem_simple_ldst_operand (operands[1], E_SFmode)
                      && ((
#line 4600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)) && 
#line 4604 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_36 (insn, operands);
                  break;

                case E_DFmode:
                  if (register_operand (operands[0], E_DFmode)
                      && mem_simple_ldst_operand (operands[1], E_DFmode)
                      && ((
#line 4600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 4604 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_37 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (mem_simple_ldst_operand (operands[0], E_QImode)
                      && reg_or_0_operand (operands[1], E_QImode)
                      && (
#line 4625 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4629 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_50 (insn, operands);
                  break;

                case E_HImode:
                  if (mem_simple_ldst_operand (operands[0], E_HImode)
                      && reg_or_0_operand (operands[1], E_HImode)
                      && (
#line 4625 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4629 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_51 (insn, operands);
                  break;

                case E_SImode:
                  if (mem_simple_ldst_operand (operands[0], E_SImode)
                      && reg_or_0_operand (operands[1], E_SImode)
                      && (
#line 4625 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4629 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_52 (insn, operands);
                  break;

                case E_DImode:
                  if (mem_simple_ldst_operand (operands[0], E_DImode)
                      && reg_or_0_operand (operands[1], E_DImode)
                      && ((
#line 4625 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 401 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4629 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_53 (insn, operands);
                  break;

                case E_SFmode:
                  if (mem_simple_ldst_operand (operands[0], E_SFmode)
                      && reg_or_0_operand (operands[1], E_SFmode)
                      && ((
#line 4625 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)) && 
#line 4629 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_54 (insn, operands);
                  break;

                case E_DFmode:
                  if (mem_simple_ldst_operand (operands[0], E_DFmode)
                      && reg_or_0_operand (operands[1], E_DFmode)
                      && ((
#line 4625 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 4629 "../../gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_55 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (!nonimmediate_operand (operands[0], E_V2DImode)
                  || !move_operand (operands[1], E_V2DImode)
                  || !(
#line 210 "../../gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
                return NULL;
              return gen_split_56 (insn, operands);

            case E_V4SImode:
              if (!nonimmediate_operand (operands[0], E_V4SImode)
                  || !move_operand (operands[1], E_V4SImode)
                  || !(
#line 210 "../../gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
                return NULL;
              return gen_split_57 (insn, operands);

            case E_V8HImode:
              if (!nonimmediate_operand (operands[0], E_V8HImode)
                  || !move_operand (operands[1], E_V8HImode)
                  || !(
#line 210 "../../gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
                return NULL;
              return gen_split_58 (insn, operands);

            case E_V16QImode:
              if (!nonimmediate_operand (operands[0], E_V16QImode)
                  || !move_operand (operands[1], E_V16QImode)
                  || !(
#line 210 "../../gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
                return NULL;
              return gen_split_59 (insn, operands);

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[0], E_V2DFmode)
                  || !move_operand (operands[1], E_V2DFmode)
                  || !(
#line 210 "../../gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
                return NULL;
              return gen_split_60 (insn, operands);

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[0], E_V4SFmode)
                  || !move_operand (operands[1], E_V4SFmode)
                  || !(
#line 210 "../../gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
                return NULL;
              return gen_split_61 (insn, operands);

            case E_V4DImode:
              if (!nonimmediate_operand (operands[0], E_V4DImode)
                  || !move_operand (operands[1], E_V4DImode)
                  || !(
#line 210 "../../gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
                return NULL;
              return gen_split_62 (insn, operands);

            case E_V8SImode:
              if (!nonimmediate_operand (operands[0], E_V8SImode)
                  || !move_operand (operands[1], E_V8SImode)
                  || !(
#line 210 "../../gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
                return NULL;
              return gen_split_63 (insn, operands);

            case E_V16HImode:
              if (!nonimmediate_operand (operands[0], E_V16HImode)
                  || !move_operand (operands[1], E_V16HImode)
                  || !(
#line 210 "../../gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
                return NULL;
              return gen_split_64 (insn, operands);

            case E_V32QImode:
              if (!nonimmediate_operand (operands[0], E_V32QImode)
                  || !move_operand (operands[1], E_V32QImode)
                  || !(
#line 210 "../../gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
                return NULL;
              return gen_split_65 (insn, operands);

            case E_V4DFmode:
              if (!nonimmediate_operand (operands[0], E_V4DFmode)
                  || !move_operand (operands[1], E_V4DFmode)
                  || !(
#line 210 "../../gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
                return NULL;
              return gen_split_66 (insn, operands);

            case E_V8SFmode:
              if (!nonimmediate_operand (operands[0], E_V8SFmode)
                  || !move_operand (operands[1], E_V8SFmode)
                  || !(
#line 210 "../../gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
                return NULL;
              return gen_split_67 (insn, operands);

            case E_V1TImode:
              if (!nonimmediate_operand (operands[0], E_V1TImode)
                  || !move_operand (operands[1], E_V1TImode)
                  || !(
#line 210 "../../gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 184 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
                return NULL;
              return gen_split_68 (insn, operands);

            case E_V2TImode:
              if (!nonimmediate_operand (operands[0], E_V2TImode)
                  || !move_operand (operands[1], E_V2TImode)
                  || !(
#line 210 "../../gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 185 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
                return NULL;
              return gen_split_69 (insn, operands);

            default:
              return NULL;
            }

        case FIX:
          switch (pattern18 (x3))
            {
            case 0:
              if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return NULL;
              return gen_split_70 (insn, operands);

            case 1:
              if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return NULL;
              return gen_split_71 (insn, operands);

            case 2:
              if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return NULL;
              return gen_split_72 (insn, operands);

            case 3:
              if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return NULL;
              return gen_split_73 (insn, operands);

            default:
              return NULL;
            }

        case VEC_SELECT:
          x10 = XEXP (x3, 1);
          if (GET_CODE (x10) != PARALLEL
              || XVECLEN (x10, 0) != 1)
            return NULL;
          x11 = XVECEXP (x10, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          switch (pattern133 (x3))
            {
            case 0:
              if (!(
#line 375 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX) && 
#line 377 "../../gcc/config/loongarch/lsx.md"
( reload_completed)))
                return NULL;
              return gen_split_74 (insn, operands);

            case 1:
              if (!(
#line 626 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LSX) && 
#line 628 "../../gcc/config/loongarch/lasx.md"
( reload_completed)))
                return NULL;
              return gen_split_78 (insn, operands);

            case 2:
              if (!(
#line 375 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX) && 
#line 377 "../../gcc/config/loongarch/lsx.md"
( reload_completed)))
                return NULL;
              return gen_split_75 (insn, operands);

            case 3:
              if (!(
#line 626 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LSX) && 
#line 628 "../../gcc/config/loongarch/lasx.md"
( reload_completed)))
                return NULL;
              return gen_split_79 (insn, operands);

            default:
              return NULL;
            }

        case VEC_CONCAT:
          x12 = XEXP (x3, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              operands[1] = x12;
              if (!register_operand (operands[1], E_DFmode)
                  || !register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode)
                return NULL;
              x10 = XEXP (x3, 1);
              operands[2] = x10;
              if (!register_operand (operands[2], E_DFmode)
                  || !(
#line 1926 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX) && 
#line 1928 "../../gcc/config/loongarch/lsx.md"
( reload_completed)))
                return NULL;
              return gen_split_76 (insn, operands);

            case VEC_CONCAT:
              if (pattern94 (x3) != 0
                  || !(
#line 1949 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX) && 
#line 1951 "../../gcc/config/loongarch/lsx.md"
( reload_completed)))
                return NULL;
              return gen_split_77 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
