/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_vector_same_val_operand (operands[2], i1)
      || !const_uimm4_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern0 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 3;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 4;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 5;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 6;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern41 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CONST_INT
      || !register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || GET_MODE (x2) != i2)
    return -1;
  return pattern40 (x3, 
i1); /* [-1, 1] */
}

int
pattern46 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern61 (x3, 
E_V2DFmode, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern61 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V4DImode:
      if (pattern61 (x3, 
E_V4DFmode, 
E_V4DImode) != 0)
        return -1;
      return 2;

    case E_V8SImode:
      if (pattern61 (x3, 
E_V8SFmode, 
E_V8SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V2DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V2DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V2DImode))
    return -1;
  return 0;
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 2;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 3;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 4;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 5;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 6;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 7;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 8;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern112 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern121 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !sle_operand (operands[2], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !sle_operand (operands[2], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !sle_operand (operands[2], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!memory_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!memory_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!memory_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern146 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_uimm8_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      return pattern58 (x1, 
E_V4DImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern58 (x1, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V16HImode:
      if (pattern58 (x1, 
E_V16HImode) != 0)
        return -1;
      return 2;

    case E_V32QImode:
      if (pattern58 (x1, 
E_V32QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern163 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_0_to_7_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern169 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern173 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !const_exp_4_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern183 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aq12d_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern191 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern200 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_even_or_odd_half (operands[4], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i3
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern219 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i1)
      || !reg_or_0_operand (operands[5], i1)
      || !scratch_operand (operands[7], i1)
      || !scratch_operand (operands[8], i1))
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern51 (x1))
    {
    case 0:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 561; /* lsx_vfrint_d */

    case 1:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 566; /* lsx_vfrint_s */

    case 2:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 571; /* lasx_xvfrint_d */

    case 3:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 576; /* lasx_xvfrint_s */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (pattern139 (x3, 
E_V2DImode) != 0
          || !
#line 1754 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1263; /* lsx_vreplvei_mirror_d */

    case E_V4SImode:
      if (pattern140 (x3, 
E_V4SImode) != 0
          || !
#line 1754 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1264; /* lsx_vreplvei_mirror_w */

    case E_V8HImode:
      if (pattern66 (x3, 
E_V8HImode) != 0
          || !
#line 1754 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1265; /* lsx_vreplvei_mirror_h */

    case E_V16QImode:
      if (pattern65 (x3, 
E_V16QImode) != 0
          || !
#line 1754 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1266; /* lsx_vreplvei_mirror_b */

    case E_V2DFmode:
      if (pattern139 (x3, 
E_V2DFmode) != 0
          || !
#line 1754 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1267; /* lsx_vreplvei_mirror_d_f */

    case E_V4SFmode:
      if (pattern140 (x3, 
E_V4SFmode) != 0
          || !
#line 1754 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1268; /* lsx_vreplvei_mirror_w_f */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern59 (x1))
    {
    case 0:
      if (!
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 83; /* fmaxsf3 */

    case 1:
      if (!
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 84; /* fmaxdf3 */

    case 2:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 779; /* fmaxv2df3 */

    case 3:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 781; /* fmaxv4sf3 */

    case 4:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 783; /* fmaxv4df3 */

    case 5:
      if (!
#line 42 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 785; /* fmaxv8sf3 */

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern81 (x1))
    {
    case 0:
      if (!
#line 2657 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1996; /* lasx_xvbsrl_d */

    case 1:
      if (!
#line 2657 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1997; /* lasx_xvbsrl_w */

    case 2:
      if (!
#line 2657 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1998; /* lasx_xvbsrl_h */

    case 3:
      if (!
#line 2657 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1999; /* lasx_xvbsrl_b */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern77 (x1))
    {
    case 0:
      if (!
#line 1146 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1702; /* lasx_xvbitrevi_d */

    case 1:
      if (!
#line 1146 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1703; /* lasx_xvbitrevi_w */

    case 2:
      if (!
#line 1146 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1704; /* lasx_xvbitrevi_h */

    case 3:
      if (!
#line 1146 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1705; /* lasx_xvbitrevi_b */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (pattern61 (x3, 
E_V4SFmode, 
E_V8HImode) != 0
          || !
#line 1784 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1281; /* lsx_vfcvt_h_s */

    case E_V4SFmode:
      if (pattern61 (x3, 
E_V2DFmode, 
E_V4SFmode) != 0
          || !
#line 1794 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1282; /* lsx_vfcvt_s_d */

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 976 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1088; /* lsx_vbitclr_d */

    case 1:
      if (!
#line 976 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1089; /* lsx_vbitclr_w */

    case 2:
      if (!
#line 976 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1090; /* lsx_vbitclr_h */

    case 3:
      if (!
#line 976 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1091; /* lsx_vbitclr_b */

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern160 (x2, 
E_V4DFmode) != 0
          || !
#line 2069 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1865; /* lasx_xvshuf_d_f */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern160 (x2, 
E_V8SFmode) != 0
          || !
#line 2069 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1866; /* lasx_xvshuf_w_f */

    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern160 (x2, 
E_V4DImode) != 0
          || !
#line 2069 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1867; /* lasx_xvshuf_d */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern160 (x2, 
E_V8SImode) != 0
          || !
#line 2069 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1868; /* lasx_xvshuf_w */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern160 (x2, 
E_V16HImode) != 0
          || !
#line 2069 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1869; /* lasx_xvshuf_h */

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && move_operand (operands[1], E_DImode))
        {
          if (
#line 2194 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
            return 152; /* *movdi_32bit */
          if (
#line 2213 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
            return 153; /* *movdi_64bit */
        }
      if (register_operand (operands[0], E_DImode)
          && mem_simple_ldst_operand (operands[1], E_DImode)
          && (
#line 4600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
        return 469; /* simple_loaddi */
      if (!mem_simple_ldst_operand (operands[0], E_DImode)
          || !reg_or_0_operand (operands[1], E_DImode)
          || !(
#line 4625 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 401 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
        return -1;
      return 487; /* simple_storedi */

    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && move_operand (operands[1], E_SImode)
          && 
#line 2303 "../../gcc/config/loongarch/loongarch.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))))
        return 156; /* *movsi_internal */
      if (register_operand (operands[0], E_SImode)
          && mem_simple_ldst_operand (operands[1], E_SImode)
          && 
#line 4600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)))
        return 468; /* simple_loadsi */
      if (!mem_simple_ldst_operand (operands[0], E_SImode)
          || !reg_or_0_operand (operands[1], E_SImode)
          || !
#line 4625 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)))
        return -1;
      return 486; /* simple_storesi */

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && move_operand (operands[1], E_HImode)
          && 
#line 2337 "../../gcc/config/loongarch/loongarch.md"
((register_operand (operands[0], HImode)
       || reg_or_0_operand (operands[1], HImode))))
        return 157; /* *movhi_internal */
      if (!mem_simple_ldst_operand (operands[0], E_HImode)
          || !reg_or_0_operand (operands[1], E_HImode)
          || !
#line 4625 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)))
        return -1;
      return 485; /* simple_storehi */

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && move_operand (operands[1], E_QImode)
          && 
#line 2371 "../../gcc/config/loongarch/loongarch.md"
((register_operand (operands[0], QImode)
       || reg_or_0_operand (operands[1], QImode))))
        return 158; /* *movqi_internal */
      if (!mem_simple_ldst_operand (operands[0], E_QImode)
          || !reg_or_0_operand (operands[1], E_QImode)
          || !
#line 4625 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)))
        return -1;
      return 484; /* simple_storeqi */

    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && move_operand (operands[1], E_SFmode))
        {
          if (
#line 2391 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT
   && (register_operand (operands[0], SFmode)
       || reg_or_0_operand (operands[1], SFmode))))
            return 159; /* *movsf_hardfloat */
          if (
#line 2401 "../../gcc/config/loongarch/loongarch.md"
(TARGET_SOFT_FLOAT
   && (register_operand (operands[0], SFmode)
       || reg_or_0_operand (operands[1], SFmode))))
            return 160; /* *movsf_softfloat */
        }
      if (register_operand (operands[0], E_SFmode)
          && mem_simple_ldst_operand (operands[1], E_SFmode)
          && (
#line 4600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
        return 470; /* simple_loadsf */
      if (!mem_simple_ldst_operand (operands[0], E_SFmode)
          || !reg_or_0_operand (operands[1], E_SFmode)
          || !(
#line 4625 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
        return -1;
      return 488; /* simple_storesf */

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && move_operand (operands[1], E_DFmode))
        {
          if (
#line 2422 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
            return 161; /* *movdf_hardfloat */
          if (
#line 2432 "../../gcc/config/loongarch/loongarch.md"
((TARGET_SOFT_FLOAT || TARGET_SINGLE_FLOAT)
   && TARGET_64BIT
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
            return 162; /* *movdf_softfloat */
        }
      if (register_operand (operands[0], E_DFmode)
          && mem_simple_ldst_operand (operands[1], E_DFmode)
          && (
#line 4600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
        return 471; /* simple_loaddf */
      if (!mem_simple_ldst_operand (operands[0], E_DFmode)
          || !reg_or_0_operand (operands[1], E_DFmode)
          || !(
#line 4625 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
        return -1;
      return 489; /* simple_storedf */

    case E_FCCmode:
      if (!nonimmediate_operand (operands[0], E_FCCmode)
          || !reg_or_0_operand (operands[1], E_FCCmode)
          || !
#line 2457 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 163; /* movfcc_internal */

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !move_operand (operands[1], E_V2DImode)
          || !
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 545; /* movv2di_simd */

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || !move_operand (operands[1], E_V4SImode)
          || !
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 546; /* movv4si_simd */

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || !move_operand (operands[1], E_V8HImode)
          || !
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 547; /* movv8hi_simd */

    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || !move_operand (operands[1], E_V16QImode)
          || !
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 548; /* movv16qi_simd */

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !move_operand (operands[1], E_V2DFmode)
          || !
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 549; /* movv2df_simd */

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !move_operand (operands[1], E_V4SFmode)
          || !
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 550; /* movv4sf_simd */

    case E_V4DImode:
      if (!nonimmediate_operand (operands[0], E_V4DImode)
          || !move_operand (operands[1], E_V4DImode)
          || !
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 551; /* movv4di_simd */

    case E_V8SImode:
      if (!nonimmediate_operand (operands[0], E_V8SImode)
          || !move_operand (operands[1], E_V8SImode)
          || !
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 552; /* movv8si_simd */

    case E_V16HImode:
      if (!nonimmediate_operand (operands[0], E_V16HImode)
          || !move_operand (operands[1], E_V16HImode)
          || !
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 553; /* movv16hi_simd */

    case E_V32QImode:
      if (!nonimmediate_operand (operands[0], E_V32QImode)
          || !move_operand (operands[1], E_V32QImode)
          || !
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 554; /* movv32qi_simd */

    case E_V4DFmode:
      if (!nonimmediate_operand (operands[0], E_V4DFmode)
          || !move_operand (operands[1], E_V4DFmode)
          || !
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 555; /* movv4df_simd */

    case E_V8SFmode:
      if (!nonimmediate_operand (operands[0], E_V8SFmode)
          || !move_operand (operands[1], E_V8SFmode)
          || !
#line 45 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 556; /* movv8sf_simd */

    case E_V1TImode:
      if (!nonimmediate_operand (operands[0], E_V1TImode)
          || !move_operand (operands[1], E_V1TImode)
          || !
#line 184 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 557; /* movv1ti_simd */

    case E_V2TImode:
      if (!nonimmediate_operand (operands[0], E_V2TImode)
          || !move_operand (operands[1], E_V2TImode)
          || !
#line 185 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 558; /* movv2ti_simd */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern0 (x3, 
E_SFmode) != 0
                  || !
#line 404 "../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 7; /* subsf3 */

            case E_DFmode:
              if (pattern0 (x3, 
E_DFmode) != 0
                  || !
#line 405 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 8; /* subdf3 */

            case E_SImode:
              if (pattern0 (x3, 
E_SImode) != 0)
                return -1;
              return 9; /* *subsi3 */

            case E_DImode:
              if (pattern0 (x3, 
E_DImode) != 0
                  || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 10; /* *subdi3 */

            case E_V2DImode:
              if (pattern16 (x3, 
E_V2DImode) != 0
                  || !
#line 584 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 972; /* subv2di3 */

            case E_V4SImode:
              if (pattern16 (x3, 
E_V4SImode) != 0
                  || !
#line 584 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 973; /* subv4si3 */

            case E_V8HImode:
              if (pattern16 (x3, 
E_V8HImode) != 0
                  || !
#line 584 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 974; /* subv8hi3 */

            case E_V16QImode:
              if (pattern16 (x3, 
E_V16QImode) != 0
                  || !
#line 584 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 975; /* subv16qi3 */

            case E_V2DFmode:
              if (pattern0 (x3, 
E_V2DFmode) != 0
                  || !
#line 804 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1040; /* subv2df3 */

            case E_V4SFmode:
              if (pattern0 (x3, 
E_V4SFmode) != 0
                  || !
#line 804 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1041; /* subv4sf3 */

            case E_V4DImode:
              if (pattern16 (x3, 
E_V4DImode) != 0
                  || !
#line 708 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1574; /* subv4di3 */

            case E_V8SImode:
              if (pattern16 (x3, 
E_V8SImode) != 0
                  || !
#line 708 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1575; /* subv8si3 */

            case E_V16HImode:
              if (pattern16 (x3, 
E_V16HImode) != 0
                  || !
#line 708 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1576; /* subv16hi3 */

            case E_V32QImode:
              if (pattern16 (x3, 
E_V32QImode) != 0
                  || !
#line 708 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1577; /* subv32qi3 */

            case E_V4DFmode:
              if (pattern0 (x3, 
E_V4DFmode) != 0
                  || !
#line 945 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1642; /* subv4df3 */

            case E_V8SFmode:
              if (pattern0 (x3, 
E_V8SFmode) != 0
                  || !
#line 945 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1643; /* subv8sf3 */

            default:
              return -1;
            }

        case MULT:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern157 (x3, 
E_V2DImode) != 0
                  || !
#line 616 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 984; /* lsx_vmsub_d */

            case E_V4SImode:
              if (pattern157 (x3, 
E_V4SImode) != 0
                  || !
#line 616 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 985; /* lsx_vmsub_w */

            case E_V8HImode:
              if (pattern157 (x3, 
E_V8HImode) != 0
                  || !
#line 616 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 986; /* lsx_vmsub_h */

            case E_V16QImode:
              if (pattern157 (x3, 
E_V16QImode) != 0
                  || !
#line 616 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 987; /* lsx_vmsub_b */

            case E_V4DImode:
              if (pattern157 (x3, 
E_V4DImode) != 0
                  || !
#line 742 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1586; /* lasx_xvmsub_d */

            case E_V8SImode:
              if (pattern157 (x3, 
E_V8SImode) != 0
                  || !
#line 742 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1587; /* lasx_xvmsub_w */

            case E_V16HImode:
              if (pattern157 (x3, 
E_V16HImode) != 0
                  || !
#line 742 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1588; /* lasx_xvmsub_h */

            case E_V32QImode:
              if (pattern157 (x3, 
E_V32QImode) != 0
                  || !
#line 742 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1589; /* lasx_xvmsub_b */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern28 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 792; /* simd_subw_evod_v2di_s */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V2DImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 865; /* simd_hsubw_v2di_s */

        case 1:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 798; /* simd_subw_evod_v4si_s */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V4SImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 869; /* simd_hsubw_v4si_s */

        case 2:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 804; /* simd_subw_evod_v8hi_s */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V8HImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 873; /* simd_hsubw_v8hi_s */

        case 3:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 810; /* simd_subw_evod_v16qi_s */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V16QImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 877; /* simd_hsubw_v16qi_s */

        case 4:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 816; /* simd_subw_evod_v4di_s */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V4DImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 881; /* simd_hsubw_v4di_s */

        case 5:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 822; /* simd_subw_evod_v8si_s */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V8SImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 885; /* simd_hsubw_v8si_s */

        case 6:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 828; /* simd_subw_evod_v16hi_s */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V16HImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 889; /* simd_hsubw_v16hi_s */

        case 7:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 834; /* simd_subw_evod_v32qi_s */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V32QImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 893; /* simd_hsubw_v32qi_s */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern31 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 795; /* simd_subw_evod_v2di_u */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V2DImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 866; /* simd_hsubw_v2di_u */

        case 1:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 801; /* simd_subw_evod_v4si_u */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V4SImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 870; /* simd_hsubw_v4si_u */

        case 2:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 807; /* simd_subw_evod_v8hi_u */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V8HImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 874; /* simd_hsubw_v8hi_u */

        case 3:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 813; /* simd_subw_evod_v16qi_u */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V16QImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 878; /* simd_hsubw_v16qi_u */

        case 4:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 819; /* simd_subw_evod_v4di_u */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V4DImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 882; /* simd_hsubw_v4di_u */

        case 5:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 825; /* simd_subw_evod_v8si_u */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V8SImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 886; /* simd_hsubw_v8si_u */

        case 6:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 831; /* simd_subw_evod_v16hi_u */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V16HImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 890; /* simd_hsubw_v16hi_u */

        case 7:
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x8 = XEXP (x6, 1);
          if (rtx_equal_p (x8, operands[3])
              && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 837; /* simd_subw_evod_v32qi_u */
          operands[4] = x8;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V32QImode)
              || !(
#line 742 "../../gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 894; /* simd_hsubw_v32qi_u */

        case 8:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 840; /* simd_subw_evod_v2di_hetero */

        case 9:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 843; /* simd_subw_evod_v4si_hetero */

        case 10:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 846; /* simd_subw_evod_v8hi_hetero */

        case 11:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 849; /* simd_subw_evod_v16qi_hetero */

        case 12:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 852; /* simd_subw_evod_v4di_hetero */

        case 13:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 855; /* simd_subw_evod_v8si_hetero */

        case 14:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 858; /* simd_subw_evod_v16hi_hetero */

        case 15:
          if (!
#line 39 "../../gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 861; /* simd_subw_evod_v32qi_hetero */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern44 (x3, 
SMIN))
        {
        case 0:
          if (!
#line 926 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1064; /* sabdv2di3 */

        case 1:
          if (!
#line 926 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1066; /* sabdv4si3 */

        case 2:
          if (!
#line 926 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1068; /* sabdv8hi3 */

        case 3:
          if (!
#line 926 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1070; /* sabdv16qi3 */

        case 4:
          if (!
#line 1066 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1666; /* sabdv4di3 */

        case 5:
          if (!
#line 1066 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1668; /* sabdv8si3 */

        case 6:
          if (!
#line 1066 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1670; /* sabdv16hi3 */

        case 7:
          if (!
#line 1066 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1672; /* sabdv32qi3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern44 (x3, 
UMIN))
        {
        case 0:
          if (!
#line 926 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1065; /* uabdv2di3 */

        case 1:
          if (!
#line 926 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1067; /* uabdv4si3 */

        case 2:
          if (!
#line 926 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1069; /* uabdv8hi3 */

        case 3:
          if (!
#line 926 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1071; /* uabdv16qi3 */

        case 4:
          if (!
#line 1066 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1667; /* uabdv4di3 */

        case 5:
          if (!
#line 1066 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1669; /* uabdv8si3 */

        case 6:
          if (!
#line 1066 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1671; /* uabdv16hi3 */

        case 7:
          if (!
#line 1066 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1673; /* uabdv32qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern130 (x3, 
E_SImode) != 0)
            return -1;
          return 97; /* *xorsi3 */

        case E_DImode:
          if (pattern130 (x3, 
E_DImode) != 0
              || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 99; /* *xordi3 */

        case E_V2DImode:
          if (pattern131 (x3, 
E_V2DImode) != 0
              || !
#line 662 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1004; /* xorv2di3 */

        case E_V4SImode:
          if (pattern131 (x3, 
E_V4SImode) != 0
              || !
#line 662 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1005; /* xorv4si3 */

        case E_V8HImode:
          if (pattern131 (x3, 
E_V8HImode) != 0
              || !
#line 662 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1006; /* xorv8hi3 */

        case E_V16QImode:
          if (pattern131 (x3, 
E_V16QImode) != 0
              || !
#line 662 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1007; /* xorv16qi3 */

        case E_V2DFmode:
          if (pattern131 (x3, 
E_V2DFmode) != 0
              || !
#line 662 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1008; /* xorv2df3 */

        case E_V4SFmode:
          if (pattern131 (x3, 
E_V4SFmode) != 0
              || !
#line 662 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1009; /* xorv4sf3 */

        case E_V4DImode:
          if (pattern131 (x3, 
E_V4DImode) != 0
              || !
#line 800 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1606; /* xorv4di3 */

        case E_V8SImode:
          if (pattern131 (x3, 
E_V8SImode) != 0
              || !
#line 800 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1607; /* xorv8si3 */

        case E_V16HImode:
          if (pattern131 (x3, 
E_V16HImode) != 0
              || !
#line 800 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1608; /* xorv16hi3 */

        case E_V32QImode:
          if (pattern131 (x3, 
E_V32QImode) != 0
              || !
#line 800 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1609; /* xorv32qi3 */

        case E_V4DFmode:
          if (pattern131 (x3, 
E_V4DFmode) != 0
              || !
#line 800 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1610; /* xorv4df3 */

        case E_V8SFmode:
          if (pattern131 (x3, 
E_V8SFmode) != 0
              || !
#line 800 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1611; /* xorv8sf3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern22 (x3))
        {
        case 0:
          if (!
#line 1600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (SImode, operands)))
            return -1;
          return 106; /* *bstrins_si_for_ior_mask */

        case 1:
          if (!(
#line 1600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (DImode, operands)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 109; /* *bstrins_di_for_ior_mask */

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[2] = x6;
      if (const_int_operand (operands[2], E_SImode))
        {
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          switch (pattern89 (x3))
            {
            case 0:
              if ((
#line 3136 "../../gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !uns_arith_operand (operands[3], SImode))
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       SImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)))
                return 262; /* xor_shift_reversesi */
              break;

            case 1:
              if ((
#line 3136 "../../gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !uns_arith_operand (operands[3], DImode))
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       DImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return 265; /* xor_shift_reversedi */
              break;

            default:
              break;
            }
        }
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != LSHIFTRT)
        return -1;
      switch (pattern109 (x3))
        {
        case 0:
          if (!
#line 4296 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 418; /* *bytepick_d_1_rev */

        case 1:
          if (!
#line 4296 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 419; /* *bytepick_d_2_rev */

        case 2:
          if (!
#line 4296 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 420; /* *bytepick_d_3_rev */

        case 3:
          if (!
#line 4296 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 421; /* *bytepick_d_4_rev */

        case 4:
          if (!
#line 4296 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 422; /* *bytepick_d_5_rev */

        case 5:
          if (!
#line 4296 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 423; /* *bytepick_d_6_rev */

        case 6:
          if (!
#line 4296 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 424; /* *bytepick_d_7_rev */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern25 (x3))
        {
        case 0:
          return 381; /* *bytepick_w_1 */

        case 1:
          if (!
#line 4285 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 401; /* *bytepick_d_5 */

        case 2:
          return 382; /* *bytepick_w_2 */

        case 3:
          if (!
#line 4285 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 402; /* *bytepick_d_6 */

        case 4:
          return 383; /* *bytepick_w_3 */

        case 5:
          if (!
#line 4285 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 403; /* *bytepick_d_7 */

        case 6:
          if (!
#line 4285 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 397; /* *bytepick_d_1 */

        case 7:
          if (!
#line 4285 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 398; /* *bytepick_d_2 */

        case 8:
          if (!
#line 4285 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 399; /* *bytepick_d_3 */

        case 9:
          if (!
#line 4285 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 400; /* *bytepick_d_4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode)
          || !register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !
#line 1881 "../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 139; /* extendsfdf2 */

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XVECLEN (x5, 0))
        {
        case 2:
          switch (pattern41 (x3, 
E_V4SFmode, 
E_V2SFmode, 
E_V2DFmode))
            {
            case 0:
              if (!
#line 1824 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1285; /* vec_unpacks_hi_v4sf */

            case 1:
              if (!
#line 1844 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1287; /* vec_unpacks_lo_v4sf */

            default:
              return -1;
            }

        case 4:
          x7 = XVECEXP (x5, 0, 0);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x8) != CONST_INT)
            return -1;
          x9 = XVECEXP (x5, 0, 2);
          if (GET_CODE (x9) != CONST_INT)
            return -1;
          x10 = XVECEXP (x5, 0, 3);
          if (GET_CODE (x10) != CONST_INT
              || pattern37 (x3, 
E_V8SFmode, 
E_V4SFmode, 
E_V4DFmode) != 0)
            return -1;
          switch (XWINT (x7, 0))
            {
            case 2L:
              if (XWINT (x8, 0) != 3L
                  || XWINT (x9, 0) != 6L
                  || XWINT (x10, 0) != 7L
                  || !
#line 2237 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1894; /* lasx_xvfcvth_d_s */

            case 4L:
              if (XWINT (x8, 0) != 5L
                  || XWINT (x9, 0) != 6L
                  || XWINT (x10, 0) != 7L
                  || !
#line 2251 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1895; /* lasx_xvfcvth_d_insn */

            case 0L:
              if (XWINT (x8, 0) != 1L)
                return -1;
              switch (XWINT (x9, 0))
                {
                case 4L:
                  if (XWINT (x10, 0) != 5L
                      || !
#line 2275 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1897; /* lasx_xvfcvtl_d_s */

                case 2L:
                  if (XWINT (x10, 0) != 3L
                      || !
#line 2289 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1898; /* lasx_xvfcvtl_d_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_122 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern116 (x3))
        {
        case 0:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 298; /* *sltu_sisi */

        case 1:
          if (!
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 300; /* *sltu_disi */

        default:
          return -1;
        }

    case E_DImode:
      if (pattern4 (x3, 
E_DImode) != 0
          || !
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 302; /* *sltu_didi */

    case E_V2DImode:
      if (pattern16 (x3, 
E_V2DImode) != 0
          || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1121; /* lsx_vslt_du */

    case E_V4SImode:
      if (pattern16 (x3, 
E_V4SImode) != 0
          || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1126; /* lsx_vslt_wu */

    case E_V8HImode:
      if (pattern16 (x3, 
E_V8HImode) != 0
          || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1131; /* lsx_vslt_hu */

    case E_V16QImode:
      if (pattern16 (x3, 
E_V16QImode) != 0
          || !
#line 1090 "../../gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1136; /* lsx_vslt_bu */

    case E_V4DImode:
      if (pattern16 (x3, 
E_V4DImode) != 0
          || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1725; /* lasx_xvslt_du */

    case E_V8SImode:
      if (pattern16 (x3, 
E_V8SImode) != 0
          || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1730; /* lasx_xvslt_wu */

    case E_V16HImode:
      if (pattern16 (x3, 
E_V16HImode) != 0
          || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1735; /* lasx_xvslt_hu */

    case E_V32QImode:
      if (pattern16 (x3, 
E_V32QImode) != 0
          || !
#line 1200 "../../gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1740; /* lasx_xvslt_bu */

    default:
      return -1;
    }
}

 int
recog_129 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 271; /* bswaphi2 */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !
#line 3250 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 273; /* *bswapsi2 */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 3271 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 274; /* bswapdi2 */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern123 (x3) != 0
                  || !
#line 722 "../../gcc/config/loongarch/loongarch.md"
(CONST_INT_P (operands[2]) && !IMM12_INT (operands[2])    && !ADDU16I_OPERAND (INTVAL (operands[2]))))
                return NULL;
              return gen_split_1 (insn, operands);

            case E_DImode:
              if (pattern124 (x3) != 0
                  || !(
#line 769 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 778 "../../gcc/config/loongarch/loongarch.md"
( CONST_INT_P (operands[2]) && !IMM12_INT (operands[2])    && !ADDU16I_OPERAND (INTVAL (operands[2])))))
                return NULL;
              return gen_split_2 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern22 (x3))
            {
            case 0:
              if (!(
#line 1600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (SImode, operands)) && 
#line 1603 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_6 (insn, operands);

            case 1:
              if (!((
#line 1600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (DImode, operands)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 1603 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_9 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != PLUS
          || GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (register_operand (operands[1], E_SImode))
        {
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          if (plus_si_extend_operand (operands[2], E_SImode)
              && 
#line 801 "../../gcc/config/loongarch/loongarch.md"
(CONST_INT_P (operands[2]) && !IMM12_INT (operands[2])))
            return gen_split_3 (insn, operands);
        }
      if (GET_CODE (x6) != SUBREG
          || maybe_ne (SUBREG_BYTE (x6), 0)
          || GET_MODE (x6) != E_SImode)
        return NULL;
      x8 = XEXP (x6, 0);
      if (GET_MODE (x8) != E_DImode)
        return NULL;
      x7 = XEXP (x4, 1);
      operands[4] = x7;
      if (!register_operand (operands[4], E_SImode))
        return NULL;
      switch (GET_CODE (x8))
        {
        case AND:
          if (pattern212 (x8) != 0
              || !(
#line 3175 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && loongarch_reassoc_shift_bitwise (true, operands[2], operands[3],
				       SImode)) && 
#line 3179 "../../gcc/config/loongarch/loongarch.md"
( reload_completed)))
            return NULL;
          return gen_split_22 (insn, operands);

        case IOR:
          if (pattern212 (x8) != 0
              || !(
#line 3175 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       SImode)) && 
#line 3179 "../../gcc/config/loongarch/loongarch.md"
( reload_completed)))
            return NULL;
          return gen_split_23 (insn, operands);

        case XOR:
          if (pattern212 (x8) != 0
              || !(
#line 3175 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       SImode)) && 
#line 3179 "../../gcc/config/loongarch/loongarch.md"
( reload_completed)))
            return NULL;
          return gen_split_24 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case AND:
          switch (pattern22 (x3))
            {
            case 0:
              if (!(
#line 1600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (SImode, operands)) && 
#line 1603 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_4 (insn, operands);

            case 1:
              if (!((
#line 1600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (DImode, operands)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 1603 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_7 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern90 (x3))
            {
            case 0:
              if (!((
#line 3136 "../../gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !uns_arith_operand (operands[3], SImode))
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       SImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 3141 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_17 (insn, operands);

            case 1:
              if (!((
#line 3136 "../../gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !uns_arith_operand (operands[3], DImode))
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       DImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 3141 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_20 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case XOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case AND:
          switch (pattern22 (x3))
            {
            case 0:
              if (!(
#line 1600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (SImode, operands)) && 
#line 1603 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_5 (insn, operands);

            case 1:
              if (!((
#line 1600 "../../gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (DImode, operands)) && 
#line 375 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 1603 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_8 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern90 (x3))
            {
            case 0:
              if (!((
#line 3136 "../../gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !uns_arith_operand (operands[3], SImode))
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       SImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 3141 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_18 (insn, operands);

            case 1:
              if (!((
#line 3136 "../../gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !uns_arith_operand (operands[3], DImode))
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       DImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 3141 "../../gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_21 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !(
#line 1766 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 1772 "../../gcc/config/loongarch/loongarch.md"
( reload_completed
   && MEM_P (operands[1])
   && (loongarch_14bit_shifted_offset_address_p (XEXP (operands[1], 0), SImode)
       && !loongarch_12bit_offset_address_p (XEXP (operands[1], 0), SImode))
   && !paradoxical_subreg_p (operands[0]))))
        return NULL;
      return gen_split_10 (insn, operands);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !move_operand (operands[1], E_DImode)
              || !
#line 2198 "../../gcc/config/loongarch/loongarch.md"
(CONST_INT_P (operands[1]) && REG_P (operands[0]) && GP_REG_P (REGNO
  (operands[0]))))
            return NULL;
          return gen_split_11 (insn, operands);

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !move_operand (operands[1], E_SImode)
              || !
#line 2306 "../../gcc/config/loongarch/loongarch.md"
(CONST_INT_P (operands[1]) && REG_P (operands[0]) && GP_REG_P (REGNO
  (operands[0]))))
            return NULL;
          return gen_split_14 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || !move_operand (operands[1], E_HImode)
              || !
#line 2340 "../../gcc/config/loongarch/loongarch.md"
(CONST_INT_P (operands[1]) && REG_P (operands[0]) && GP_REG_P (REGNO
  (operands[0]))))
            return NULL;
          return gen_split_15 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != ASHIFT)
        return NULL;
      switch (pattern90 (x3))
        {
        case 0:
          if (!((
#line 3136 "../../gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !and_operand (operands[3], SImode))
   && loongarch_reassoc_shift_bitwise (true, operands[2], operands[3],
				       SImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 3141 "../../gcc/config/loongarch/loongarch.md"
( true)))
            return NULL;
          return gen_split_16 (insn, operands);

        case 1:
          if (!((
#line 3136 "../../gcc/config/loongarch/loongarch.md"
((const_immalsl_operand (operands[2], SImode)
    || !and_operand (operands[3], DImode))
   && loongarch_reassoc_shift_bitwise (true, operands[2], operands[3],
				       DImode)) && 
#line 389 "../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 3141 "../../gcc/config/loongarch/loongarch.md"
( true)))
            return NULL;
          return gen_split_19 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
